function ret_value_hys = autoprox_has_hysdel

% Checks, whether Hysdel has been installed

% Copyright is with the following author(s):
%
% (C) 2010 Alexander Szucs, Slovak University of Technology in Bratislava
%          alexander.szucs@stuba.sk
% (C) 2010 Michal Kvasnica, Slovak University of Technology in Bratislava
%          michal.kvasnica@stuba.sk

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------

if(exist('hysdel') ~= 2)
    warning('Hysdel has not been installed. You can download it from the following link: http://control.ee.ethz.ch/~hybrid/hysdel/hysdel.php');
    warning('In case of ignoring the abovementioned warning not every feature will works listed in the documentation');
    warning('Hysdel compiler is responsible for converting the automatically generated hys file to the corresponding m- and sim-files');
    warning('These files serve for investigation of the dynamical properties of the given hybrid system, so installing of the Hysdel compiler is highly recommended.');
    ret_value_hys = 0;
else
    ret_value_hys = 1;
end
