close all

% checking the existence of the required features
[ret_value_fm,ret_value_s]=autoprox_have_fmincon_and_sym;

syms z

%----------------------------------------------------------------------

% approximate the function z^3 by 3 segments
f1_var = z;
f1 = abs(z) + 0.5*z^2 - sin(z^3); 
f1_f = matlabFunction(f1);
f1_bounds = [-1, 2.5];
f1_segments = 7;
[f1_aprx,f1_aprx_data] = autoprox_1d(f1, f1_var, f1_bounds, f1_segments);

%%% checking whether HYSDEL has already installed
ret_value_hys = autoprox_has_hysdel;
if ret_value_hys
    % export the approximation to a HYSDEL file
    hysdel_1d(f1_aprx_data, 'f1_aprx.hys');
    
    % generation of the sim file
    hysdel('f1_aprx.hys','f1_aprx.sim');
end

% plot the original function and its approximation
figure
x1 = linspace(f1_bounds(1), f1_bounds(2), 100);
plot(x1, f1_f(x1), 'b', x1, f1_aprx(x1), 'r--', 'linewidth', 2);
legend(char(f1), 'Approximation', 'Location', 'Best');

%----------------------------------------------------------------------

% approximate the function abs(z) + 0.5*z^2 - sin(z^3) by 7 segments
f2_var = z;
f2 = abs(z) + 0.5*z^2 - sin(z^3); 
f2_f = matlabFunction(f2);
f2_bounds = [-1, 2.5];
f2_segments = 7;
[f2_aprx, f2_aprx_data] = autoprox_1d(f2, f2_var, f2_bounds, f2_segments);

%%% checking whether HYSDEL has already installed
ret_value_hys = autoprox_has_hysdel;
if ret_value_hys
    % export the approximation to a HYSDEL file
    hysdel_1d(f2_aprx_data, 'f2_aprx.hys');
    
    % generation of the sim file
    hysdel('f2_aprx.hys','f2_aprx.sim');
end

% plot the original function and its approximation
figure
x2 = linspace(f2_bounds(1), f2_bounds(2), 100);
plot(x2, f2_f(x2), 'b', x2, f2_aprx(x2), 'r--', 'linewidth', 2);
legend(char(f2), 'Approximation', 'Location', 'Best');









