syms ca v vc qc

% checking the existence of the required features
[ret_value_fm,ret_value_s]=autoprox_have_fmincon_and_sym;

%%% data storage for states and the inputs %%%
vars_state = [ca v vc];
vars_input = [qc];

%%% right sides of the differential equations %%%

right_side{1} = '0.2752-0.0052*ca*exp(-v)-v*ca';
right_side{2} = '2.5-0.05*v*ca+0.005*v+0.00685*vc';
right_side{3} = '0.25*qc*vc + 0.0685*qc-0.275*vc';

%%% nunmber of approximation points %%%

Nlinx_1 = [2 2];
Nlinu_1 = [2 2];

Nlinx_2 = [2 2];
Nlinu_2 = [2 2];

Nlinx_3 = [2 2];
Nlinu_3 = [2 2];

Nlinx_4 = [2 2];
Nlin_u4 = [2 2];

Nlinx_1 = {Nlinx_1 Nlinx_2 Nlinx_3 Nlinx_4};
Nlinu_1 = {Nlinu_1 Nlinu_2 Nlinu_3 Nlin_u4};

%%% bounds for each variable %%%
%%% states %%%
xbmin = [-2 -1 -1];
xbmax = [2 500 3];

%%% inputs %%%
umin1 = -4;
umax1 = 4;

%%% sampling Time %%%
Ts = 2;

apprx_data = autoprox_deq(vars_state,vars_input,xbmin,xbmax,Nlinx_1,Nlinu_1,umin1,umax1,right_side,Ts)

% generate the corresponding HYSDEL file
hysdel_nd_sum(apprx_data, 'diffeq_aprx.hys',apprx_data{end}); 

% compile the HYSDEL file to obtain a simulator
hysdel('diffeq_aprx.hys', 'diffeq_aprx_sim.m','-5');

% obtain values of f_aprx() for a given input data

% x_data = [1;0.1;2];
% u_data = [2];
%[x,d,z,y] = diffeq_aprx_sim(x_data,u_data);

% --------------------- simulation ------------------------- %

%N - number of simulation steps









