clear

% checking the existence of the required features
[ret_value_fm,ret_value_s]=autoprox_have_fmincon_and_sym;

syms z1 z2 z3

% vector of symbolic variobles involved in the function
vars = [z1 z2 z3];

% vector of symbolic variobles involved in the function
fun = 'sin(z1)*cos(z2)*abs(z3)';

% bounds for each variable
xbmin = [-1 -1 -1];
xbmax = [1 1 1];

% number of approximation points
Nlin_x = [2 2 2];
Nlin_u = [2 2 2 2];

% obtain the approximation data
apprx_data = autoprox_nd(fun,vars,xbmin,xbmax,Nlin_x,Nlin_u);

% generate the corresponding HYSDEL file
hysdel_nd(apprx_data,'FN_aprx.hys'); 

% compile the HYSDEL file to obtain a simulator
hysdel('FN_aprx.hys','FN_aprx_sim.m');

% obtain values of f_aprx() for a given input data
z_data = [1; 0.1; 0.8];
[x,d,z,y] = FN_aprx_sim([], z_data);
y
