clear

% checking the existence of the required features
[ret_value_fm,ret_value_s]=autoprox_have_fmincon_and_sym;

syms z1 z2 z3 z4 z5 z6 

% the symbolic function as a string
fun = 'sin(z1)*z2*z6+z1*log(z3)*z4*sin(z5)+cos(z3)*z4*abs(z5)*cos(z6)';

% vector of symbolic variobles involved in the function
vars = [z1 z2 z3 z4 z5 z6];

% bounds for each variable
xbmin = [-1.5 -1.5 1.5 -1.5 -1.5 -1.5];
xbmax = [1.5 1.5 2.5 1.5 1.5 1.5];

% number of approximation points
Nlin_x1 = [4 2 3];
Nlin_u1 = [3 5 4 2];

Nlin_x2 = [2 4 3 2];
Nlin_u2 = [2 5 2 4 3 3];

Nlin_x3 = [2 4 5 3];
Nlin_u3 = [4 2 2 3 4 3];

Nlin_x = {Nlin_x1 Nlin_x2 Nlin_x3};
Nlin_u = {Nlin_u1 Nlin_u2 Nlin_u3};

% obtain the approximation data
apprx_data = autoprox_nd_sum(fun,vars,xbmin,xbmax,Nlin_x,Nlin_u); 
           
% generate the corresponding HYSDEL file
hysdel_nd_sum(apprx_data, 'FNsum_aprx.hys'); 

% compile the HYSDEL file to obtain a simulator
hysdel('FNsum_aprx.hys', 'FNsum_aprx_sim.m');

% obtain values of f_aprx() for a given input data
z_data = [1; 0.1; 2; 0; 0; 0];
[x,d,z,y] = FNsum_aprx_sim([], z_data);
y
