function hysdel_nd_sum(main_datas,fname,sub_funs_de)
% Converts the PWA approximation of a sum of functions of N variable into HYSDEL

% Copyright is with the following author(s):
%
% (C) 2010 Alexander Szucs, Slovak University of Technology in Bratislava
%          alexander.szucs@stuba.sk
% (C) 2010 Michal Kvasnica, Slovak University of Technology in Bratislava
%          michal.kvasnica@stuba.sk

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------

fw = fopen(fname,'w');

if(nargin < 3)
   L = main_datas{end};
   functions = cell(1,length(L));
   f_sum = cell(1,length(functions));
   for i = 1:length(functions)
       functions{i} = L{i};
   end
else
   sub_funs_de1 = sub_funs_de{1};
   functions = sub_funs_de{2}{1}; 
   f_sum = cell(1,length(functions)); 
end

count = 1;

xfmain1 = cell(1,length(functions));
xumain1 = cell(1,length(functions));
a_main1 = cell(1,length(functions));
c_main1 = cell(1,length(functions));
r_main1 = cell(1,length(functions));
au_main1 = cell(1,length(functions));
cu_main1 = cell(1,length(functions));
ru_main1 = cell(1,length(functions));

for k = 1:length(functions)
    Nlin_x{k} = main_datas{1}{5}{k};
    xfmain1{k} = cell(1,length(Nlin_x{k}));
    if(length(Nlin_x{k}) > 1)
        for n = 1:length(Nlin_x{k})
            xfmain1{k}{n} = main_datas{k}{2}{n};
        end
    else
            xfmain1{k}{1} = main_datas{k}{2};
    end
    temp = cat(1,xfmain1{k}{:});
    a_main1{k} = temp(:,2);
    c_main1{k} = temp(:,3);
    r_main1{k} = temp(:,1);
    r_temp = isinf(r_main1{k});
    r_pos = find(r_temp ~= 1);
    r_main1{k} = r_main1{k}(r_pos);
        
    if(length(Nlin_x{k}) > 1)
    Nlin_u{k} = main_datas{1}{6}{k};    
    xumain1{k} = cell(1,length(Nlin_u{k}));    
        for m = 1:length(Nlin_u{k})  
            xumain1{k}{m} = main_datas{k}{4}{m};
        end
    temp1 = cat(1,xumain1{k}{:});
    au_main1{k} = temp1(:,2);
    cu_main1{k} = temp1(:,3);
    ru_main1{k} = temp1(:,1);
    ru_temp = isinf(ru_main1{k});
    ru_pos = find(ru_temp ~= 1);
    ru_main1{k} = ru_main1{k}(ru_pos);
    end
end

fprintf(fw,'SYSTEM f_approx1x2Nsum {');
fprintf(fw,'\n\t\t');
fprintf(fw,'INTERFACE {');

if(nargin < 3)

fprintf(fw,'\n\t\t\t');
fprintf(fw,'INPUT { ');

for i = 1 : length(main_datas{end-1}{1})
    fprintf(fw,'REAL ');
    fprintf(fw,'%s ',char(main_datas{end-2}{i}));
    fprintf(fw,'[');    
    fprintf(fw,'%.4f',main_datas{end-1}{1}(i));
    fprintf(fw,', ');
    fprintf(fw,'%.4f',main_datas{end-1}{2}(i));
    fprintf(fw,'];');
    fprintf(fw,'\n\t\t\t\t    ');
end
fprintf(fw,'}');

else
    
fprintf(fw,'\n\t\t\t');
fprintf(fw,'INPUT { ');

for i = 1 : length(main_datas{end-1}{3})
    fprintf(fw,'REAL ');
    fprintf(fw,'%s ',char(main_datas{end-2}{2}(i)));
    fprintf(fw,'[');    
    fprintf(fw,'%.4f',main_datas{end-1}{3}(i));
    fprintf(fw,', ');
    fprintf(fw,'%.4f',main_datas{end-1}{4}(i));
    fprintf(fw,'];');
    fprintf(fw,'\n\t\t\t\t    ');
end
fprintf(fw,'}'); 

fprintf(fw,'\n\t\t\t');
fprintf(fw,'STATE { ');

for i = 1:length(main_datas{end-1}{1})
    fprintf(fw,'REAL ');
    fprintf(fw,'%s ',char(main_datas{end-2}{1}(i)));
    fprintf(fw,'[');    
    fprintf(fw,'%.4f',main_datas{end-1}{1}(i));
    fprintf(fw,', ');
    fprintf(fw,'%.4f',main_datas{end-1}{2}(i));
    fprintf(fw,'];');
    fprintf(fw,'\n\t\t\t\t    ');
end  
fprintf(fw,'}');

end

fprintf(fw,'\n\t\t\t');
if(nargin < 3)
    fprintf(fw,'OUTPUT {');
    fprintf(fw,'REAL PWA_apprx; }');
end

fprintf(fw,'\n\t\t\t');
fprintf(fw,'PARAMETER {');

if(nargin == 3)   
   fprintf(fw,'\n\t\t\t');
   fprintf(fw,'/* Sampling Time */');
   fprintf(fw,'\n\t\t\t');
   fprintf(fw,'REAL Ts = '); 
   fprintf(fw,'%.4f',main_datas{end}{3});
   fprintf(fw,';');
end

for foi = 1:length(functions)  
    
subscript = num2str(foi);    
    
xfmain = xfmain1{foi};
a_main = a_main1{foi};
c_main = c_main1{foi};
r_main = r_main1{foi};

xfmain_size = [];
for i1 = 1:length(xfmain)
    xfmain_size = [xfmain_size size(xfmain{i1},1)];
end

xf1 = xfmain{1};
if(length(xfmain_size) > 1)
    xf2 = xfmain{2};
end

xumain = xumain1{foi};
au_main = au_main1{foi};
cu_main = cu_main1{foi};
ru_main = ru_main1{foi};

xumain_size = [];
for i2 = 1:length(xumain)
    xumain_size = [xumain_size size(xumain{i2},1)];
end

if(length(xumain_size)>1)
   xu1 = xumain{1};
   xu2 = xumain{2};
end

if(length(xfmain_size) == 1)
    
    a_values1 = a_main;
    b_values1 = c_main;
    r_values1 = r_main;
      
    xf = xf1;
  
    a = {};
    b = {};
        for i = 1:size(xf,1)
            j = num2str(i);
            a{i} = strcat('PWA',subscript);
            a{i} = strcat(a{i},'_a');
            a{i} = strcat(a{i},j);
            b{i} = strcat('PWA',subscript);
            b{i} = strcat(b{i},'_b');
            b{i} = strcat(b{i},j);
        end
    r = {};
        for i = 1:size(xf,1)-1
            j = num2str(i);
            r{i} = strcat('r',j);
            r{i} = strcat('PWA',subscript);
            r{i} = strcat(r{i},'_r');
            r{i} = strcat(r{i},j);
        end

    for i = 1:size(xf,1)
        fprintf(fw,' REAL ');
        fprintf(fw,'%c',char(a(i)));
        fprintf(fw,' = ');
        fprintf(fw,'%.4f',a_values1(i));
        fprintf(fw,';');
        fprintf(fw,'\n');
        fprintf(fw,'\t\t\t\t\t   ');
    end
    
    for i = 1:size(xf,1)
        fprintf(fw,' REAL ');
        fprintf(fw,'%c',char(b(i)));
        fprintf(fw,' = ');
        fprintf(fw,'%.4f',b_values1(i));
        fprintf(fw,';');
        fprintf(fw,'\n');
        fprintf(fw,'\t\t\t\t\t   ');
    end

    for i = 1:size(xf,1)-1
        fprintf(fw,' REAL ');
        fprintf(fw,'%c',char(r(i)));
        fprintf(fw,' = ');
        fprintf(fw,'%.4f',r_values1(i));
        fprintf(fw,';');
        fprintf(fw,'\n');
        fprintf(fw,'\t\t\t\t\t   ');
    end
      
end  

if(length(xfmain_size) > 1)

%%% first function %%%

a = cell(1,length(xfmain_size));
c = cell(1,length(xfmain_size));
r = cell(1,length(xfmain_size));
index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)
            j = num2str(i);
            sub = num2str(index);
            a{k}{i} = strcat('PWA',subscript);
            a{k}{i} = strcat(a{k}{i},'_a');
            a{k}{i} = strcat(a{k}{i},sub);
            temp11a = a{k}{i};
            a{k}{i} = strcat(temp11a,'_');
            temp12a = a{k}{i};
            a{k}{i} = strcat(temp12a,j); 
            c{k}{i} = strcat('PWA',subscript);
            c{k}{i} = strcat(c{k}{i},'_c');
            c{k}{i} = strcat(c{k}{i},sub);
            temp11b = c{k}{i};
            c{k}{i} = strcat(temp11b,'_');
            temp12b = c{k}{i};
            c{k}{i} = strcat(temp12b,j);
            if(i < xfmain_size(k))
               r{k}{i} = strcat('PWA',subscript);
               r{k}{i} = strcat(r{k}{i},'_r');
               r{k}{i} = strcat(r{k}{i},sub); 
               temp11r = r{k}{i};
               r{k}{i} = strcat(temp11r,'_');
               temp12r = r{k}{i};
               r{k}{i} = strcat(temp12r,j);
            end
        end
        index = index+1;
    end
    fprintf(fw,'\n\t\t\t');
    
    count = count + 1;
    
    index_a = 0;
    index_c = 0;
    index_r = 0;
    index = 1;
    for k = 1:length(xfmain_size)
        fprintf(fw,'/*approximation parameters of the %d.function */',index);
        fprintf(fw,'\n\t\t\t');
        fprintf(fw,'REAL ');
        for i = 1:xfmain_size(k)
            fprintf(fw,'%s',char(a{k}{i}));
            fprintf(fw,' = ');
            fprintf(fw,'%.4f',a_main(index_a+1));
            if(i ~= xfmain_size(k))
               fprintf(fw,', ');
            end
            index_a = index_a+1; 
        end
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t');
        fprintf(fw,'REAL ');
        for i = 1:xfmain_size(k)
            fprintf(fw,'%s',char(c{k}{i}));
            fprintf(fw,' = ');
            fprintf(fw,'%.4f',c_main(index_c+1));
            if(i ~= xfmain_size(k))
               fprintf(fw,', ');
            end
            index_c = index_c+1;
        end
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t');
        fprintf(fw,'REAL ');
        for i = 1:xfmain_size(k)-1
            fprintf(fw,'%s',char(r{k}{i}));
            fprintf(fw,' = ');
            fprintf(fw,'%.4f',r_main(index_r+1));
            if(i ~= xfmain_size(k)-1)
               fprintf(fw,', ');
            end
            index_r = index_r+1;
        end        
        fprintf(fw,';');
        fprintf(fw,'\n\n\t\t\t ');
        index = index+1;
    end  

%%%%% parameters for the functions fu1 and fu2 %%%%%%

au = cell(1,2*(length(xfmain_size)-1));
cu = cell(1,2*(length(xfmain_size)-1));
ru = cell(1,2*(length(xfmain_size)-1));
index = 1;
    for k = 1:length(au)
        for i = 1:xumain_size(k)
            j = num2str(i);
            sub = num2str(index);
            au{k}{i} = strcat('PWA',subscript);
            au{k}{i} = strcat(au{k}{i},'_au');
            au{k}{i} = strcat(au{k}{i},sub); 
            temp11a = au{k}{i};
            au{k}{i} = strcat(temp11a,'_');
            temp12a = au{k}{i};
            au{k}{i} = strcat(temp12a,j);
            cu{k}{i} = strcat('PWA',subscript);
            cu{k}{i} = strcat(cu{k}{i},'_cu');
            cu{k}{i} = strcat(cu{k}{i},sub);
            temp11b = cu{k}{i};
            cu{k}{i} = strcat(temp11b,'_');
            temp12b = cu{k}{i};
            cu{k}{i} = strcat(temp12b,j);
            if(i < xumain_size(k))
               ru{k}{i} = strcat('PWA',subscript);
               ru{k}{i} = strcat(ru{k}{i},'_ru');
               ru{k}{i} = strcat(ru{k}{i},sub);
               temp11r = ru{k}{i};
               ru{k}{i} = strcat(temp11r,'_');
               temp12r = ru{k}{i};
               ru{k}{i} = strcat(temp12r,j);
            end
        end
        index = index+1;
    end
    fprintf(fw,'\n\t\t\t');
        
    index_au = 0;
    index_cu = 0;
    index_ru = 0;
    index = 1;
    for k = 1:length(au)
        fprintf(fw,'/*approximation parameters of the %d.function u1^2 */',index);
        fprintf(fw,'\n\t\t\t');
        fprintf(fw,'REAL ');
        for i = 1:xumain_size(k)
            fprintf(fw,'%s',char(au{k}{i}));
            fprintf(fw,' = ');
            fprintf(fw,'%.4f',au_main(index_au+1));
            if(i ~= xumain_size(k))
               fprintf(fw,', ');
            end
            index_au = index_au+1;
        end
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t');
        fprintf(fw,'REAL ');
        for i = 1:xumain_size(k)
            fprintf(fw,'%s',char(cu{k}{i}));
            fprintf(fw,' = ');
            fprintf(fw,'%.4f',cu_main(index_cu+1));
            if(i ~= xumain_size(k))
               fprintf(fw,', ');
            end
            index_cu = index_cu+1;
        end
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t');
        fprintf(fw,'REAL ');
        for i = 1:xumain_size(k)-1
            fprintf(fw,'%s',char(ru{k}{i}));
            fprintf(fw,' = ');
            fprintf(fw,'%.4f',ru_main(index_ru+1));
            if(i ~= xumain_size(k)-1)
               fprintf(fw,', ');
            end
            index_ru = index_ru+1; 
        end        
        fprintf(fw,';');
        fprintf(fw,'\n\n\t\t\t');
        index = index+1;
    end    
%     fprintf(fw,'\n');
    
    end
    
end
fprintf(fw,'}');
fprintf(fw,'\n\t\t');
fprintf(fw,'}');
fprintf(fw,'\n\t\t');
fprintf(fw,'IMPLEMENTATION {');

%%% logical switchers %%%   

fprintf(fw,'\n\t\t\t AUX {');

for foi = 1:length(functions)
       
subscript1 = num2str(foi);    
    
xfmain = xfmain1{foi};
a_main = a_main1{foi};
c_main = c_main1{foi};
r_main = r_main1{foi};

xfmain_size = [];
for i1 = 1:length(xfmain)
    xfmain_size = [xfmain_size size(xfmain{i1},1)];
end

xf1 = xfmain{1};
if(length(xfmain_size) > 1)
    xf2 = xfmain{2};
end

xumain = xumain1{foi};
au_main = au_main1{foi};
cu_main = cu_main1{foi};
ru_main = ru_main1{foi};

xumain_size = [];
for i2 = 1:length(xumain)
    xumain_size = [xumain_size size(xumain{i2},1)];
end

if(length(xumain_size)>1)
   xu1 = xumain{1};
   xu2 = xumain{2};
end    
    
if(length(xfmain_size) == 1)
    a_values1 = a_main;
    b_values1 = c_main;
    r_values1 = r_main;
    
    fc1 = {};
    
    fc1 = strcat('PWA',subscript1);
    fc1 = strcat(fc1,'_fc');
    
    a = {};
    b = {};
        for i = 1:size(xf,1)
            j = num2str(i);
            a{i} = strcat('PWA',subscript1);
            a{i} = strcat(a{i},'_a');
            a{i} = strcat(a{i},j);
            b{i} = strcat('PWA',subscript1);
            b{i} = strcat(b{i},'_b');
            b{i} = strcat(b{i},j);
        end
    r = {};
        for i = 1:size(xf,1)-1
            j = num2str(i);
            r{i} = strcat('PWA',subscript1);
            r{i} = strcat(r{i},'_r');
            r{i} = strcat(r{i},j);
        end
    
    fprintf(fw,'\n\t\t\t ');
    fprintf(fw,'/*threshold detectors */');
    fprintf(fw,'\n\t\t\t ');
    fprintf(fw,'BOOL ');

    d = {};
        for i = 1:size(xf,1)-1
            j = num2str(i);
            d{i} = strcat('PWA',subscript1);
            d{i} = strcat(d{i},'_d');
            d{i} = strcat(d{i},j);
        end

    f = {};

        for i = 1:size(xf,1)
            j = num2str(i);
            f{i} = strcat('PWA',subscript1);
            f{i} = strcat(f{i},'_f');
            f{i} = strcat(f{i},j);
        end
        f{i+1} = fc1;
   
    for i = 1:size(xf,1)-1
        fprintf(fw,'%c',char(d(i)));
        if(i ~= size(xf,1)-1)
            fprintf(fw,',');
        end
    end
    fprintf(fw,';');
    
    fprintf(fw,'\n\t\t\t REAL ');

    for i = 1:size(xf,1)+1
        fprintf(fw,'%c',char(f(i)));
        if(i ~= size(xf,1)+1)
            fprintf(fw,',');
        end
    end
    
end
    
    
if(length(xfmain_size) > 1)    

fprintf(fw,'\n\t\t\t ');
fprintf(fw,'/*threshold detectors */');
fprintf(fw,'\n\t\t\t ');
fprintf(fw,'BOOL ');

for i = 1:length(xfmain_size)
    j = num2str(i);
    x{i} = strcat('x',j);
    temp11a = x{i};
    f_f{i} = strcat('f',j);
    temp11b = f_f{i};
    if(i ~= length(xfmain_size))
        f_f{i} = strcat(temp11b,'_');
    end
end

a = cell(1,length(xfmain_size));
c = cell(1,length(xfmain_size));
r = cell(1,length(xfmain_size));
index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)
            j = num2str(i);
            sub = num2str(index);
            a{k}{i} = strcat('PWA',subscript1);
            a{k}{i} = strcat(a{k}{i},'_a');
            a{k}{i} = strcat(a{k}{i},sub);
            temp11a = a{k}{i};
            a{k}{i} = strcat(temp11a,'_');
            temp12a = a{k}{i};
            a{k}{i} = strcat(temp12a,j); 
            c{k}{i} = strcat('PWA',subscript1);
            c{k}{i} = strcat(c{k}{i},'_c');
            c{k}{i} = strcat(c{k}{i},sub);
            temp11b = c{k}{i};
            c{k}{i} = strcat(temp11b,'_');
            temp12b = c{k}{i};
            c{k}{i} = strcat(temp12b,j);
            if(i < xfmain_size(k))
               r{k}{i} = strcat('PWA',subscript1);
               r{k}{i} = strcat(r{k}{i},'_r');
               r{k}{i} = strcat(r{k}{i},sub); 
               temp11r = r{k}{i};
               r{k}{i} = strcat(temp11r,'_');
               temp12r = r{k}{i};
               r{k}{i} = strcat(temp12r,j);
            end
        end
        index = index+1;
    end
   

%%%%% parameters for the functions fu1 and fu2 %%%%%%

au = cell(1,2*(length(xfmain_size)-1));
cu = cell(1,2*(length(xfmain_size)-1));
ru = cell(1,2*(length(xfmain_size)-1));
index = 1;
    for k = 1:length(au)
        for i = 1:xumain_size(k)
            j = num2str(i);
            sub = num2str(index);
            au{k}{i} = strcat('PWA',subscript1);
            au{k}{i} = strcat(au{k}{i},'_au');
            au{k}{i} = strcat(au{k}{i},sub); 
            temp11a = au{k}{i};
            au{k}{i} = strcat(temp11a,'_');
            temp12a = au{k}{i};
            au{k}{i} = strcat(temp12a,j);
            cu{k}{i} = strcat('PWA',subscript1);
            cu{k}{i} = strcat(cu{k}{i},'_cu');
            cu{k}{i} = strcat(cu{k}{i},sub);
            temp11b = cu{k}{i};
            cu{k}{i} = strcat(temp11b,'_');
            temp12b = cu{k}{i};
            cu{k}{i} = strcat(temp12b,j);
            if(i < xumain_size(k))
               ru{k}{i} = strcat('PWA',subscript1);
               ru{k}{i} = strcat(ru{k}{i},'_ru');
               ru{k}{i} = strcat(ru{k}{i},sub);
               temp11r = ru{k}{i};
               ru{k}{i} = strcat(temp11r,'_');
               temp12r = ru{k}{i};
               ru{k}{i} = strcat(temp12r,j);
            end
        end
        index = index+1;
    end


d = cell(1,length((xfmain_size-1)));
index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)-1
            j = num2str(i);
            sub = num2str(index);
            d{k}{i} = strcat('PWA',subscript1);
            d{k}{i} = strcat(d{k}{i},'_d');
            d{k}{i} = strcat(d{k}{i},sub);
            temp11a = d{k}{i};
            d{k}{i} = strcat(temp11a,'_');
            temp12a = d{k}{i};
            d{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
    fprintf(fw,'');
        
    index_d = 0;
    index = 1;
    counter = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)-1
            fprintf(fw,'%s',char(d{k}{i}));
            if(counter ~= sum(xfmain_size)-length(xfmain_size))
               fprintf(fw,', ');
               index_d = index_d+1;
               counter = counter + 1;
            end
        end
        index = index+1;
    end        
   
    du = cell(1,2*(length(xfmain_size)-1));
    index = 1;
    for k = 1:2*(length(xfmain_size)-1)
        for i = 1:xumain_size(k)-1
            j = num2str(i);
            sub = num2str(index);
            du{k}{i} = strcat('PWA',subscript1);
            du{k}{i} = strcat(du{k}{i},'_du');
            du{k}{i} = strcat(du{k}{i},sub);
            temp11a = du{k}{i};
            du{k}{i} = strcat(temp11a,'_');
            temp12a = du{k}{i};
            du{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
    fprintf(fw,';');
    index_du = 0;
    index = 1;
    counter = 1;
    fprintf(fw,'\n\t\t\t BOOL ');
    for k = 1:2*(length(xfmain_size)-1)
        for i = 1:xumain_size(k)-1
            fprintf(fw,'%s',char(du{k}{i}));
            if(counter ~= sum(xumain_size)-length(xumain_size))
               fprintf(fw,', ');
               index_du = index_du+1;
            end
            counter = counter + 1;
        end
        index = index+1;
    end     
    fprintf(fw,';');
     
    
%%%% auxiliary variables for original functions %%%%

fprintf(fw,'\n\t\t\t');
fprintf(fw,' /*auxiliary variables */');
fprintf(fw,'\n\t\t\t REAL ');

f = cell(1,length(xfmain_size));
    index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)
            j = num2str(i);
            sub = num2str(index);
            f{k}{i} = strcat('PWA',subscript1);
            f{k}{i} = strcat(f{k}{i},'_f');
            f{k}{i} = strcat(f{k}{i},sub);
            temp11a = f{k}{i};
            f{k}{i} = strcat(temp11a,'_');
            temp12a = f{k}{i};
            f{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
    index_f = 0;
    index = 1;
    counter = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)
            fprintf(fw,'%s',char(f{k}{i}));
            if(counter ~= sum(xfmain_size))
               fprintf(fw,', ');
               index_f = index_f+1;
            end
            counter = counter + 1;
        end
        index = index+1;
    end        
    fprintf(fw,';');
   
%%%% auxiliary variables for u1^2 u2^2 .... %%%%

fprintf(fw,'\n\t\t\t REAL ');

fu = cell(1,2*(length(xfmain_size)-1));
    index = 1;
    for k = 1:2*(length(xfmain_size)-1)
        for i = 1:xumain_size(k)
            j = num2str(i);
            sub = num2str(index);
            fu{k}{i} = strcat('PWA',subscript1);
            fu{k}{i} = strcat(fu{k}{i},'_fu');
            fu{k}{i} = strcat(fu{k}{i},sub);
            temp11a = fu{k}{i};
            fu{k}{i} = strcat(temp11a,'_');
            temp12a = fu{k}{i};
            fu{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
    index_fu = 0;
    index = 1;
    counter = 1;
    for k = 1:2*(length(xfmain_size)-1)
        for i = 1:xumain_size(k)
            fprintf(fw,'%s',char(fu{k}{i}));
            if(counter ~= sum(xumain_size))
               fprintf(fw,', ');
               index_fu = index_fu+1; 
            end
            counter = counter + 1;
        end
        index = index+1;
    end        
    fprintf(fw,';');
        
        
%%%% main auxiliary variables %%%%   

fu_1 = cell(1,2*(length(xfmain_size)-1));
f_c = cell(1,length(xfmain_size)-2);
    for k = 1:2*(length(xfmain_size)-1)
        j = num2str(k);
        f_1{k} = strcat('PWA',subscript1);
        f_1{k} = strcat(f_1{k},'_f');
        f_1{k} = strcat(f_1{k},j);
        fu_1{k} = strcat('PWA',subscript1);
        fu_1{k} = strcat(fu_1{k},'_fu');
        fu_1{k} = strcat(fu_1{k},j);
    end


f_1 = cell(1,length(xfmain_size));

    for k = 1:length(xfmain_size)
        j = num2str(k);
        f_1{k} = strcat('PWA',subscript1);
        f_1{k} = strcat(f_1{k},'_f');
        f_1{k} = strcat(f_1{k},j);
    end
        
    fprintf(fw,'\n\t\t\t REAL ');
    for k = 1:length(xfmain_size)
        fprintf(fw,'%s',char(f_1{k}));
        if(k ~= length(xfmain_size))
           fprintf(fw,', '); 
        end
    end
fprintf(fw,';');

fprintf(fw,'\n\t\t\t REAL ');
    for k = 1:2*(length(xfmain_size)-1)
        fprintf(fw,'%s',char(fu_1{k}));
        if(k ~= 2*(length(xfmain_size)-1))
           fprintf(fw,', '); 
        end
    end
fprintf(fw,';');  
    
for k = 1:length(xfmain_size)-1
    j = num2str(k);
    f_c{k} = strcat('PWA',subscript1);
    f_c{k} = strcat(f_c{k},'_fc');
    f_c{k} = strcat(f_c{k},j);
end    

if(isempty(f_c))
    syms fc
    f_c{1} = fc;
end


if(length(f_c) >= 1)    
fprintf(fw,'\n\t\t\t REAL ');
    for k = 1:length(xfmain_size)-1
        fprintf(fw,'%s',char(f_c{k}));
        if(k ~= (length(xfmain_size)-1))
           fprintf(fw,', '); 
        end
    end    
else
fprintf(fw,', ');    
fprintf(fw,'%s',char(f_c{1}));
end
fprintf(fw,';');

fmainForNdim = cell(1,length(f_1)+length(f_c));

fmainForNdim{1} = f_1{1};
fmainForNdim{2} = f_1{2};

index = 1;
index2 = 3;
for h = 3:length(fmainForNdim)
    if(rem(h,2))
        fmainForNdim{h} = f_c{index};
        index = index+1;
    else
        fmainForNdim{h} = f_1{index2};
        index2 = index2 + 1;
    end
end

end
if(length(xfmain_size) == 1)
    fprintf(fw,';');
end

if(length(xfmain_size) == 1)
    f_sum{foi} = fc1;
else
    f_sum{foi} = f_c{end};
end

end

fprintf(fw,'\n\t\t\t }');    

count = 0; 
for foi = 1:length(functions)

subscript1 = num2str(foi);    
    
xfmain = xfmain1{foi};
a_main = a_main1{foi};
c_main = c_main1{foi};
r_main = r_main1{foi};

xfmain_size = [];
for i1 = 1:length(xfmain)
    xfmain_size = [xfmain_size size(xfmain{i1},1)];
end

xf1 = xfmain{1};
if(length(xfmain_size) > 1)
    xf2 = xfmain{2};
end

xumain = xumain1{foi};
au_main = au_main1{foi};
cu_main = cu_main1{foi};
ru_main = ru_main1{foi};

xumain_size = [];
for i2 = 1:length(xumain)
    xumain_size = [xumain_size size(xumain{i2},1)];
end

if(length(xumain_size)>1)
   xu1 = xumain{1};
   xu2 = xumain{2};
end        

sym_variables = main_datas{1}{7}{foi};    
subscript1 = num2str(foi);    
    
if(length(xfmain_size) == 1)
    
    xf = xf1;
    
    a_values1 = a_main;
    b_values1 = c_main;
    r_values1 = r_main;
    
    fc1 = {};
    fc1 = strcat('PWA',subscript1);
    fc1 = strcat(fc1,'_fc');
    
    a = {};
    b = {};
        for i = 1:size(xf,1)
            j = num2str(i);
            a{i} = strcat('PWA',subscript1);
            a{i} = strcat(a{i},'_a');
            a{i} = strcat(a{i},j);
            b{i} = strcat('PWA',subscript1);
            b{i} = strcat(b{i},'_b');
            b{i} = strcat(b{i},j);
        end
    r = {};
        for i = 1:size(xf,1)-1
            j = num2str(i);
            r{i} = strcat('PWA',subscript1);
            r{i} = strcat(r{i},'_r');
            r{i} = strcat(r{i},j);
        end
    
    d = {};
        for i = 1:size(xf,1)-1
            j = num2str(i);
            d{i} = strcat('PWA',subscript1);
            d{i} = strcat(d{i},'_d');
            d{i} = strcat(d{i},j);
        end

    f = {};

        for i = 1:size(xf,1)
            j = num2str(i);
            f{i} = strcat('PWA',subscript1);
            f{i} = strcat(f{i},'_f');
            f{i} = strcat(f{i},j);
        end
   
    fprintf(fw,'\n\t\t\t AD {');
    fprintf(fw,'\n\t\t\t\t ');

    for i = 1:length(d)
        fprintf(fw,'%c',char(d(i)));
        fprintf(fw,' = ');
        fprintf(fw,'%s',char(sym_variables{1}));
        fprintf(fw,' <= ');
        fprintf(fw,'%c',char(r(i)));
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t\t ');
    end
    fprintf(fw,'}');
    fprintf(fw,'\n\t\t\t DA {');
    fprintf(fw,'\n\t\t\t\t ');
        
    if(size(xf,1) == 2)
        
        fprintf(fw,'%s',char(f{1}));
        fprintf(fw,' = {IF ');
        fprintf(fw,'%s',char(d{1}));
        fprintf(fw,'             THEN ');
        fprintf(fw,'%s',char(a{1}));
        fprintf(fw,'*');
        fprintf(fw,'%s',char(sym_variables{1}));
        fprintf(fw,'+');
        fprintf(fw,'%s',char(b{1}));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
        
        fprintf(fw,'%s',char(f{2}));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(d{1}));
        fprintf(fw,'            THEN ');
        fprintf(fw,'%s',char(a{2}));
        fprintf(fw,'*');
        fprintf(fw,'%s',char(sym_variables{1}));
        fprintf(fw,'+');
        fprintf(fw,'%s',char(b{2}));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
        fprintf(fw,'}');
    else
        
    fprintf(fw,'%s',char(f{1}));
    fprintf(fw,' = { IF ');
    fprintf(fw,'%s',char(d{1}));
    fprintf(fw,'             THEN ');
    fprintf(fw,'%s',char(a{1}));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{1}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(b{1}));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');

    for i = 1:length(d)-1
        fprintf(fw,'%c',f{i+1});
        fprintf(fw,' = { IF ~');
        fprintf(fw,'%c',char(d(i)));
        fprintf(fw,' & ');
        fprintf(fw,'%c',char(d(i+1)));
        fprintf(fw,'  THEN ');
        fprintf(fw,'%c',char(a(i+1)));
        fprintf(fw,'*');
        fprintf(fw,'%s',char(sym_variables{1}));
        fprintf(fw,'+');
        fprintf(fw,'%c',char(b(i+1)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
    end
    fprintf(fw,'%c',f{i+2});
    fprintf(fw,' = { IF ~');
    fprintf(fw,'%c',char(d(i+1)));
    fprintf(fw,'     ');
    fprintf(fw,'       THEN ');
    fprintf(fw,'%c',char(a(i+2)));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{1}));
    fprintf(fw,'+');
    fprintf(fw,'%c',char(b(i+2)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t }');
    
    end
    
    fprintf(fw,'\n\t\t\t LINEAR {');
    fprintf(fw,'%s',fc1);
    fprintf(fw,' = ');
   
    for i = 1:length(f)
       fprintf(fw,'%c',char(f(i)));
       if(i ~= length(f))
          fprintf(fw,' + ');
       end
    end
    fprintf(fw,'; }');
end    
    
if(length(xfmain_size) > 1)    

a = cell(1,length(xfmain_size));
c = cell(1,length(xfmain_size));
r = cell(1,length(xfmain_size));
index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)
            j = num2str(i);
            sub = num2str(index);
            a{k}{i} = strcat('PWA',subscript1);
            a{k}{i} = strcat(a{k}{i},'_a');
            a{k}{i} = strcat(a{k}{i},sub);
            temp11a = a{k}{i};
            a{k}{i} = strcat(temp11a,'_');
            temp12a = a{k}{i};
            a{k}{i} = strcat(temp12a,j); 
            c{k}{i} = strcat('PWA',subscript1);
            c{k}{i} = strcat(c{k}{i},'_c');
            c{k}{i} = strcat(c{k}{i},sub);
            temp11b = c{k}{i};
            c{k}{i} = strcat(temp11b,'_');
            temp12b = c{k}{i};
            c{k}{i} = strcat(temp12b,j);
            if(i < xfmain_size(k))
               r{k}{i} = strcat('PWA',subscript1);
               r{k}{i} = strcat(r{k}{i},'_r');
               r{k}{i} = strcat(r{k}{i},sub); 
               temp11r = r{k}{i};
               r{k}{i} = strcat(temp11r,'_');
               temp12r = r{k}{i};
               r{k}{i} = strcat(temp12r,j);
            end
        end
        index = index+1;
    end
   

%%%%% parameters for the functions fu1 and fu2 %%%%%%

au = cell(1,2*(length(xfmain_size)-1));
cu = cell(1,2*(length(xfmain_size)-1));
ru = cell(1,2*(length(xfmain_size)-1));
index = 1;
    for k = 1:length(au)
        for i = 1:xumain_size(k)
            j = num2str(i);
            sub = num2str(index);
            au{k}{i} = strcat('PWA',subscript1);
            au{k}{i} = strcat(au{k}{i},'_au');
            au{k}{i} = strcat(au{k}{i},sub); 
            temp11a = au{k}{i};
            au{k}{i} = strcat(temp11a,'_');
            temp12a = au{k}{i};
            au{k}{i} = strcat(temp12a,j);
            cu{k}{i} = strcat('PWA',subscript1);
            cu{k}{i} = strcat(cu{k}{i},'_cu');
            cu{k}{i} = strcat(cu{k}{i},sub);
            temp11b = cu{k}{i};
            cu{k}{i} = strcat(temp11b,'_');
            temp12b = cu{k}{i};
            cu{k}{i} = strcat(temp12b,j);
            if(i < xumain_size(k))
               ru{k}{i} = strcat('PWA',subscript1);
               ru{k}{i} = strcat(ru{k}{i},'_ru');
               ru{k}{i} = strcat(ru{k}{i},sub);
               temp11r = ru{k}{i};
               ru{k}{i} = strcat(temp11r,'_');
               temp12r = ru{k}{i};
               ru{k}{i} = strcat(temp12r,j);
            end
        end
        index = index+1;
    end


d = cell(1,length((xfmain_size-1)));
index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)-1
            j = num2str(i);
            sub = num2str(index);
            d{k}{i} = strcat('PWA',subscript1);
            d{k}{i} = strcat(d{k}{i},'_d');
            d{k}{i} = strcat(d{k}{i},sub);
            temp11a = d{k}{i};
            d{k}{i} = strcat(temp11a,'_');
            temp12a = d{k}{i};
            d{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
   
    du = cell(1,2*(length(xfmain_size)-1));
    index = 1;
    for k = 1:2*(length(xfmain_size)-1)
        for i = 1:xumain_size(k)-1
            j = num2str(i);
            sub = num2str(index);
            du{k}{i} = strcat('PWA',subscript1);
            du{k}{i} = strcat(du{k}{i},'_du');
            du{k}{i} = strcat(du{k}{i},sub);
            temp11a = du{k}{i};
            du{k}{i} = strcat(temp11a,'_');
            temp12a = du{k}{i};
            du{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end

f = cell(1,length(xfmain_size));
    index = 1;
    for k = 1:length(xfmain_size)
        for i = 1:xfmain_size(k)
            j = num2str(i);
            sub = num2str(index);
            f{k}{i} = strcat('PWA',subscript1);
            f{k}{i} = strcat(f{k}{i},'_f');
            f{k}{i} = strcat(f{k}{i},sub);
            temp11a = f{k}{i};
            f{k}{i} = strcat(temp11a,'_');
            temp12a = f{k}{i};
            f{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
 
   
%%%% auxiliary variables for u1^2 u2^2 .... %%%%

fu = cell(1,2*(length(xfmain_size)-1));
    index = 1;
    for k = 1:2*(length(xfmain_size)-1)
        for i = 1:xumain_size(k)
            j = num2str(i);
            sub = num2str(index);
            fu{k}{i} = strcat('PWA',subscript1);
            fu{k}{i} = strcat(fu{k}{i},'_fu');
            fu{k}{i} = strcat(fu{k}{i},sub);
            temp11a = fu{k}{i};
            fu{k}{i} = strcat(temp11a,'_');
            temp12a = fu{k}{i};
            fu{k}{i} = strcat(temp12a,j); 
        end
        index = index+1;
    end
       
        
%%%% main auxiliary variables %%%%   

fu_1 = cell(1,2*(length(xfmain_size)-1));
f_c = cell(1,length(xfmain_size)-2);
    for k = 1:2*(length(xfmain_size)-1)
        j = num2str(k);
        f_1{k} = strcat('PWA',subscript1);
        f_1{k} = strcat(f_1{k},'_f');
        f_1{k} = strcat(f_1{k},j);
        fu_1{k} = strcat('PWA',subscript1);
        fu_1{k} = strcat(fu_1{k},'_fu');
        fu_1{k} = strcat(fu_1{k},j);
    end


f_1 = cell(1,length(xfmain_size));

    for k = 1:length(xfmain_size)
        j = num2str(k);
        f_1{k} = strcat('PWA',subscript1);
        f_1{k} = strcat(f_1{k},'_f');
        f_1{k} = strcat(f_1{k},j);
    end

    
for k = 1:length(xfmain_size)-1
    j = num2str(k);
    f_c{k} = strcat('PWA',subscript1);
    f_c{k} = strcat(f_c{k},'_fc');
    f_c{k} = strcat(f_c{k},j);
end    

if(isempty(f_c))
    syms fc
    f_c{1} = fc;
end

if(length(xfmain_size) > 1)

fmainForNdim = cell(1,length(f_1)+length(f_c));
fmainForNdim{1} = f_1{1};
fmainForNdim{2} = f_1{2};

index = 1;
index2 = 3;
for h = 3:length(fmainForNdim)
    if(rem(h,2))
        fmainForNdim{h} = f_c{index};
        index = index+1;
    else
        fmainForNdim{h} = f_1{index2};
        index2 = index2 + 1;
    end
end

end
  
    
fprintf(fw,'\n\t\t\t ');    
fprintf(fw,'AD {');    
fprintf(fw,'\n\t\t\t\t ');

for k = 1:2
    for i = 1:length(d{k})
        fprintf(fw,'%s',char(d{k}(i)));
        fprintf(fw,' = ');
        fprintf(fw,'%s',char(sym_variables{k}));
        fprintf(fw,' <= ');
        fprintf(fw,'%s',char(r{k}(i)));
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t\t ');
    end
end
fprintf(fw,'}');
fprintf(fw,'\n\t\t\t DA {');
fprintf(fw,'\n\t\t\t\t');

if(size(xf1,1) == 2)
    fprintf(fw,' ');
    fprintf(fw,'%s',char(f{1}{1}));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(d{1}{1}));
    fprintf(fw,'               THEN ');
    fprintf(fw,'%s',char(a{1}{1}));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{1}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(c{1}{1}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t ');
    
    fprintf(fw,'\t ');
    fprintf(fw,'%s',char(f{1}{2}));
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%s',char(d{1}{1}));
    fprintf(fw,'              THEN ');
    fprintf(fw,'%s',char(a{1}{2}));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{1}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(c{1}{2}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t ');
    
else

fprintf(fw,'%s',char(f{1}{1}));
fprintf(fw,' = {IF ');
fprintf(fw,'%s',char(d{1}{1}));
fprintf(fw,'              THEN  ');
fprintf(fw,'%s',char(a{1}{1}));
fprintf(fw,'*');
fprintf(fw,'%s',char(sym_variables{1}));
fprintf(fw,'+');
fprintf(fw,'%s',char(c{1}{1}));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t\t');   
    
for i = 1:length(d{1})-1
    fprintf(fw,'%c',f{1}{i+1});
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%c',char(d{1}(i)));
    fprintf(fw,' & ');
    fprintf(fw,'%c',char(d{1}(i+1)));
    fprintf(fw,' THEN  ');
    fprintf(fw,'%c',char(a{1}(i+1)));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{2}));
    fprintf(fw,'+'); 
    fprintf(fw,'%c',char(c{1}(i+1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t');
end
fprintf(fw,'%c',f{1}{i+2});
fprintf(fw,' = {IF ~');
fprintf(fw,'%c',char(d{1}(i+1)));
fprintf(fw,'     ');
fprintf(fw,'        THEN  ');
fprintf(fw,'%c',char(a{1}(i+2)));
fprintf(fw,'*');
fprintf(fw,'%s',char(sym_variables{1}));
fprintf(fw,'+');
fprintf(fw,'%c',char(c{1}(i+2)));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t\t');

end

if(size(xf2,1) == 2)
    
    fprintf(fw,'\t ');
    fprintf(fw,'%s',char(f{2}{1}));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(d{2}{1}));
    fprintf(fw,'               THEN ');
    fprintf(fw,'%s',char(a{2}{1}));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{2}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(c{2}{1}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t');
    
    fprintf(fw,'\t ');
    fprintf(fw,'%s',char(f{2}{2}));
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%s',char(d{2}{1}));
    fprintf(fw,'              THEN ');
    fprintf(fw,'%s',char(a{2}{2}));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{2}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(c{2}{2}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t');
    
else

if(size(xf1,1) == 2)    
    fprintf(fw,'\n\t\t\t\t ');
end    
    
fprintf(fw,'%s',char(f{2}{1}));
fprintf(fw,' = {IF ');
fprintf(fw,'%s',char(d{2}{1}));
fprintf(fw,'              THEN  ');
fprintf(fw,'%s',char(a{2}{1}));
fprintf(fw,'*');
fprintf(fw,'%s',char(sym_variables{2}));
fprintf(fw,'+');
fprintf(fw,'%s',char(c{2}{1}));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t\t');

for i = 1:length(d{2})-1
    fprintf(fw,'%c',f{2}{i+1});
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%c',char(d{2}(i)));
    fprintf(fw,' & ');
    fprintf(fw,'%c',char(d{2}(i+1)));
    fprintf(fw,' THEN  ');
    fprintf(fw,'%c',char(a{2}(i+1)));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{2}));
    fprintf(fw,'+');
    fprintf(fw,'%c',char(c{2}(i+1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t');
end
fprintf(fw,'%c',f{2}{i+2});
fprintf(fw,' = {IF ~');
fprintf(fw,'%c',char(d{2}(i+1)));
fprintf(fw,'     ');
fprintf(fw,'        THEN  ');
fprintf(fw,'%c',char(a{2}(i+2)));
fprintf(fw,'*');
fprintf(fw,'%s',char(sym_variables{2}));
fprintf(fw,'+');
fprintf(fw,'%c',char(c{2}(i+2)));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t }');

end

if(size(xf2,1) == 2)
   fprintf(fw,'\t}');
end

fprintf(fw,'\n\t\t\t LINEAR { ');
for k = 1:2
    fprintf(fw,'%s',char(f_1(k)));
    fprintf(fw,' = ');
    for i = 1:length(f{k})
       fprintf(fw,'%s',char(f{k}(i)));
       if(i ~= length(f{k}))
          fprintf(fw,' + ');
       end
    end
    fprintf(fw,';');
    if(k ~= 2)
        fprintf(fw,'\n\t\t\t\t\t  ');
    end
end
 
% %%%%%%%%%%%% approximations of the functions u1^2 and u2^2 %%%%%%%%%%%%

fprintf(fw,'\n\t\t\t } ');
fprintf(fw,'\n\t\t\t AD {');
fprintf(fw,'\n\t\t\t\t ');

for i = 1:length(du{1})
    fprintf(fw,'%c',char(du{1}(i)));
    fprintf(fw,' = ');
    fprintf(fw,'%s',char(f_1{1}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(f_1{2}));
    fprintf(fw,' <= ');
    fprintf(fw,'%c',char(ru{1}(i)));
    fprintf(fw,';');
    fprintf(fw,'\n\t\t\t\t ');
end

for i = 1:length(du{2})
    fprintf(fw,'%c',char(du{2}(i)));
    fprintf(fw,' = ');
    fprintf(fw,'%s',char(f_1{1}));
    fprintf(fw,'-');
    fprintf(fw,'%s',char(f_1{2}));
    fprintf(fw,' <= ');
    fprintf(fw,'%c',char(ru{2}(i)));
    fprintf(fw,';');
    fprintf(fw,'\n\t\t\t\t ');
end
fprintf(fw,'}');

fprintf(fw,'\n\n\t\t\t DA {');
fprintf(fw,'\n\t\t\t\t ');

if(size(xu1,1) == 2)
    
    fprintf(fw,'%s',char(fu{1}{1}));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(du{1}{1}));
    fprintf(fw,'               THEN ');
    fprintf(fw,'%s',char(au{1}{1}));
    fprintf(fw,'*(');
    fprintf(fw,'%s + %s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{1}{1}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t ');
    
    fprintf(fw,'\t ');
    fprintf(fw,'%s',char(fu{1}{2}));
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%s',char(du{1}{1}));
    fprintf(fw,'              THEN ');
    fprintf(fw,'%s',char(au{1}{2}));
    fprintf(fw,'*(');
    fprintf(fw,'%s + %s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{1}{2}));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');

else

if(size(xu1,1) == 2)    
    fprintf(fw,'\n\t\t\t\t ');
end
    
fprintf(fw,'%s',char(fu{1}{1}));
fprintf(fw,' = {IF ');
fprintf(fw,'%s',char(du{1}{1}));
fprintf(fw,'               THEN ');
fprintf(fw,'%s',char(au{1}{1}));
fprintf(fw,'*(');
fprintf(fw,'%s+%s',char(f_1{1}),char(f_1{2}));
fprintf(fw,')');
fprintf(fw,'+');
fprintf(fw,'%s',char(cu{1}{1}));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t\t ');    

for i = 1:length(du{1})-1
    fprintf(fw,'%s',char(fu{1}(i+1)));
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%s',char(du{1}(i)));
    fprintf(fw,' & ');
    fprintf(fw,'%s',char(du{1}(i+1)));
    fprintf(fw,' THEN ');
    fprintf(fw,'%s',char(au{1}(i+1)));
    fprintf(fw,'*(');
    fprintf(fw,'%s+%s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{1}(i+1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');
end

fprintf(fw,'%s',char(fu{1}{i+2}));
fprintf(fw,' = {IF ~');
fprintf(fw,'%s',char(du{1}{i+1}));
fprintf(fw,'              THEN ');
fprintf(fw,'%s',char(au{1}{i+2}));
fprintf(fw,'*(');
fprintf(fw,'%s+%s',char(f_1{1}),char(f_1{2}));
fprintf(fw,')');
fprintf(fw,'+');
fprintf(fw,'%s',char(cu{1}{i+2}));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t\t '); 

end

if(size(xu2,1) == 2)

    fprintf(fw,'%s',char(fu{2}{1}));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(du{2}{1}));
    fprintf(fw,'               THEN ');
    fprintf(fw,'%s',char(au{2}{1}));
    fprintf(fw,'*(');
    fprintf(fw,'%s - %s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{2}{1}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t ');
    
    fprintf(fw,'\t ');
    fprintf(fw,'%s',char(fu{2}{2}));
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%s',char(du{2}{1}));
    fprintf(fw,'              THEN ');
    fprintf(fw,'%s',char(au{2}{2}));
    fprintf(fw,'*(');
    fprintf(fw,'%s - %s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{2}{2}));
    fprintf(fw,'};');
    
    fprintf(fw,'\n\t\t\t ');
    fprintf(fw,'}');
    
else

    fprintf(fw,'%s',char(fu{2}{1}));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(du{2}{1}));
    fprintf(fw,'               THEN ');
    fprintf(fw,'%s',char(au{2}{1}));
    fprintf(fw,'*(');
    fprintf(fw,'%s-%s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{2}{1}));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');
    
for i = 1:length(du{2})-1
    fprintf(fw,'%s',char(fu{2}(i+1)));
    fprintf(fw,' = {IF ~');
    fprintf(fw,'%s',char(du{2}(i)));
    fprintf(fw,' & ');
    fprintf(fw,'%s',char(du{2}(i+1)));
    fprintf(fw,' THEN ');
    fprintf(fw,'%s',char(au{2}(i+1)));
    fprintf(fw,'*(');
    fprintf(fw,'%s-%s',char(f_1{1}),char(f_1{2}));
    fprintf(fw,')');
    fprintf(fw,'+');
    fprintf(fw,'%s',char(cu{2}(i+1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');
end
fprintf(fw,'%s',char(fu{2}(i+2)));
fprintf(fw,' = {IF ~');
fprintf(fw,'%s',char(du{2}(i+1)));
fprintf(fw,'     ');
fprintf(fw,'         THEN ');
fprintf(fw,'%s',char(au{2}(i+2)));
fprintf(fw,'*(');
fprintf(fw,'%s-%s',char(f_1{1}),char(f_1{2}));
fprintf(fw,')');
fprintf(fw,'+');
fprintf(fw,'%s',char(cu{2}(i+2)));
fprintf(fw,'};');
fprintf(fw,'\n\t\t\t }');

end

fprintf(fw,'\n\t\t\t LINEAR { ');
for k = 1:2
    fprintf(fw,'%s',char(fu_1{k}));
    fprintf(fw,' = ');
    for i = 1:length(fu{k})
       fprintf(fw,'%s',char(fu{k}(i)));
       if(i ~= length(fu{k}))
          fprintf(fw,' + ');
       end
    end
    fprintf(fw,';');
    fprintf(fw,'\n\t\t\t\t\t  ');
end

fprintf(fw,'%s',char(f_c{1}));
fprintf(fw,' = (');
fprintf(fw,'%s - %s',char(fu_1{1}),char(fu_1{2}));
fprintf(fw,');');
fprintf(fw,'\n\t\t\t }');
fprintf(fw,'\n\t\t\t\t  ');

% end

%%% for dimension N > 2

ind = 1;
xstart = 3;

for i = 3:length(xfmain_size)
   
    fprintf(fw,'\n\t\t\t ');
    
    %%%% AD section %%%%
    
    fprintf(fw,'AD {');
    fprintf(fw,'\n\t\t\t\t ');
    for k = 1:length(d{i})
        fprintf(fw,'%s',char(d{i}(k)));
        fprintf(fw,' = ');
        fprintf(fw,'%s',char(sym_variables{i}));
        fprintf(fw,' <= ');
        fprintf(fw,'%s',char(r{i}(k)));
        fprintf(fw,';');
        fprintf(fw,'\n\t\t\t\t ');
    end
    fprintf(fw,'}');
        
    %%%% DA section %%%%
    fprintf(fw,'\n\t\t\t ');
    fprintf(fw,'DA {');
    
    if(xfmain_size(i) == 2)
       indexf = 1; 
       fprintf(fw,'\n\t\t\t\t ');
       for t = 1:2        
          fprintf(fw,'%s',char(f{i}(t)));
          if(t == 1)
             fprintf(fw,' = {IF ');
          else
             fprintf(fw,' = {IF ~'); 
          end
          fprintf(fw,'%s',char(d{i}(indexf)));
          if(t == 1)
            fprintf(fw,'         THEN ');
          else
            fprintf(fw,'        THEN ');  
          end
          fprintf(fw,'%s',char(a{i}(t)));
          fprintf(fw,'*');
          fprintf(fw,'%s',char(sym_variables{i}));
          fprintf(fw,'+');
          fprintf(fw,'%s',char(c{i}(t)));
          fprintf(fw,'};');
          fprintf(fw,'\n\t\t\t\t ');  
       end
    fprintf(fw,'}');
    else
    
    fprintf(fw,'\n\t\t\t\t ');
    fprintf(fw,'%s',char(f{i}(1)));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(d{i}(1)));
    fprintf(fw,'               THEN ');
    fprintf(fw,'%s',char(a{i}(1)));
    fprintf(fw,'*');
    fprintf(fw,'%s',char(sym_variables{i}));
    fprintf(fw,'+');
    fprintf(fw,'%s',char(c{i}(1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');    
        
    for n = 1:length(d{i})-1
        fprintf(fw,'%s',char(f{i}(n+1)));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(d{i}(n)));
        fprintf(fw,' & ');
        fprintf(fw,'%s',char(d{i}(n+1)));
        fprintf(fw,'  THEN ');
        fprintf(fw,'%s',char(a{i}(n+1)));
        fprintf(fw,'*');
        fprintf(fw,'%s',char(sym_variables{i}));
        fprintf(fw,'+');
        fprintf(fw,'%s',char(c{i}(n+1)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
    end
        fprintf(fw,'%s',char(f{i}(n+2)));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(d{i}(n+1)));
        fprintf(fw,'     ');
        fprintf(fw,'         THEN ');
        fprintf(fw,'%s',char(a{i}(n+2)));
        fprintf(fw,'*');
        fprintf(fw,'%s',char(sym_variables{i}));
        fprintf(fw,'+');
        fprintf(fw,'%s',char(c{i}(n+2)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
        
    fprintf(fw,'}');   
     
    end
       
        
     fprintf(fw,'\n\t\t\t LINEAR { ');
     
     %%% Linear section for the functions fi, where i = 3, ... N
     
     fprintf(fw,'%s',char(f_1{i}));
     fprintf(fw,' = ');
     for v = 1:length(f{i})
         fprintf(fw,'%s',char(f{i}(v)));
         if(v ~= length(f{i}))
            fprintf(fw,' + ');
         end
     end
         fprintf(fw,';');
         if(v ~= 2)
            fprintf(fw,'\n\t\t\t\t\t');
         end  
      
      fprintf(fw,'}');    
         
for ii = xstart:length(xumain_size)
     
     %%%% AD section %%%%
     fprintf(fw,'\n\t\t\t ');    
     fprintf(fw,'AD {');
     fprintf(fw,'\n\t\t\t\t ');
     for g = 1:length(du{ii})
             fprintf(fw,'%s',char(du{ii}(g)));
             fprintf(fw,' = ');
             fprintf(fw,'%s + %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
             fprintf(fw,' <= ');
             fprintf(fw,'%s',char(ru{ii}(g)));
             fprintf(fw,';');
             fprintf(fw,'\n\t\t\t\t ');
     end
        
     for g = 1:length(du{ii+1})
         fprintf(fw,'%s',char(du{ii+1}(g)));
         fprintf(fw,' = ');
         fprintf(fw,'%s - %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
         fprintf(fw,' <= ');
         fprintf(fw,'%s',char(ru{ii+1}(g)));
         fprintf(fw,';');
         fprintf(fw,'\n\t\t\t\t ');
     end
     fprintf(fw,'}');
        
    
     %%%% DA section %%%%
    fprintf(fw,'\n\t\t\t ');
    fprintf(fw,'DA {');
    
   if(xumain_size(ii) == 2)
      fprintf(fw,'\n\t\t\t\t ');
      indexu = 1;  
      for t = 1:2        
          fprintf(fw,'%s',char(fu{ii}(t)));
          if(t == 1)
          fprintf(fw,' = {IF ');
          else
          fprintf(fw,' = {IF ~');    
          end
          fprintf(fw,'%s',char(du{ii}(indexu)));
          if(t == 1)
            fprintf(fw,'                THEN ');
          else
            fprintf(fw,'               THEN ');  
          end
          fprintf(fw,'%s',char(au{ii}(t)));
          fprintf(fw,'*(');
          fprintf(fw,'%s + %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
          fprintf(fw,') + ');
          fprintf(fw,'%s',char(cu{ii}(t)));
          fprintf(fw,'};');
          if(t == 1)
            fprintf(fw,'\n\t\t\t\t ');
          end
       end
    
    else
    
    fprintf(fw,'\n\t\t\t\t ');
    fprintf(fw,'%s',char(fu{ii}(1)));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(du{ii}(1)));
    fprintf(fw,'                THEN ');
    fprintf(fw,'%s',char(au{ii}(1)));
    fprintf(fw,'*(');
    fprintf(fw,'%s + %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
    fprintf(fw,') + ');
    fprintf(fw,'%s',char(cu{ii}(1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');

    for n = 1:length(du{ii})-1
        fprintf(fw,'%s',char(fu{ii}(n+1)));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(du{ii}(n)));
        fprintf(fw,' & ');
        fprintf(fw,'%s',char(du{ii}(n+1)));
        fprintf(fw,'  THEN ');
        fprintf(fw,'%s',char(au{ii}(n+1)));
        fprintf(fw,'*(');
        fprintf(fw,'%s + %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
        fprintf(fw,') + ');
        fprintf(fw,'%s',char(cu{ii}(n+1)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
    end
        fprintf(fw,'%s',char(fu{ii}(n+2)));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(du{ii}(n+1)));
        fprintf(fw,'     ');
        fprintf(fw,'          THEN ');
        fprintf(fw,'%s',char(au{ii}(n+2)));
        fprintf(fw,'*(');
        fprintf(fw,'%s + %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
        fprintf(fw,') + ');
        fprintf(fw,'%s',char(cu{ii}(n+2)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
        
   end   
      
    if(xumain_size(ii+1) == 2)
       indexu2 = 1; 
       fprintf(fw,'\n\t\t\t\t ');
       for t = 1:2        
          fprintf(fw,'%s',char(fu{ii+1}(t)));
          if(t == 1)
             fprintf(fw,' = {IF ');
          else
             fprintf(fw,' = {IF ~'); 
          end
          fprintf(fw,'%s',char(du{ii+1}(indexu2)));
          if(t == 1)
              fprintf(fw,'          THEN ');
          else
              fprintf(fw,'         THEN ');
          end  
          fprintf(fw,'%s',char(au{ii+1}(t)));
          fprintf(fw,'*(');
          fprintf(fw,'%s - %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
          fprintf(fw,') + ');
          fprintf(fw,'%s',char(cu{ii+1}(t)));
          fprintf(fw,'};');
          if(t == 1)
              fprintf(fw,'\n\t\t\t\t ');
          end
       end
    
    else 
    if(xumain_size(ii) ==2)   
        fprintf(fw,'\n\t\t\t\t ');
    end        
    fprintf(fw,'%s',char(fu{ii+1}(1)));
    fprintf(fw,' = {IF ');
    fprintf(fw,'%s',char(du{ii+1}(1)));
    fprintf(fw,'                THEN ');
    fprintf(fw,'%s',char(au{ii+1}(1)));
    fprintf(fw,'*(');
    fprintf(fw,'%s - %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
    fprintf(fw,') + ');
    fprintf(fw,'%s',char(cu{ii+1}(1)));
    fprintf(fw,'};');
    fprintf(fw,'\n\t\t\t\t ');
      
    for n = 1:length(du{ii+1})-1
        fprintf(fw,'%s',char(fu{ii+1}(n+1)));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(du{ii+1}(n)));
        fprintf(fw,' & ');
        fprintf(fw,'%s',char(du{ii+1}(n+1)));
        fprintf(fw,'  THEN ');
        fprintf(fw,'%s',char(au{ii+1}(n+1)));
        fprintf(fw,'*(');
        fprintf(fw,'%s - %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
        fprintf(fw,') + ');
        fprintf(fw,'%s',char(cu{ii+1}(n+1)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');
    end
        fprintf(fw,'%s',char(fu{ii+1}(n+2)));
        fprintf(fw,' = {IF ~');
        fprintf(fw,'%s',char(du{ii+1}(n+1)));
        fprintf(fw,'     ');
        fprintf(fw,'          THEN ');
        fprintf(fw,'%s',char(au{ii+1}(n+2)));
        fprintf(fw,'*(');
        fprintf(fw,'%s - %s',char(fmainForNdim{ii}),char(fmainForNdim{ii+1}));
        fprintf(fw,') + ');
        fprintf(fw,'%s',char(cu{ii+1}(n+2)));
        fprintf(fw,'};');
        fprintf(fw,'\n\t\t\t\t ');   
       
    end   
     
     fprintf(fw,'\n\t\t\t ');
     fprintf(fw,'}');   
          
     %%% Linear section for the functions fi, where i = 3, ... N
     
     fprintf(fw,'\n\t\t\t LINEAR { ');
     for k = ii:ii+1
         fprintf(fw,'%s',char(fu_1{k}));
         fprintf(fw,' = ');
         for t = 1:xumain_size(k)
             fprintf(fw,'%s',char(fu{k}(t)));
                 if(t ~= xumain_size(k))
                    fprintf(fw,' + ');
                 end
         end
             fprintf(fw,';');
             fprintf(fw,'\n\t\t\t\t\t  ');
     end
         fprintf(fw,'%s',char(f_c{ind+1}));
         fprintf(fw,' = (');
         fprintf(fw,'%s - %s',char(fu_1{k-1}),char(fu_1{k}));
         fprintf(fw,');');
         fprintf(fw,'\n\t\t\t\t  ');
         fprintf(fw,'}');
            
         xstart = xstart+2;
         ind = ind+1;
         break;
    end
       
    end
end
count = count + 1;
end

fprintf(fw,'\n\t\t\t ');
if(nargin < 3)
fprintf(fw,'OUTPUT {');
fprintf(fw,'PWA_apprx = ');
   for i = 1:length(functions)
       fprintf(fw,'%s',char(f_sum{i}));
       if(i ~= length(functions))
         fprintf(fw,'+');
       end
   end
   fprintf(fw,';}');
   fprintf(fw,'\n\t\t\t }');
   fprintf(fw,'\n\t\t }');
else
   fprintf(fw,'CONTINUOUS { '); 
   fprintf(fw,'\n\t\t\t ');
   pos1 = 1;
   for i = 1:length(sub_funs_de1)
       fprintf(fw,'%s',char(main_datas{end-2}{1}(i)));
       fprintf(fw,' = ');
       fprintf(fw,'(');
       for j = 1:length(sub_funs_de1{i})
           dif_temp = diff(sym(sub_funs_de1{i}{j}));
           temp = findsym(sym(dif_temp));
           if(temp)
               fprintf(fw,'%s',f_sum{pos1});
               pos1 = pos1 + 1;
           else
               fprintf(fw,'%s',char(sub_funs_de1{i}{j}));
           end
           if(j ~= length(sub_funs_de1{i}))
               fprintf(fw,' %s ',main_datas{end}{4}{i}(j));
           end
       end
       fprintf(fw,')*Ts');
       fprintf(fw,' + ');
       fprintf(fw,'%s',char(main_datas{end-2}{1}(i)));
       fprintf(fw,';');
       fprintf(fw,'\n\t\t\t ');
   end
   fprintf(fw,'}');
   fprintf(fw,'\n\t\t }');
   fprintf(fw,'\n\t }');
end


