function result_signs = obtain_signs(fun)
% Obtain the signs separating the sum of nD functions

% Copyright is with the following author(s):
%
% (C) 2010 Alexander Szucs, Slovak University of Technology in Bratislava
%          alexander.szucs@stuba.sk
% (C) 2010 Michal Kvasnica, Slovak University of Technology in Bratislava
%          michal.kvasnica@stuba.sk

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------
Fpom = fun;

%%% checking whether the argument contains a minus sign: e.g: exp(-9850/t
%%% +273.15) %%%

brackets = findstr(Fpom,'(');
minus = findstr(Fpom,'-');    
 
pos_minus = []; 
for i = 1:length(brackets)
    for j = 1:length(minus)  
        if(abs(brackets(i) - minus(j)) == 1 & brackets(i) < minus(j))
            pos_minus = [pos_minus; minus(j)];
        end
    end
end

%%% counting the number of signs(+,-)

for i = 1:length(Fpom)
    pozchar_plus = findstr(Fpom,'+');
    pozchar_minus = findstr(Fpom,'-');
end

for i = 1:length(pozchar_minus)
    for j = 1:length(pos_minus)
        if(pozchar_minus(i) == pos_minus(j))
            pozchar_minus(i) = 0;
        end
    end
end

pos = find(pozchar_minus ~= 0);
pozchar_minus = pozchar_minus(pos);

%%% final array of signs %%%

resultPozChar = sort([pozchar_plus pozchar_minus]);
result_signs = Fpom(resultPozChar)';





