function autoprox_gui(input)
% Graphical Use Interface

% Copyright is with the following author(s):
%
% (C) 2010 Alexander Szucs, Slovak University of Technology in Bratislava
%          alexander.szucs@stuba.sk
% (C) 2010 Michal Kvasnica, Slovak University of Technology in Bratislava
%          michal.kvasnica@stuba.sk

% ---------------------------------------------------------------------------
% Legal note:
%          This program is free software; you can redistribute it and/or
%          modify it under the terms of the GNU General Public
%          License as published by the Free Software Foundation; either
%          version 2.1 of the License, or (at your option) any later version.
%
%          This program is distributed in the hope that it will be useful,
%          but WITHOUT ANY WARRANTY; without even the implied warranty of
%          MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
%          General Public License for more details.
% 
%          You should have received a copy of the GNU General Public
%          License along with this library; if not, write to the 
%          Free Software Foundation, Inc., 
%          59 Temple Place, Suite 330, 
%          Boston, MA  02111-1307  USA
%
% -------------------------------------------------------------------------

global pocet avg_error wst_error counter

if(nargin == 0)
    
    %%% closing in case of repeatedly calling of function %%%
    close(findobj('Tag','figure1'));
    close(findobj('Tag','figure2'));
    close(findobj('Tag','figure3'));
    
                                
    %%% resolution of screen %%%
    Monitor = get(0,'Screensize');
    
    %%% main figure %%%
    F1 = figure('Units','Pixels','Name','Automatic approximation',...
        'position',[0.25*Monitor(4) 0.3*Monitor(4) 0.7*Monitor(4) 0.5*Monitor(4)],...
        'Tag','figure1','numbertitle','off','Color',[0.701961 0.701961 0.701961]);
    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
    F3 = figure('Units','Pixels','Name','Info','position',...
        [0.5*Monitor(4) 0.4*Monitor(4) 0.3*Monitor(4) 0.2*Monitor(4)],'Tag','figure3',...
        'Visible','off','menubar','none','numbertitle','off');
    
     %%% text block for export information %%%
    figure(F1);
            
    %%% objects for data 2d case %%%
    hu1 = uicontrol('Style','text','Visible','off','tag','hu_11'); 
    hu2 = uicontrol('Style','text','Visible','off','tag','hu_12');
    hu3 = uicontrol('Style','text','Visible','off','tag','hu_13'); 
    
    %%% objects for data 1d case %%%
    hu1_1D = uicontrol('Style','text','Visible','off','tag','hu_11_1D'); 
    hu2_1D = uicontrol('Style','text','Visible','off','tag','hu_12_1D');
    
    %%% temporary variable %%%
    huglob = uicontrol('Style','text','Visible','off','tag','to_export');
        
    %%% objects for data 3d case %%%
    hu1a_3D = uicontrol('Style','text','Visible','off','tag','Hu1a_3D'); 
    hu1b_3D = uicontrol('Style','text','Visible','off','tag','Hu1b_3D'); 
    hu2a_3D = uicontrol('Style','text','Visible','off','tag','Hu2a_3D');     
    hu2b_3D = uicontrol('Style','text','Visible','off','tag','Hu2b_3D');     
    hu3a_3D = uicontrol('Style','text','Visible','off','tag','Hu3a_3D');     
    hu3b_3D = uicontrol('Style','text','Visible','off','tag','Hu3b_3D');     
    hu4a_3D = uicontrol('Style','text','Visible','off','tag','Hu4a_3D');     
    hu4b_3D = uicontrol('Style','text','Visible','off','tag','Hu4b_3D');     
    hu5a_3D = uicontrol('Style','text','Visible','off','tag','Hu5a_3D');     
    hu5b_3D = uicontrol('Style','text','Visible','off','tag','Hu5b_3D');     
    hu6a_3D = uicontrol('Style','text','Visible','off','tag','Hu6a_3D');     
    hu6b_3D = uicontrol('Style','text','Visible','off','tag','Hu6b_3D');     
    hu7a_3D = uicontrol('Style','text','Visible','off','tag','Hu7a_3D');     
    hu7b_3D = uicontrol('Style','text','Visible','off','tag','Hu7b_3D');     
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_3D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_3D');
    hu_bound1 = uicontrol('Style','text','Visible','off','tag','Hu_b1');
    hu_bound2 = uicontrol('Style','text','Visible','off','tag','Hu_b2');
    hu_sym = uicontrol('Style','text','Visible','off','tag','Hu_sym');
    
    %%% objects for data 4d case %%%
    hu1a_4D = uicontrol('Style','text','Visible','off','tag','Hu1a_4D'); 
    hu1b_4D = uicontrol('Style','text','Visible','off','tag','Hu1b_4D'); 
    hu2a_4D = uicontrol('Style','text','Visible','off','tag','Hu2a_4D');     
    hu2b_4D = uicontrol('Style','text','Visible','off','tag','Hu2b_4D');     
    hu3a_4D = uicontrol('Style','text','Visible','off','tag','Hu3a_4D');     
    hu3b_4D = uicontrol('Style','text','Visible','off','tag','Hu3b_4D');     
    hu4a_4D = uicontrol('Style','text','Visible','off','tag','Hu4a_4D');     
    hu4b_4D = uicontrol('Style','text','Visible','off','tag','Hu4b_4D');     
    hu5a_4D = uicontrol('Style','text','Visible','off','tag','Hu5a_4D');     
    hu5b_4D = uicontrol('Style','text','Visible','off','tag','Hu5b_4D');     
    hu6a_4D = uicontrol('Style','text','Visible','off','tag','Hu6a_4D');     
    hu6b_4D = uicontrol('Style','text','Visible','off','tag','Hu6b_4D');     
    hu7a_4D = uicontrol('Style','text','Visible','off','tag','Hu7a_4D');     
    hu7b_4D = uicontrol('Style','text','Visible','off','tag','Hu7b_4D');     
    hu8a_4D = uicontrol('Style','text','Visible','off','tag','Hu8a_4D');     
    hu8b_4D = uicontrol('Style','text','Visible','off','tag','Hu8b_4D');     
    hu9a_4D = uicontrol('Style','text','Visible','off','tag','Hu9a_4D');     
    hu9b_4D = uicontrol('Style','text','Visible','off','tag','Hu9b_4D');     
    hu10a_4D = uicontrol('Style','text','Visible','off','tag','Hu10a_4D');     
    hu10b_4D = uicontrol('Style','text','Visible','off','tag','Hu10b_4D');     
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_4D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_4D');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval');
    
    %%% objects for data 5d case %%%
    hu1a_5D = uicontrol('Style','text','Visible','off','tag','Hu1a_5D'); 
    hu1b_5D = uicontrol('Style','text','Visible','off','tag','Hu1b_5D'); 
    hu2a_5D = uicontrol('Style','text','Visible','off','tag','Hu2a_5D');     
    hu2b_5D = uicontrol('Style','text','Visible','off','tag','Hu2b_5D');     
    hu3a_5D = uicontrol('Style','text','Visible','off','tag','Hu3a_5D');     
    hu3b_5D = uicontrol('Style','text','Visible','off','tag','Hu3b_5D');     
    hu4a_5D = uicontrol('Style','text','Visible','off','tag','Hu4a_5D');     
    hu4b_5D = uicontrol('Style','text','Visible','off','tag','Hu4b_5D');     
    hu5a_5D = uicontrol('Style','text','Visible','off','tag','Hu5a_5D');     
    hu5b_5D = uicontrol('Style','text','Visible','off','tag','Hu5b_5D');     
    hu6a_5D = uicontrol('Style','text','Visible','off','tag','Hu6a_5D');     
    hu6b_5D = uicontrol('Style','text','Visible','off','tag','Hu6b_5D');     
    hu7a_5D = uicontrol('Style','text','Visible','off','tag','Hu7a_5D');     
    hu7b_5D = uicontrol('Style','text','Visible','off','tag','Hu7b_5D');     
    hu8a_5D = uicontrol('Style','text','Visible','off','tag','Hu8a_5D');     
    hu8b_5D = uicontrol('Style','text','Visible','off','tag','Hu8b_5D');     
    hu9a_5D = uicontrol('Style','text','Visible','off','tag','Hu9a_5D');     
    hu9b_5D = uicontrol('Style','text','Visible','off','tag','Hu9b_5D');     
    hu10a_5D = uicontrol('Style','text','Visible','off','tag','Hu10a_5D');     
    hu10b_5D = uicontrol('Style','text','Visible','off','tag','Hu10b_5D'); 
    hu11a_5D = uicontrol('Style','text','Visible','off','tag','Hu11a_5D');     
    hu11b_5D = uicontrol('Style','text','Visible','off','tag','Hu11b_5D'); 
    hu12a_5D = uicontrol('Style','text','Visible','off','tag','Hu12a_5D');     
    hu12b_5D = uicontrol('Style','text','Visible','off','tag','Hu12b_5D'); 
    hu13a_5D = uicontrol('Style','text','Visible','off','tag','Hu13a_5D');     
    hu13b_5D = uicontrol('Style','text','Visible','off','tag','Hu13b_5D'); 
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_5D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_5D');
    hu_Pomaa = uicontrol('Style','text','Visible','off','tag','Hpom1b_5Da');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval_5D');
    hu_good_valuea = uicontrol('Style','text','Visible','off','tag','Hu_gval_5Da');
    
    %%% objects for data 6d case %%%
    hu1a_6D = uicontrol('Style','text','Visible','off','tag','Hu1a_6D'); 
    hu1b_6D = uicontrol('Style','text','Visible','off','tag','Hu1b_6D'); 
    hu2a_6D = uicontrol('Style','text','Visible','off','tag','Hu2a_6D');     
    hu2b_6D = uicontrol('Style','text','Visible','off','tag','Hu2b_6D');     
    hu3a_6D = uicontrol('Style','text','Visible','off','tag','Hu3a_6D');     
    hu3b_6D = uicontrol('Style','text','Visible','off','tag','Hu3b_6D');     
    hu4a_6D = uicontrol('Style','text','Visible','off','tag','Hu4a_6D');     
    hu4b_6D = uicontrol('Style','text','Visible','off','tag','Hu4b_6D');     
    hu5a_6D = uicontrol('Style','text','Visible','off','tag','Hu5a_6D');     
    hu5b_6D = uicontrol('Style','text','Visible','off','tag','Hu5b_6D');     
    hu6a_6D = uicontrol('Style','text','Visible','off','tag','Hu6a_6D');     
    hu6b_6D = uicontrol('Style','text','Visible','off','tag','Hu6b_6D');     
    hu7a_6D = uicontrol('Style','text','Visible','off','tag','Hu7a_6D');     
    hu7b_6D = uicontrol('Style','text','Visible','off','tag','Hu7b_6D');     
    hu8a_6D = uicontrol('Style','text','Visible','off','tag','Hu8a_6D');     
    hu8b_6D = uicontrol('Style','text','Visible','off','tag','Hu8b_6D');     
    hu9a_6D = uicontrol('Style','text','Visible','off','tag','Hu9a_6D');     
    hu9b_6D = uicontrol('Style','text','Visible','off','tag','Hu9b_5D');     
    hu10a_6D = uicontrol('Style','text','Visible','off','tag','Hu10a_6D');     
    hu10b_6D = uicontrol('Style','text','Visible','off','tag','Hu10b_6D'); 
    hu11a_6D = uicontrol('Style','text','Visible','off','tag','Hu11a_6D');     
    hu11b_6D = uicontrol('Style','text','Visible','off','tag','Hu11b_6D'); 
    hu12a_6D = uicontrol('Style','text','Visible','off','tag','Hu12a_6D');     
    hu12b_6D = uicontrol('Style','text','Visible','off','tag','Hu12b_6D'); 
    hu13a_6D = uicontrol('Style','text','Visible','off','tag','Hu13a_6D');     
    hu13b_6D = uicontrol('Style','text','Visible','off','tag','Hu13b_6D'); 
    hu14a_6D = uicontrol('Style','text','Visible','off','tag','Hu14a_6D');     
    hu14b_6D = uicontrol('Style','text','Visible','off','tag','Hu14b_6D'); 
    hu15a_6D = uicontrol('Style','text','Visible','off','tag','Hu15a_6D');     
    hu15b_6D = uicontrol('Style','text','Visible','off','tag','Hu15b_6D'); 
    hu16a_6D = uicontrol('Style','text','Visible','off','tag','Hu16a_6D');     
    hu16b_6D = uicontrol('Style','text','Visible','off','tag','Hu16b_6D'); 
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_6D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_6D');
    hu_Pomaa = uicontrol('Style','text','Visible','off','tag','Hpom1b_6Da');
    hu_Pombb = uicontrol('Style','text','Visible','off','tag','Hpom1b_6Db');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval_6D');
    hu_good_valuea = uicontrol('Style','text','Visible','off','tag','Hu_gval_6Da');
    hu_good_valueb = uicontrol('Style','text','Visible','off','tag','Hu_gval_6Db');
    
    %%% objects for data 7d case %%%
    hu1a_7D = uicontrol('Style','text','Visible','off','tag','Hu1a_7D'); 
    hu1b_7D = uicontrol('Style','text','Visible','off','tag','Hu1b_7D'); 
    hu2a_7D = uicontrol('Style','text','Visible','off','tag','Hu2a_7D');     
    hu2b_7D = uicontrol('Style','text','Visible','off','tag','Hu2b_7D');     
    hu3a_7D = uicontrol('Style','text','Visible','off','tag','Hu3a_7D');     
    hu3b_7D = uicontrol('Style','text','Visible','off','tag','Hu3b_7D');     
    hu4a_7D = uicontrol('Style','text','Visible','off','tag','Hu4a_7D');     
    hu4b_7D = uicontrol('Style','text','Visible','off','tag','Hu4b_7D');     
    hu5a_7D = uicontrol('Style','text','Visible','off','tag','Hu5a_7D');     
    hu5b_7D = uicontrol('Style','text','Visible','off','tag','Hu5b_7D');     
    hu6a_7D = uicontrol('Style','text','Visible','off','tag','Hu6a_7D');     
    hu6b_7D = uicontrol('Style','text','Visible','off','tag','Hu6b_7D');     
    hu7a_7D = uicontrol('Style','text','Visible','off','tag','Hu7a_7D');     
    hu7b_7D = uicontrol('Style','text','Visible','off','tag','Hu7b_7D');     
    hu8a_7D = uicontrol('Style','text','Visible','off','tag','Hu8a_7D');     
    hu8b_7D = uicontrol('Style','text','Visible','off','tag','Hu8b_7D');     
    hu9a_7D = uicontrol('Style','text','Visible','off','tag','Hu9a_7D');     
    hu9b_7D = uicontrol('Style','text','Visible','off','tag','Hu9b_5D');     
    hu10a_7D = uicontrol('Style','text','Visible','off','tag','Hu10a_7D');     
    hu10b_7D = uicontrol('Style','text','Visible','off','tag','Hu10b_7D'); 
    hu11a_7D = uicontrol('Style','text','Visible','off','tag','Hu11a_7D');     
    hu11b_7D = uicontrol('Style','text','Visible','off','tag','Hu11b_7D'); 
    hu12a_7D = uicontrol('Style','text','Visible','off','tag','Hu12a_7D');     
    hu12b_7D = uicontrol('Style','text','Visible','off','tag','Hu12b_7D'); 
    hu13a_7D = uicontrol('Style','text','Visible','off','tag','Hu13a_7D');     
    hu13b_7D = uicontrol('Style','text','Visible','off','tag','Hu13b_7D'); 
    hu14a_7D = uicontrol('Style','text','Visible','off','tag','Hu14a_7D');     
    hu14b_7D = uicontrol('Style','text','Visible','off','tag','Hu14b_7D'); 
    hu15a_7D = uicontrol('Style','text','Visible','off','tag','Hu15a_7D');     
    hu15b_7D = uicontrol('Style','text','Visible','off','tag','Hu15b_7D'); 
    hu16a_7D = uicontrol('Style','text','Visible','off','tag','Hu16a_7D');     
    hu16b_7D = uicontrol('Style','text','Visible','off','tag','Hu16b_7D'); 
    hu17a_7D = uicontrol('Style','text','Visible','off','tag','Hu17a_7D');     
    hu17b_7D = uicontrol('Style','text','Visible','off','tag','Hu17b_7D'); 
    hu18a_7D = uicontrol('Style','text','Visible','off','tag','Hu18a_7D');     
    hu18b_7D = uicontrol('Style','text','Visible','off','tag','Hu18b_7D'); 
    hu19a_7D = uicontrol('Style','text','Visible','off','tag','Hu19a_7D');     
    hu19b_7D = uicontrol('Style','text','Visible','off','tag','Hu19b_7D'); 
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_7D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_7D');
    hu_Pomaa = uicontrol('Style','text','Visible','off','tag','Hpom1b_7Da');
    hu_Pombb = uicontrol('Style','text','Visible','off','tag','Hpom1b_7Db');
    hu_Pombc = uicontrol('Style','text','Visible','off','tag','Hpom1b_7Dc');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval_7D');
    hu_good_valuea = uicontrol('Style','text','Visible','off','tag','Hu_gval_7Da');
    hu_good_valueb = uicontrol('Style','text','Visible','off','tag','Hu_gval_7Db');
    hu_good_valuec = uicontrol('Style','text','Visible','off','tag','Hu_gval_7Dc');
    
    %%% objects for data 8d case %%%
    hu1a_8D = uicontrol('Style','text','Visible','off','tag','Hu1a_8D'); 
    hu1b_8D = uicontrol('Style','text','Visible','off','tag','Hu1b_8D'); 
    hu2a_8D = uicontrol('Style','text','Visible','off','tag','Hu2a_8D');     
    hu2b_8D = uicontrol('Style','text','Visible','off','tag','Hu2b_8D');     
    hu3a_8D = uicontrol('Style','text','Visible','off','tag','Hu3a_8D');     
    hu3b_8D = uicontrol('Style','text','Visible','off','tag','Hu3b_8D');     
    hu4a_8D = uicontrol('Style','text','Visible','off','tag','Hu4a_8D');     
    hu4b_8D = uicontrol('Style','text','Visible','off','tag','Hu4b_8D');     
    hu5a_8D = uicontrol('Style','text','Visible','off','tag','Hu5a_8D');     
    hu5b_8D = uicontrol('Style','text','Visible','off','tag','Hu5b_8D');     
    hu6a_8D = uicontrol('Style','text','Visible','off','tag','Hu6a_8D');     
    hu6b_8D = uicontrol('Style','text','Visible','off','tag','Hu6b_8D');     
    hu7a_8D = uicontrol('Style','text','Visible','off','tag','Hu7a_8D');     
    hu7b_8D = uicontrol('Style','text','Visible','off','tag','Hu7b_8D');     
    hu8a_8D = uicontrol('Style','text','Visible','off','tag','Hu8a_8D');     
    hu8b_8D = uicontrol('Style','text','Visible','off','tag','Hu8b_8D');     
    hu9a_8D = uicontrol('Style','text','Visible','off','tag','Hu9a_8D');     
    hu9b_8D = uicontrol('Style','text','Visible','off','tag','Hu9b_5D');     
    hu10a_8D = uicontrol('Style','text','Visible','off','tag','Hu10a_8D');     
    hu10b_8D = uicontrol('Style','text','Visible','off','tag','Hu10b_8D'); 
    hu11a_8D = uicontrol('Style','text','Visible','off','tag','Hu11a_8D');     
    hu11b_8D = uicontrol('Style','text','Visible','off','tag','Hu11b_8D'); 
    hu12a_8D = uicontrol('Style','text','Visible','off','tag','Hu12a_8D');     
    hu12b_8D = uicontrol('Style','text','Visible','off','tag','Hu12b_8D'); 
    hu13a_8D = uicontrol('Style','text','Visible','off','tag','Hu13a_8D');     
    hu13b_8D = uicontrol('Style','text','Visible','off','tag','Hu13b_8D'); 
    hu14a_8D = uicontrol('Style','text','Visible','off','tag','Hu14a_8D');     
    hu14b_8D = uicontrol('Style','text','Visible','off','tag','Hu14b_8D'); 
    hu15a_8D = uicontrol('Style','text','Visible','off','tag','Hu15a_8D');     
    hu15b_8D = uicontrol('Style','text','Visible','off','tag','Hu15b_8D'); 
    hu16a_8D = uicontrol('Style','text','Visible','off','tag','Hu16a_8D');     
    hu16b_8D = uicontrol('Style','text','Visible','off','tag','Hu16b_8D'); 
    hu17a_8D = uicontrol('Style','text','Visible','off','tag','Hu17a_8D');     
    hu17b_8D = uicontrol('Style','text','Visible','off','tag','Hu17b_8D'); 
    hu18a_8D = uicontrol('Style','text','Visible','off','tag','Hu18a_8D');     
    hu18b_8D = uicontrol('Style','text','Visible','off','tag','Hu18b_8D'); 
    hu19a_8D = uicontrol('Style','text','Visible','off','tag','Hu19a_8D');     
    hu19b_8D = uicontrol('Style','text','Visible','off','tag','Hu19b_8D'); 
    hu20a_8D = uicontrol('Style','text','Visible','off','tag','Hu20a_8D');
    hu20b_8D = uicontrol('Style','text','Visible','off','tag','Hu20b_8D'); 
    hu21a_8D = uicontrol('Style','text','Visible','off','tag','Hu21a_8D');
    hu21b_8D = uicontrol('Style','text','Visible','off','tag','Hu21b_8D'); 
    hu22a_8D = uicontrol('Style','text','Visible','off','tag','Hu22a_8D');
    hu22b_8D = uicontrol('Style','text','Visible','off','tag','Hu22b_8D'); 
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_8D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_8D');
    hu_Pomaa = uicontrol('Style','text','Visible','off','tag','Hpom1b_8Da');
    hu_Pombb = uicontrol('Style','text','Visible','off','tag','Hpom1b_8Db');
    hu_Pombc = uicontrol('Style','text','Visible','off','tag','Hpom1b_8Dc');
    hu_Pombd = uicontrol('Style','text','Visible','off','tag','Hpom1b_8Dd');
    hu_Pombe = uicontrol('Style','text','Visible','off','tag','Hpom1b_8De');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval_8D');
    hu_good_valuea = uicontrol('Style','text','Visible','off','tag','Hu_gval_8Da');
    hu_good_valueb = uicontrol('Style','text','Visible','off','tag','Hu_gval_8Db');
    hu_good_valuec = uicontrol('Style','text','Visible','off','tag','Hu_gval_8Dc');
    hu_good_valued = uicontrol('Style','text','Visible','off','tag','Hu_gval_8Dd');
    hu_good_valuee = uicontrol('Style','text','Visible','off','tag','Hu_gval_8De');
        
    %%% objects for data 9d case %%%
    hu1a_9D = uicontrol('Style','text','Visible','off','tag','Hu1a_9D'); 
    hu1b_9D = uicontrol('Style','text','Visible','off','tag','Hu1b_9D'); 
    hu2a_9D = uicontrol('Style','text','Visible','off','tag','Hu2a_9D');     
    hu2b_9D = uicontrol('Style','text','Visible','off','tag','Hu2b_9D');     
    hu3a_9D = uicontrol('Style','text','Visible','off','tag','Hu3a_9D');     
    hu3b_9D = uicontrol('Style','text','Visible','off','tag','Hu3b_9D');     
    hu4a_9D = uicontrol('Style','text','Visible','off','tag','Hu4a_9D');     
    hu4b_9D = uicontrol('Style','text','Visible','off','tag','Hu4b_9D');     
    hu5a_9D = uicontrol('Style','text','Visible','off','tag','Hu5a_9D');     
    hu5b_9D = uicontrol('Style','text','Visible','off','tag','Hu5b_9D');     
    hu6a_9D = uicontrol('Style','text','Visible','off','tag','Hu6a_9D');     
    hu6b_9D = uicontrol('Style','text','Visible','off','tag','Hu6b_9D');     
    hu7a_9D = uicontrol('Style','text','Visible','off','tag','Hu7a_9D');     
    hu7b_9D = uicontrol('Style','text','Visible','off','tag','Hu7b_9D');     
    hu8a_9D = uicontrol('Style','text','Visible','off','tag','Hu8a_9D');     
    hu8b_9D = uicontrol('Style','text','Visible','off','tag','Hu8b_9D');     
    hu9a_9D = uicontrol('Style','text','Visible','off','tag','Hu9a_9D');     
    hu9b_9D = uicontrol('Style','text','Visible','off','tag','Hu9b_9D');     
    hu10a_9D = uicontrol('Style','text','Visible','off','tag','Hu10a_9D');     
    hu10b_9D = uicontrol('Style','text','Visible','off','tag','Hu10b_9D'); 
    hu11a_9D = uicontrol('Style','text','Visible','off','tag','Hu11a_9D');     
    hu11b_9D = uicontrol('Style','text','Visible','off','tag','Hu11b_9D'); 
    hu12a_9D = uicontrol('Style','text','Visible','off','tag','Hu12a_9D');     
    hu12b_9D = uicontrol('Style','text','Visible','off','tag','Hu12b_9D'); 
    hu13a_9D = uicontrol('Style','text','Visible','off','tag','Hu13a_9D');     
    hu13b_9D = uicontrol('Style','text','Visible','off','tag','Hu13b_9D'); 
    hu14a_9D = uicontrol('Style','text','Visible','off','tag','Hu14a_9D');     
    hu14b_9D = uicontrol('Style','text','Visible','off','tag','Hu14b_9D'); 
    hu15a_9D = uicontrol('Style','text','Visible','off','tag','Hu15a_9D');     
    hu15b_9D = uicontrol('Style','text','Visible','off','tag','Hu15b_9D'); 
    hu16a_9D = uicontrol('Style','text','Visible','off','tag','Hu16a_9D');     
    hu16b_9D = uicontrol('Style','text','Visible','off','tag','Hu16b_9D'); 
    hu17a_9D = uicontrol('Style','text','Visible','off','tag','Hu17a_9D');     
    hu17b_9D = uicontrol('Style','text','Visible','off','tag','Hu17b_9D'); 
    hu18a_9D = uicontrol('Style','text','Visible','off','tag','Hu18a_9D');     
    hu18b_9D = uicontrol('Style','text','Visible','off','tag','Hu18b_9D'); 
    hu19a_9D = uicontrol('Style','text','Visible','off','tag','Hu19a_9D');     
    hu19b_9D = uicontrol('Style','text','Visible','off','tag','Hu19b_9D'); 
    hu20a_9D = uicontrol('Style','text','Visible','off','tag','Hu20a_9D');
    hu20b_9D = uicontrol('Style','text','Visible','off','tag','Hu20b_9D'); 
    hu21a_9D = uicontrol('Style','text','Visible','off','tag','Hu21a_9D');
    hu21b_9D = uicontrol('Style','text','Visible','off','tag','Hu21b_9D'); 
    hu22a_9D = uicontrol('Style','text','Visible','off','tag','Hu22a_9D');
    hu22b_9D = uicontrol('Style','text','Visible','off','tag','Hu22b_9D'); 
    hu23a_9D = uicontrol('Style','text','Visible','off','tag','Hu23a_9D');
    hu23b_9D = uicontrol('Style','text','Visible','off','tag','Hu23b_9D'); 
    hu24a_9D = uicontrol('Style','text','Visible','off','tag','Hu24a_9D');
    hu24b_9D = uicontrol('Style','text','Visible','off','tag','Hu24b_9D'); 
    hu25a_9D = uicontrol('Style','text','Visible','off','tag','Hu25a_9D');
    hu25b_9D = uicontrol('Style','text','Visible','off','tag','Hu25b_9D'); 
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_9D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_9D');
    hu_Pomaa = uicontrol('Style','text','Visible','off','tag','Hpom1b_9Da');
    hu_Pombb = uicontrol('Style','text','Visible','off','tag','Hpom1b_9Db');
    hu_Pombc = uicontrol('Style','text','Visible','off','tag','Hpom1b_9Dc');
    hu_Pombd = uicontrol('Style','text','Visible','off','tag','Hpom1b_9Dd');
    hu_Pombe = uicontrol('Style','text','Visible','off','tag','Hpom1b_9De');
    hu_Pombf = uicontrol('Style','text','Visible','off','tag','Hpom1b_9Df');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval_9D');
    hu_good_valuea = uicontrol('Style','text','Visible','off','tag','Hu_gval_9Da');
    hu_good_valueb = uicontrol('Style','text','Visible','off','tag','Hu_gval_9Db');
    hu_good_valuec = uicontrol('Style','text','Visible','off','tag','Hu_gval_9Dc');
    hu_good_valued = uicontrol('Style','text','Visible','off','tag','Hu_gval_9Dd');
    hu_good_valuee = uicontrol('Style','text','Visible','off','tag','Hu_gval_9De');
    hu_good_valuef = uicontrol('Style','text','Visible','off','tag','Hu_gval_9Df');
    
    %%% objects for data 10d case %%%
    hu1a_10D = uicontrol('Style','text','Visible','off','tag','Hu1a_10D'); 
    hu1b_10D = uicontrol('Style','text','Visible','off','tag','Hu1b_10D'); 
    hu2a_10D = uicontrol('Style','text','Visible','off','tag','Hu2a_10D');     
    hu2b_10D = uicontrol('Style','text','Visible','off','tag','Hu2b_10D');     
    hu3a_10D = uicontrol('Style','text','Visible','off','tag','Hu3a_10D');     
    hu3b_10D = uicontrol('Style','text','Visible','off','tag','Hu3b_10D');     
    hu4a_10D = uicontrol('Style','text','Visible','off','tag','Hu4a_10D');     
    hu4b_10D = uicontrol('Style','text','Visible','off','tag','Hu4b_10D');     
    hu5a_10D = uicontrol('Style','text','Visible','off','tag','Hu5a_10D');     
    hu5b_10D = uicontrol('Style','text','Visible','off','tag','Hu5b_10D');     
    hu6a_10D = uicontrol('Style','text','Visible','off','tag','Hu6a_10D');     
    hu6b_10D = uicontrol('Style','text','Visible','off','tag','Hu6b_10D');     
    hu7a_10D = uicontrol('Style','text','Visible','off','tag','Hu7a_10D');     
    hu7b_10D = uicontrol('Style','text','Visible','off','tag','Hu7b_10D');     
    hu8a_10D = uicontrol('Style','text','Visible','off','tag','Hu8a_10D');     
    hu8b_10D = uicontrol('Style','text','Visible','off','tag','Hu8b_10D');     
    hu9a_10D = uicontrol('Style','text','Visible','off','tag','Hu9a_10D');     
    hu9b_10D = uicontrol('Style','text','Visible','off','tag','Hu9b_10D');     
    hu10a_10D = uicontrol('Style','text','Visible','off','tag','Hu10a_10D');     
    hu10b_10D = uicontrol('Style','text','Visible','off','tag','Hu10b_10D'); 
    hu11a_10D = uicontrol('Style','text','Visible','off','tag','Hu11a_10D');     
    hu11b_10D = uicontrol('Style','text','Visible','off','tag','Hu11b_10D'); 
    hu12a_10D = uicontrol('Style','text','Visible','off','tag','Hu12a_10D');     
    hu12b_10D = uicontrol('Style','text','Visible','off','tag','Hu12b_10D'); 
    hu13a_10D = uicontrol('Style','text','Visible','off','tag','Hu13a_10D');     
    hu13b_10D = uicontrol('Style','text','Visible','off','tag','Hu13b_10D'); 
    hu14a_10D = uicontrol('Style','text','Visible','off','tag','Hu14a_10D');     
    hu14b_10D = uicontrol('Style','text','Visible','off','tag','Hu14b_10D'); 
    hu15a_10D = uicontrol('Style','text','Visible','off','tag','Hu15a_10D');     
    hu15b_10D = uicontrol('Style','text','Visible','off','tag','Hu15b_10D'); 
    hu16a_10D = uicontrol('Style','text','Visible','off','tag','Hu16a_10D');     
    hu16b_10D = uicontrol('Style','text','Visible','off','tag','Hu16b_10D'); 
    hu17a_10D = uicontrol('Style','text','Visible','off','tag','Hu17a_10D');     
    hu17b_10D = uicontrol('Style','text','Visible','off','tag','Hu17b_10D'); 
    hu18a_10D = uicontrol('Style','text','Visible','off','tag','Hu18a_10D');     
    hu18b_10D = uicontrol('Style','text','Visible','off','tag','Hu18b_10D'); 
    hu19a_10D = uicontrol('Style','text','Visible','off','tag','Hu19a_10D');     
    hu19b_10D = uicontrol('Style','text','Visible','off','tag','Hu19b_10D'); 
    hu20a_10D = uicontrol('Style','text','Visible','off','tag','Hu20a_10D');
    hu20b_10D = uicontrol('Style','text','Visible','off','tag','Hu20b_10D'); 
    hu21a_10D = uicontrol('Style','text','Visible','off','tag','Hu21a_10D');
    hu21b_10D = uicontrol('Style','text','Visible','off','tag','Hu21b_10D'); 
    hu22a_10D = uicontrol('Style','text','Visible','off','tag','Hu22a_10D');
    hu22b_10D = uicontrol('Style','text','Visible','off','tag','Hu22b_10D'); 
    hu23a_10D = uicontrol('Style','text','Visible','off','tag','Hu23a_10D');
    hu23b_10D = uicontrol('Style','text','Visible','off','tag','Hu23b_10D'); 
    hu24a_10D = uicontrol('Style','text','Visible','off','tag','Hu24a_10D');
    hu24b_10D = uicontrol('Style','text','Visible','off','tag','Hu24b_10D'); 
    hu25a_10D = uicontrol('Style','text','Visible','off','tag','Hu25a_10D');
    hu25b_10D = uicontrol('Style','text','Visible','off','tag','Hu25b_10D'); 
    hu26a_10D = uicontrol('Style','text','Visible','off','tag','Hu26a_10D');
    hu26b_10D = uicontrol('Style','text','Visible','off','tag','Hu26b_10D'); 
    hu27a_10D = uicontrol('Style','text','Visible','off','tag','Hu27a_10D');
    hu27b_10D = uicontrol('Style','text','Visible','off','tag','Hu27b_10D'); 
    hu28a_10D = uicontrol('Style','text','Visible','off','tag','Hu28a_10D');
    hu28b_10D = uicontrol('Style','text','Visible','off','tag','Hu28b_10D'); 
    hu_POMa = uicontrol('Style','text','Visible','off','tag','Hpom1a_10D');
    hu_Pomb = uicontrol('Style','text','Visible','off','tag','Hpom1b_10D');
    hu_Pomaa = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Da');
    hu_Pombb = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Db');
    hu_Pombc = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Dc');
    hu_Pombd = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Dd');
    hu_Pombe = uicontrol('Style','text','Visible','off','tag','Hpom1b_10De');
    hu_Pombf = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Df');
    hu_Pombg = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Dg');
    hu_Pombh = uicontrol('Style','text','Visible','off','tag','Hpom1b_10Dh');
    hu_good_value = uicontrol('Style','text','Visible','off','tag','Hu_gval_10D');
    hu_good_valuea = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Da');
    hu_good_valueb = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Db');
    hu_good_valuec = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Dc');
    hu_good_valued = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Dd');
    hu_good_valuee = uicontrol('Style','text','Visible','off','tag','Hu_gval_10De');
    hu_good_valuef = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Df');
    hu_good_valueg = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Dg');
    hu_good_valueh = uicontrol('Style','text','Visible','off','tag','Hu_gval_10Dh');
    
    %%% uicontrols %%%
    
    %%% temporary uicontrols %%%
    
    hp1 = uicontrol('Style','text','Visible','off','tag','hp_11'); 
    hp2 = uicontrol('Style','text','Visible','off','tag','hp_12');
    
    %%% main frame for Approximation section %%%
    h1 = uicontrol('Units','normalized','Position',[0.05 0.6 0.5 0.3],...
        'Style','Frame','tag','2D_funs');
    
    %%% radio buttons %%%
    h2 = uicontrol('Units','normalized','Style','radio','Tag','but1','value',1,...
        'Position',[0.08 0.84 0.05 0.03],'Backgroundcolor',get(gcf,'Color'),'Callback','autoprox_gui BUT1');
    h3 = uicontrol('Units','normalized','Style','radio','Tag','but2',...
        'Position',[0.08 0.79 0.05 0.03],'Backgroundcolor',get(gcf,'Color'),'Callback','autoprox_gui BUT2');        
    h4 = uicontrol('Units','normalized','Style','radio','Tag','but3',...
        'Position',[0.08 0.74 0.05 0.03],'Backgroundcolor',get(gcf,'Color'),'Callback','autoprox_gui BUT3');        
    h5 = uicontrol('Units','normalized','Style','radio','Tag','but4',...
        'Position',[0.08 0.69 0.05 0.03],'Backgroundcolor',get(gcf,'Color'),'Callback','autoprox_gui BUT4');        
    h6 = uicontrol('Units','normalized','Style','radio','Tag','but5',...
        'Position',[0.08 0.64 0.05 0.03],'Backgroundcolor',get(gcf,'Color'),'Callback','autoprox_gui BUT5');        
       
    
    %%% texts for radio buttons %%%
    h7 = uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'String','Approximation','Position',[0.19 0.82 0.2 0.1],...
        'fontsize',12,'Foregroundcolor','black','fontweight','bold');
    h8 = uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'String','1D_Approximation','Position',[0.11 0.77 0.17 0.1]);
    h9 = uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'String','2D_Approximation','Position',[0.11 0.72 0.17 0.1]);
    h10= uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'String','ND_Approximation','Position',[0.11 0.67 0.17 0.1]);
    h11= uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'String','Approximation(sum of products)','Position',[0.103 0.62 0.3 0.1]);
    h12= uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'String','Differential equation','Position',[0.102 0.62 0.2 0.05]);
    
    %%% Setup section %%%
    h13=uicontrol('Units','normalized','Position',[0.6 0.46 0.35 0.44],'style','frame');
    
    %%% text for setup section %%%
    h14=uicontrol('Units','normalized','position',[0.73 0.82 0.1 0.1],...
        'Style','text','String','Setup','Backgroundcolor',get(gcf,'Color'),...
        'Foregroundcolor','black','fontweight','bold','fontsize',12);
    
    %%% edit blocks %%%
    h15 = uicontrol('units','normalized','position',[0.63 0.81 0.3 0.06],...
        'Style','text','Backgroundcolor',get(gcf,'Color'),'String','FUNCTION','tag','funpos');
    h16 = uicontrol('Units','normalized','position',[0.64 0.77 0.28 0.06],'Style','edit',...
        'Foregroundcolor','black','Backgroundcolor','white','tag','fun');
    h17 = uicontrol('units','normalized','position',[0.63 0.7 0.3 0.06],'Style','text',...
        'Foregroundcolor','black','backgroundcolor',get(gcf,'Color'),'String','XMIN');
    h18 = uicontrol('Units','normalized','position',[0.64 0.66 0.28 0.06],'Style','edit',...
        'Foregroundcolor','black','Backgroundcolor','white','tag','Lbound');
    h19 = uicontrol('Units','normalized','position',[0.63 0.58 0.3 0.06],'Style','text',...
        'Foregroundcolor','black','Backgroundcolor',get(gcf,'Color'),'String','XMAX');
    h20 = uicontrol('Units','normalized','position',[0.64 0.54 0.28 0.06],'Style','edit',...
        'Foregroundcolor','black','Backgroundcolor','white','tag','Ubound');
    h21 = uicontrol('Units','normalized','position',[0.61 0.48 0.27 0.03],'Style','text','tag','text_apps',...
        'Foregroundcolor','black','Backgroundcolor','white','String','NUMBER_OF_REGIONS','Visible','off');
    h22 = uicontrol('Units','normalized','position',[0.85 0.472 0.07 0.05],'Style','Popup',...
        'Foregroundcolor','black','Backgroundcolor','white','tag','apps',...
        'String','1|2|3|4|5|6|7|8|9|10|11|12|13|14|15','Visible','off'); 
    h22_text = uicontrol('Units','normalized','position',[0.75 0.465 0.08 0.05],'Style','text','tag','regs',...
        'Foregroundcolor','black','Backgroundcolor',get(gcf,'Color'),'Visible','on','String','REGIONS');
    h22a = uicontrol('Units','normalized','position',[0.645 0.471 0.27 0.05],'Callback','autoprox_gui plot_fun',...
         'Foregroundcolor','black','Backgroundcolor',get(gcf,'Color'),'tag','origi_fun','String','Plotting the original function');
    
    %%% reset uicontrols %%%
    hp1 = uicontrol('Units','normalized','Style','push','Position',[0.637 0.48 0.07 0.04],'Foregroundcolor','black',...
         'Backgroundcolor',get(gcf,'Color'),'Visible','off','Callback','autoprox_gui reset','tag','h_temp','String','New','fontsize',12);
    
    %%% PWA section %%%
    h23 = uicontrol('Units','normalized','position',[0.05 0.46 0.5 0.1],'Style','Frame',...
         'Backgroundcolor',get(gcf,'Color'));
    h24 = uicontrol('Units','normalized','position',[0.17 0.48 0.28 0.1],'Style','text',...
         'String','Generate PWA functions','fontsize',12,'fontweight','bold');
    h25 = uicontrol('Units','normalized','position',[0.07 0.48 0.24 0.05],'String','Plotting the approximation',...
         'Foregroundcolor','black','Backgroundcolor',get(gcf,'Color'),'Callback','autoprox_gui plot');   
    h43 = uicontrol('Units','normalized','position',[0.34 0.48 0.15 0.05],...
         'Foregroundcolor','black','Backgroundcolor',get(gcf,'Color'),'String','SPLIT','Callback','autoprox_gui spl');
      
    %%% Approximation summary section %%%
    h26 = uicontrol('Units','normalized','position',[0.05 0.2 0.9 0.2],'Style','Frame',...
        'Backgroundcolor',get(gcf,'Color'));
    hpom1 = uicontrol('Units','normalized','position',[0.0607 0.32 0.06 0.05],'Style','text',...
         'String','f = ','Visible','off','tag','hp1');
    hpom1a = uicontrol('Units','normalized','position',[0.1 0.32 0.06 0.05],'Style','text',...
         'Visible','off','tag','hp1a');
    hpom2 = uicontrol('Units','normalized','position',[0.065 0.27 0.15 0.05],'Style','text',...
         'String','lower bound = ','Visible','off','tag','hp2');  
    hpom2a = uicontrol('Units','normalized','position',[0.2 0.27 0.05 0.05],'Style','text',...
          'Visible','off','tag','hp2a');   
    hpom3 = uicontrol('Units','normalized','position',[0.0658 0.22 0.15 0.05],'Style','text',...
         'String','upper bound = ','Visible','off','tag','hp3');
    hpom3a = uicontrol('Units','normalized','position',[0.2 0.22 0.05 0.05],'Style','text',...
         'Visible','off','tag','hp3a');
    hpom4 = uicontrol('Units','normalized','position',[0.31 0.32 0.1 0.05],'Style','text',...
         'String','regions: ','tag','hp4','Visible','off');
    hpom4a = uicontrol('Units','normalized','position',[0.39 0.34 0.03 0.03],'Style','text',...
         'tag','hp4a','Visible','off','Foregroundcolor','black'); 
    hpom5 = uicontrol('Units','normalized','Style','text','Backgroundcolor',get(gcf,'Color'),...
        'position',[0.308 0.27 0.15 0.05],'Foregroundcolor','black','String','average_error:','tag','hp5','Visible','off');
    hpom6 = uicontrol('Units','normalized','Style','text',...
        'position',[0.44 0.27 0.1 0.05],'Backgroundcolor',get(gcf,'Color'),...
        'Foregroundcolor','black','tag','hp6','Visible','off');
    hpom7 = uicontrol('Units','normalized','position',[0.30 0.22 0.15 0.05],'Style','text',...
        'Foregroundcolor','black','String','worst_error:','tag','hp7','Visible','off');
    hpom8 = uicontrol('Units','normalized','position',[0.44 0.22 0.1 0.05],'Style','text',...
        'Foregroundcolor','black','tag','hp8','Visible','off'); 
   
    %%% text for Apprx summary section %%%
    h27 = uicontrol('Units','normalized','position',[0.35 0.37 0.3 0.05],'Style','text',...
        'Backgroundcolor',get(gcf,'Color'),'String','Approximation summary','Fontsize',12,...
        'fontweight','bold');
    
    %%% frame for post-processing %%%
    h28 = uicontrol('Units','normalized','position',[0.05 0.05 0.9 0.1],'Style','Frame',...
        'Backgroundcolor',get(gcf,'Color'));
    
    %%% text for post-processing frame %%%
    h29 = uicontrol('units','normalized','position',[0.4 0.07 0.2 0.1],'Style','text',...
        'Backgroundcolor',get(gcf,'Color'),'String','Post-processing','fontsize',12,...
        'fontweight','bold');
    
    %%% finish and export buttons %%%
    h30 = uicontrol('units','normalized','position',[0.75 0.08 0.1 0.05],'String','FINISH',...
        'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','Callback','autoprox_gui end','tag','finish');
    h31 = uicontrol('units','normalized','position',[0.40 0.08 0.2 0.05],'String','f1_approx.hys',...
        'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','Style','edit','Tag','fname');
    h32 = uicontrol('units','normalized','position',[0.15 0.08 0.1 0.05],'String','EXPORT',...
        'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','Callback','autoprox_gui export');
      
   
else
    switch(input)
        case('BUT1')
            set(findobj('Tag','but2'),'value',0);
            set(findobj('Tag','but3'),'value',0);
            set(findobj('Tag','but4'),'value',0);
            set(findobj('Tag','but5'),'value',0);
            th1 = findobj('tag','hp1');
            th1a = findobj('tag','hp1a');
            th2 = findobj('tag','hp2');
            th2a = findobj('tag','hp2a');
            th3 = findobj('tag','hp3');
            th3a = findobj('tag','hp3a');
            th4 = findobj('tag','hp4');
            th4a = findobj('tag','hp4a');
            tp1 = findobj('tag','hp5');
            tp2 = findobj('tag','hp6');
            tp3 = findobj('tag','hp7');
            tp4 = findobj('tag','hp8');
            th5 = findobj('tag','report1');
            th6 = findobj('tag','report2');
            th7 = findobj('tag','report3');
            th8 = findobj('tag','report4');
            th9 = findobj('tag','report5');
            th10 = findobj('tag','report6');
            th11 = findobj('tag','apps1');
            th12 = findobj('tag','2D');
            tha = findobj('tag','fun');
            thb = findobj('tag','Lbound');
            thc = findobj('tag','Ubound');
            tr1 = findobj('tag','r1');
            tr2 = findobj('tag','r2');
            tr11 = findobj('tag','r1text');
            tr12 = findobj('tag','r2text');
            tr13 = findobj('tag','apps');
            tr14 = findobj('tag','origi_fun');
%             tr15 = findobj('tag','hi_avg');
%             tr16 = findobj('tag','hd_avg');
%             tr17 = findobj('tag','hi_wst');
%             tr18 = findobj('tag','hd_wst');
            set(findobj('tag','funpos'),'position',[0.63 0.81 0.3 0.06]);
            set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8 th9 th10 th11 th12 tr1 tr2 tr11 tr12 tr13],'Visible','off');
            set([tp1 tp2 tp3 tp4],'Visible','off');
            set([tha thb thc],'Visible','on','String','');
            set(tr14,'Visible','on');
            set(findobj('tag','h_temp'),'Visible','off');
            set(findobj('tag','regs'),'Visible','off');
         case('BUT2')
            set(findobj('Tag','but1'),'value',0);
            set(findobj('Tag','but3'),'value',0);
            set(findobj('Tag','but4'),'value',0);
            set(findobj('Tag','but5'),'value',0);
            th1 = findobj('tag','hp1');
            th1a = findobj('tag','hp1a');
            th2 = findobj('tag','hp2');
            th2a = findobj('tag','hp2a');
            th3 = findobj('tag','hp3');
            th3a = findobj('tag','hp3a');
            th4 = findobj('tag','hp4');
            th4a = findobj('tag','hp4a');
            tp1 = findobj('tag','hp5');
            tp2 = findobj('tag','hp6');
            tp3 = findobj('tag','hp7');
            tp4 = findobj('tag','hp8');
            th5 = findobj('tag','report1');
            th6 = findobj('tag','report2');
            th7 = findobj('tag','report3');
            th8 = findobj('tag','report4');
            th9 = findobj('tag','report5');
            th10 =findobj('tag','report6');
            th11 = findobj('tag','apps1');
            th12 = findobj('tag','2D');
            tha = findobj('tag','fun');
            thb = findobj('tag','Lbound');
            thc = findobj('tag','Ubound');
            tr1 = findobj('tag','r1');
            tr2 = findobj('tag','r2');
            tr11 = findobj('tag','r1text');
            tr12 = findobj('tag','r2text');
            tr13 = findobj('tag','apps');
            tr14 = findobj('tag','origi_fun');
%             tr15 = findobj('tag','hi_avg');
%             tr16 = findobj('tag','hd_avg');
%             tr17 = findobj('tag','hi_wst');
%             tr18 = findobj('tag','hd_wst');
            set(findobj('tag','funpos'),'position',[0.63 0.81 0.3 0.06]);
            set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8 th9 th10 th11 th12 tr1 tr2 tr11 tr12 tr13],'Visible','off');
            set([tp1 tp2 tp3 tp4],'Visible','off');
            set([tha thb thc],'Visible','on','String','');
            set(tr14,'Visible','on');
            set(findobj('tag','h_temp'),'Visible','off');
            set(findobj('tag','regs'),'Visible','off');
          case('BUT3')
            set(findobj('Tag','but1'),'value',0);
            set(findobj('Tag','but2'),'value',0);
            set(findobj('Tag','but4'),'value',0);
            set(findobj('Tag','but5'),'value',0);
            th1 = findobj('tag','hp1');
            th1a = findobj('tag','hp1a');
            th2 = findobj('tag','hp2');
            th2a = findobj('tag','hp2a');
            th3 = findobj('tag','hp3');
            th3a = findobj('tag','hp3a');
            th4 = findobj('tag','hp4');
            th4a = findobj('tag','hp4a');
            tp1 = findobj('tag','hp5');
            tp2 = findobj('tag','hp6');
            tp3 = findobj('tag','hp7');
            tp4 = findobj('tag','hp8');
            th5 = findobj('tag','report1');
            th6 = findobj('tag','report2');
            th7 = findobj('tag','report3');
            th8 = findobj('tag','report4');
            th9 = findobj('tag','report5');
            th10 = findobj('tag','report6');
            th11 = findobj('tag','apps1');
            th12 = findobj('tag','2D');
            tha = findobj('tag','fun');
            thb = findobj('tag','Lbound');
            thc = findobj('tag','Ubound');
            tr1 = findobj('tag','r1');
            tr2 = findobj('tag','r2');
            tr11 = findobj('tag','r1text');
            tr12 = findobj('tag','r2text');
            tr13 = findobj('tag','apps');
            tr14 = findobj('tag','origi_fun');
            set(findobj('tag','funpos'),'position',[0.63 0.81 0.3 0.06]);
            set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8 th9 th10 th11 th12 tr1 tr2 tr11 tr12 tr13],'Visible','off');
            set([tp1 tp2 tp3 tp4],'Visible','off');
            set([tha thb thc],'Visible','on','String','');
            set(tr14,'Visible','on');
            set(findobj('tag','h_temp'),'Visible','off');
            set(findobj('tag','regs'),'Visible','off');
         case('BUT4')
            set(findobj('Tag','but1'),'value',0);
            set(findobj('Tag','but2'),'value',0);
            set(findobj('Tag','but3'),'value',0);
            set(findobj('Tag','but5'),'value',0);
            th1 = findobj('tag','hp1');
            th1a = findobj('tag','hp1a');
            th2 = findobj('tag','hp2');
            th2a = findobj('tag','hp2a');
            th3 = findobj('tag','hp3');
            th3a = findobj('tag','hp3a');
            th4 = findobj('tag','hp4');
            th4a = findobj('tag','hp4a');
            tp1 = findobj('tag','hp5');
            tp2 = findobj('tag','hp6');
            tp3 = findobj('tag','hp7');
            tp4 = findobj('tag','hp8');
            th5 = findobj('tag','report1');
            th6 = findobj('tag','report2');
            th7 = findobj('tag','report3');
            th8 = findobj('tag','report4');
            th9 = findobj('tag','report5');
            th10 = findobj('tag','report6');
            th11 = findobj('tag','apps1');
            th12 = findobj('tag','2D');
            tha = findobj('tag','fun');
            thb = findobj('tag','Lbound');
            thc = findobj('tag','Ubound');
            tr1 = findobj('tag','r1');
            tr2 = findobj('tag','r2');
            tr11 = findobj('tag','r1text');
            tr12 = findobj('tag','r2text');
            tr13 = findobj('tag','apps');
            tr14 = findobj('tag','origi_fun')
%             tr15 = findobj('tag','hi_avg');
%             tr16 = findobj('tag','hd_avg');
%             tr17 = findobj('tag','hi_wst');
%             tr18 = findobj('tag','hd_wst');
            set(findobj('tag','funpos'),'position',[0.63 0.81 0.3 0.06]);
            set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8 th9 th10 th11 th12 tr1 tr2 tr12 tr11 tr13],'Visible','off');
            set([tp1 tp2 tp3 tp4],'Visible','off');
            set([tha thb thc],'Visible','on','String','');
            set(tr14,'Visible','on');
            set(findobj('tag','h_temp'),'Visible','off');
            set(findobj('tag','regs'),'Visible','off');
        case('BUT5')
            set(findobj('Tag','but1'),'value',0);
            set(findobj('Tag','but2'),'value',0);
            set(findobj('Tag','but3'),'value',0);
            set(findobj('Tag','but4'),'value',0);
         
        case('reset')    
            set(findobj('tag','apps'),'Visible','off');            
            set(findobj('tag','origi_fun'),'Visible','on');
            set(findobj('tag','h_temp'),'Visible','off');
            
        case('plot_fun')   
        var1 = get(findobj('Tag','but1'),'Value');    
        var2 = get(findobj('Tag','but2'),'Value');    
        var3 = get(findobj('Tag','but3'),'Value');
        if(var1)
            func = get(findobj('tag','fun'),'String');
            f_mf = matlabFunction(sym(func));
            xbmin = get(findobj('tag','Lbound'),'String');
            xbmin = str2num(xbmin);
            xbmax = get(findobj('tag','Ubound'),'String');
            xbmax = str2num(xbmax);
            args = linspace(xbmin,xbmax,50);
            F2 = findobj('Tag','figure2');
            if(isempty(F2))
                Monitor = get(0,'Screensize');
                F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                    'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                    'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                set(F2,'visible','on');
                plot(args,f_mf(args),'b-','linewidth', 2);
                legend(char(sym(f_mf)), 'Location', 'Best');
            else
                set(F2,'visible','on');
                figure(F2);
                plot(args,f_mf(args),'b-','linewidth', 2);
                legend(char(sym(f_mf)), 'Location', 'Best');
            end
            set(findobj('tag','origi_fun'),'Visible','off');
            set(findobj('tag','apps'),'Visible','on');
            set(findobj('tag','regs'),'Visible','on');
            set(findobj('tag','h_temp'),'Visible','on');   
        end
        if(var2)
           func = get(findobj('tag','fun'),'String')
           func1 = sym(func)
           vars = findsym(func1)
           vars = sym(vars)
           [L,V] = split(func,vars)
           [subL,subV] = separate_functions(L,V)
           f = obtain_subfunctions(subL,subV)
           xbmin = get(findobj('tag','Lbound'),'String');
           xbmin1 = str2num(xbmin);
           xbmax = get(findobj('tag','Ubound'),'String');
           xbmax1 = str2num(xbmax);
           ns = get(findobj('tag','apps'),'Value');
                                           
           f1 = matlabFunction(sym(f{1}{1}));
           f2 = matlabFunction(sym(f{1}{2}));
           syms u1 u2
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
                                
           if(value_of_popup == 1)
               args = linspace(xbmin1(1),xbmax1(1),50);
               F2 = findobj('Tag','figure2');
               f_mf = f1;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
               set(findobj('Tag','origi_fun'),'Visible','off');
               set(findobj('Tag','apps'),'Visible','on');
           elseif(value_of_popup == 2)
               args = linspace(xbmin1(2),xbmax1(2),50);
               F2 = findobj('Tag','figure2');
               f_mf = f2;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
               set(findobj('Tag','origi_fun'),'Visible','off');
               set(findobj('Tag','apps'),'Visible','on');
           elseif(value_of_popup == 3)
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','but1'),'Userdata');
                   f2lin = get(findobj('tag','but2'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(sym(f_mf)), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(sym(f_mf)), 'Location', 'Best');
                   end 
                   set(findobj('Tag','origi_fun'),'Visible','off');
                   set(findobj('Tag','apps'),'Visible','on');
           else
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','but1'),'Userdata');
                   f2lin = get(findobj('tag','but2'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(sym(f_mf)), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(sym(f_mf)), 'Location', 'Best');
                   end 
                   set(findobj('Tag','origi_fun'),'Visible','off');
                   set(findobj('Tag','apps'),'Visible','on');
           end
           set(findobj('tag','h_temp'),'Visible','on');    
           set(findobj('tag','regs'),'Visible','on');
        end
        pocet = 0;
        counter = 0;
        if(var3)
           func = get(findobj('tag','fun'),'String');
           func1 = sym(func);
           vars = findsym(func1)
           class(vars)
           [L,V] = split(func,vars);
           [subL,subV] = separate_functions(L,V);
           set(findobj('tag','Hu_sym'),'Userdata',subV);
           f = obtain_subfunctions(subL,subV);
           xbmin = get(findobj('tag','Lbound'),'String');
           xbmin1 = str2num(xbmin);
           set(findobj('tag','Hu_b1'),'Userdata',xbmin1);
           xbmax = get(findobj('tag','Ubound'),'String');
           xbmax1 = str2num(xbmax);
           set(findobj('tag','Hu_b2'),'Userdata',xbmax1);
           ns = get(findobj('tag','apps'),'Value');
           temp_result = findstr(vars,',');
           temp_result = length(temp_result);
           temp_result = temp_result + 1;
           set(findobj('tag','to_export'),'Userdata',temp_result);
           syms u1 u2 u3 u4 u5 u6 u7 
           if(temp_result == 3)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = @(u1) 0.25*u1.^2;
               f5 = @(u2) 0.25*u2.^2;
               f6 = @(u3) 0.25*u3.^2;
               f7 = @(u4) 0.25*u4.^2;
           elseif(temp_result == 4)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = @(u1) 0.25*u1.^2;
               f6 = @(u2) 0.25*u2.^2;
               f7 = @(u3) 0.25*u3.^2;
               f8 = @(u4) 0.25*u4.^2;
               f9 = @(u5) 0.25*u5.^2;
               f10 =@(u6) 0.25*u6.^2;
               f11 =@(u7) 0.25*u7.^2;
               f12 =@(u8) 0.25*u8.^2;
           elseif(temp_result == 5)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = @(u1) 0.25*u1.^2;
               f7 = @(u2) 0.25*u2.^2;
               f8 = @(u3) 0.25*u3.^2;
               f9 = @(u4) 0.25*u4.^2;
               f10 =@(u5) 0.25*u5.^2;
               f11 =@(u6) 0.25*u6.^2;
               f12 =@(u7) 0.25*u7.^2;
               f13 =@(u8) 0.25*u8.^2;
               f14 =@(u9) 0.25*u9.^2;
               f15 =@(u10) 0.25*u10.^2;
           elseif(temp_result == 6)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = @(u1) 0.25*u1.^2;
               f8 = @(u2) 0.25*u2.^2;
               f9 = @(u3) 0.25*u3.^2;
               f10 = @(u4) 0.25*u4.^2;
               f11 =@(u5) 0.25*u5.^2;
               f12 =@(u6) 0.25*u6.^2;
               f13 =@(u7) 0.25*u7.^2;
               f14 =@(u8) 0.25*u8.^2;
               f15 =@(u9) 0.25*u9.^2;
               f16 =@(u10) 0.25*u10.^2;
               f17 =@(u11) 0.25*u11.^2;
               f18 =@(u12) 0.25*u12.^2;
            elseif(temp_result == 7)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = @(u1) 0.25*u1.^2;
               f9 = @(u2) 0.25*u2.^2;
               f10 = @(u3) 0.25*u3.^2;
               f11 = @(u4) 0.25*u4.^2;
               f12 =@(u5) 0.25*u5.^2;
               f13 =@(u6) 0.25*u6.^2;
               f14 =@(u7) 0.25*u7.^2;
               f15 =@(u8) 0.25*u8.^2;
               f16 =@(u9) 0.25*u9.^2;
               f17 =@(u10) 0.25*u10.^2;
               f18 =@(u11) 0.25*u11.^2;
               f19 =@(u12) 0.25*u12.^2;
               f20 =@(u13) 0.25*u13.^2;
               f21 =@(u14) 0.25*u14.^2;
           elseif(temp_result == 8)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = matlabFunction(sym(f{1}{8}));
               f9 = @(u1) 0.25*u1.^2;
               f10 = @(u2) 0.25*u2.^2;
               f11 = @(u3) 0.25*u3.^2;
               f12 = @(u4) 0.25*u4.^2;
               f13 =@(u5) 0.25*u5.^2;
               f14 =@(u6) 0.25*u6.^2;
               f15 =@(u7) 0.25*u7.^2;
               f16 =@(u8) 0.25*u8.^2;
               f17 =@(u9) 0.25*u9.^2;
               f18 =@(u10) 0.25*u10.^2;
               f19 =@(u11) 0.25*u11.^2;
               f20 =@(u12) 0.25*u12.^2;
               f21 =@(u13) 0.25*u13.^2;
               f22 =@(u14) 0.25*u14.^2;
               f23 =@(u15) 0.25*u15.^2;
               f24 =@(u16) 0.25*u16.^2;
           elseif(temp_result == 9)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = matlabFunction(sym(f{1}{8}));
               f9 = matlabFunction(sym(f{1}{9}));
               f10 = @(u1) 0.25*u1^2;
               f11 = @(u2) 0.25*u2.^2;
               f12 = @(u3) 0.25*u3.^2;
               f13 = @(u4) 0.25*u4.^2;
               f14 =@(u5) 0.25*u5.^2;
               f15 =@(u6) 0.25*u6.^2;
               f16 =@(u7) 0.25*u7.^2;
               f17 =@(u8) 0.25*u8.^2;
               f18 =@(u9) 0.25*u9.^2;
               f19 =@(u10) 0.25*u10.^2;
               f20 =@(u11) 0.25*u11.^2;
               f21 =@(u12) 0.25*u12.^2;
               f22 =@(u13) 0.25*u13.^2;
               f23 =@(u14) 0.25*u14.^2;
               f24 =@(u15) 0.25*u15.^2;
               f25 =@(u16) 0.25*u16.^2;
               f26 =@(u15) 0.25*u17.^2;
               f27 =@(u16) 0.25*u18.^2;
           else
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = matlabFunction(sym(f{1}{8}));
               f9 = matlabFunction(sym(f{1}{9}));
               f10 = matlabFunction(sym(f{1}{10}));
               f11 = @(u1) 0.25*u1.^2;
               f12 = @(u2) 0.25*u2.^2;
               f13 = @(u3) 0.25*u3.^2;
               f14 = @(u4) 0.25*u4.^2;
               f15 =@(u5) 0.25*u5.^2;
               f16 =@(u6) 0.25*u6.^2;
               f17 =@(u7) 0.25*u7.^2;
               f18 =@(u8) 0.25*u8.^2;
               f19 =@(u9) 0.25*u9.^2;
               f20 =@(u10) 0.25*u10.^2;
               f21 =@(u11) 0.25*u11.^2;
               f22 =@(u12) 0.25*u12.^2;
               f23 =@(u13) 0.25*u13.^2;
               f24 =@(u14) 0.25*u14.^2;
               f25 =@(u15) 0.25*u15.^2;
               f26 =@(u16) 0.25*u16.^2;
               f27 =@(u15) 0.25*u17.^2;
               f28 =@(u16) 0.25*u18.^2;
               f29 =@(u15) 0.25*u19.^2;
               f30 =@(u16) 0.25*u19.^2;
           end
           % ----------------------------------------------------- %
           if(temp_result == 3)
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
           if(value_of_popup == 1)
               args = linspace(xbmin1(1),xbmax1(1),50);
               F2 = findobj('Tag','figure2');
               f_mf = f1;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
           elseif(value_of_popup == 2)
               args = linspace(xbmin1(2),xbmax1(2),50);
               F2 = findobj('Tag','figure2');
               f_mf = f2;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
        elseif(value_of_popup == 3)
               args = linspace(xbmin1(3),xbmax1(3),50);
               F2 = findobj('Tag','figure2');
               f_mf = f3;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
           elseif(value_of_popup == 4)
                var1 = get(findobj('Tag','but1'),'Value');
                f1lin = get(findobj('tag','Hu1b_3D'),'Userdata');
                f2lin = get(findobj('tag','Hu2b_3D'),'Userdata');
                [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                args = linspace(zb_sum(1),zb_sum(2),50);
                f_mf = @(x) 1/4*x.^2;
                F2 = findobj('Tag','figure2');
                if(isempty(F2))
                    Monitor = get(0,'Screensize');
                    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                    set(F2,'visible','on');
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                else
                    set(F2,'visible','on');
                    figure(F2);
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                end
            elseif(value_of_popup == 5)
                var1 = get(findobj('Tag','but1'),'Value');
                f1lin = get(findobj('tag','Hu1b_3D'),'Userdata');
                f2lin = get(findobj('tag','Hu2b_3D'),'Userdata');
                [~, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                args = linspace(zb_diff(1),zb_diff(2),50);
                f_mf = @(x) 1/4*x.^2;
                F2 = findobj('Tag','figure2');
                if(isempty(F2))
                    Monitor = get(0,'Screensize');
                    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                    set(F2,'visible','on');
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                else
                    set(F2,'visible','on');
                    figure(F2);
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                end
           elseif(value_of_popup == 6)
                
                flin_p1 = get(findobj('tag','Hu1a_3D'),'Userdata');
                flin_p2 = get(findobj('tag','Hu2a_3D'),'Userdata');
                flin_p3 = get(findobj('tag','Hu3a_3D'),'Userdata');
                zlin_p1 = get(findobj('tag','Hu4a_3D'),'Userdata');
                zlin_p2 = get(findobj('tag','Hu5a_3D'),'Userdata');
                
                flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                
                for i = 1:length(flin_p)
                    f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                end
                
                %%% evaluation of the all possible combinations of input arguments %%%
                Uarg = cell(1,2);
                Uarg{1} = f_hod{1};
                Uarg{2} = f_hod{2};
                
                Ucombs = mpt_allcombs(Uarg);
                f1z = Ucombs(:,1);
                f2z = Ucombs(:,2);
                
                %%% obtaining the good_values %%%
                y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                z = y1 - y2;
                
                f1min=min(z);
                f1max=max(z);
                
                f2min=min(f_hod{3});
                f2max=max(f_hod{3});
                
                %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                
                u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                zb_sum = [u1min u1max];
                zb_diff = [u2min u2max];
                set(findobj('tag','Hpom1b_3D'),'Userdata',zb_diff);
                
                %%% approximation of the quadratic functions %%%
                syms x
                               
                %%% approximation of the quadratic functions %%%
                args = linspace(zb_sum(1),zb_sum(2),50)
                
                f_mf = @(x) 1/4*x.^2;
                
                F2 = findobj('Tag','figure2');
                if(isempty(F2))
                    Monitor = get(0,'Screensize');
                    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                    set(F2,'visible','on');
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                else
                    set(F2,'visible','on');
                    figure(F2);
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                end  
                
           elseif(value_of_popup == 7)
               args_bounds = get(findobj('tag','Hpom1b_3D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               f_mf = @(x) 1/4*x.^2;
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               end
             end
           end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on');
               
        % -------------------------------------------------------- %
        if(temp_result == 4)
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
           if(value_of_popup == 1)
               args = linspace(xbmin1(1),xbmax1(1),50);
               F2 = findobj('Tag','figure2');
               f_mf = f1;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 2)
               args = linspace(xbmin1(2),xbmax1(2),50);
               F2 = findobj('Tag','figure2');
               f_mf = f2;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 3)
               args = linspace(xbmin1(3),xbmax1(3),50);
               F2 = findobj('Tag','figure2');
               f_mf = f3;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 4)
               args = linspace(xbmin1(4),xbmax1(4),50);
               F2 = findobj('Tag','figure2');
               f_mf = f4;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
           elseif(value_of_popup == 5)
              var1 = get(findobj('Tag','but1'),'Value');
              f1lin = get(findobj('tag','Hu1b_4D'),'Userdata');
              f2lin = get(findobj('tag','Hu2b_4D'),'Userdata');
              [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
              args = linspace(zb_sum(1),zb_sum(2),50);
              f_mf = @(x) 1/4*x.^2;
              F2 = findobj('Tag','figure2');
              if(isempty(F2))
                 Monitor = get(0,'Screensize');
                 F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                 'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                 'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                 set(F2,'visible','on');
                 plot(args,f_mf(args),'b-','linewidth', 2);
                 legend(char(sym(f_mf)), 'Location', 'Best');
              else
                 set(F2,'visible','on');
                 figure(F2);
                 plot(args,f_mf(args),'b-','linewidth', 2);
                 legend(char(sym(f_mf)), 'Location', 'Best');
              end
          elseif(value_of_popup == 6)
              f1lin = get(findobj('tag','Hu1b_4D'),'Userdata');
              f2lin = get(findobj('tag','Hu2b_4D'),'Userdata');
              [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
              args = linspace(zb_diff(1),zb_diff(2),50);
              f_mf = @(x) 1/4*x.^2;
              F2 = findobj('Tag','figure2');
              if(isempty(F2))
                 Monitor = get(0,'Screensize');
                 F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                 'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                 'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                 set(F2,'visible','on');
                 plot(args,f_mf(args),'b-','linewidth', 2);
                 legend(char(sym(f_mf)), 'Location', 'Best');
              else
                 set(F2,'visible','on');
                 figure(F2);
                 plot(args,f_mf(args),'b-','linewidth', 2);
                 legend(char(sym(f_mf)), 'Location', 'Best');
              end   
          elseif(value_of_popup == 7)
                
                flin_p1 = get(findobj('tag','Hu1a_4D'),'Userdata');
                flin_p2 = get(findobj('tag','Hu2a_4D'),'Userdata');
                flin_p3 = get(findobj('tag','Hu3a_4D'),'Userdata');
                zlin_p1 = get(findobj('tag','Hu5a_4D'),'Userdata');
                zlin_p2 = get(findobj('tag','Hu6a_4D'),'Userdata');
                
                flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                
                for i = 1:length(flin_p)
                    f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                end
                
                %%% evaluation of the all possible combinations of input arguments %%%
                Uarg = cell(1,2);
                Uarg{1} = f_hod{1};
                Uarg{2} = f_hod{2};
                
                Ucombs = mpt_allcombs(Uarg);
                f1z = Ucombs(:,1);
                f2z = Ucombs(:,2);
                
                %%% obtaining the good_values %%%
                y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                z = y1 - y2;
                
                f1min=min(z);
                f1max=max(z);
                
                f2min=min(f_hod{3});
                f2max=max(f_hod{3});
                
                %%% obtaining the boundaries for apporximation of the quadratic functions %%%
                u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                
                u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                zb_sum = [u1min u1max];
                zb_diff = [u2min u2max];
                set(findobj('tag','Hpom1b_4D'),'Userdata',zb_diff);
                
                %%% approximation of the quadratic functions %%%
                syms x
                               
                %%% approximation of the quadratic functions %%%
                args = linspace(zb_sum(1),zb_sum(2),50)
                
                F2 = findobj('Tag','figure2');
                if(isempty(F2))
                    Monitor = get(0,'Screensize');
                    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                    set(F2,'visible','on');
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                else
                    set(F2,'visible','on');
                    figure(F2);
                    plot(args,f7(args),'b-','linewidth', 2);
                    legend(char(sym(f7)), 'Location', 'Best');
                end        
          elseif(value_of_popup == 8)
               args_bounds = get(findobj('tag','Hpom1b_4D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
               end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on');
           
           elseif(value_of_popup == 9)
               flin_p3 = get(findobj('tag','Hu3a_4D'),'Userdata');
               flin_p4 = get(findobj('tag','Hu4a_4D'),'Userdata');
               zlin_p1 = get(findobj('tag','Hu7a_4D'),'Userdata');
               zlin_p2 = get(findobj('tag','Hu8a_4D'),'Userdata');
               fun_temp = get(findobj('tag','Hu_gval'),'Userdata');
               
               flin_p = {flin_p3{1} flin_p4{1}};
               
               for i = 1:length(flin_p)
                   f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
               end
               
               %%% here the good _value of z
               
               
               %%% evaluation of all possible combination of input arguments %%%
               Uarg = cell(1,2);
               Uarg{1} = fun_temp';
               Uarg{2} = f_hod{1};
               
               Ucombs = mpt_allcombs(Uarg);
               fzz = Ucombs(:,1);
               f3z = Ucombs(:,2);
               
               %%% approximation of the quadratic functions %%%
               y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
               y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
               z = y1-y2;
               
               %%% finding the minimal and maximal function values %%%
               f2min=min(z);
               f2max=max(z);
               
               f1min=min(f_hod{2});
               f1max=max(f_hod{2});
               
               %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
               u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
               u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
               u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
               u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
               
               zb_sum = [u1min u1max];
               zb_diff = [u2min u2max];
               
               set(findobj('tag','Hpom1b_4D'),'Userdata',zb_diff);
                           
               %%% approximation of the quadratic functions %%%
               args = linspace(zb_sum(1),zb_sum(2),50);
               
               f_mf = @(x) 1/4*x.^2;
                              
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on');
           elseif(value_of_popup == 10)
               args_bounds = get(findobj('tag','Hpom1b_4D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
               end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on');
           end
        end
        % -------------------------------------------------- %
        if(temp_result == 5)
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
           if(value_of_popup == 1)
               args = linspace(xbmin1(1),xbmax1(1),50);
               F2 = findobj('Tag','figure2');
               f_mf = f1;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
           elseif(value_of_popup == 2)
               args = linspace(xbmin1(2),xbmax1(2),50);
               F2 = findobj('Tag','figure2');
               f_mf = f2;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 3)
               args = linspace(xbmin1(3),xbmax1(3),50);
               F2 = findobj('Tag','figure2');
               f_mf = f3;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
         elseif(value_of_popup == 4)
               args = linspace(xbmin1(4),xbmax1(4),50);
               F2 = findobj('Tag','figure2');
               f_mf = f4;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
         elseif(value_of_popup == 5)
               args = linspace(xbmin1(5),xbmax1(5),50);
               F2 = findobj('Tag','figure2');
               f_mf = f5;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
        elseif(value_of_popup == 6)
             f1lin = get(findobj('tag','Hu1b_5D'),'Userdata');
             f2lin = get(findobj('tag','Hu2b_5D'),'Userdata');
             [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
             args = linspace(zb_sum(1),zb_sum(2),50);
             f_mf = @(x) 1/4*x.^2;
             F2 = findobj('Tag','figure2');
             if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
         elseif(value_of_popup == 7)
             f1lin = get(findobj('tag','Hu1b_5D'),'Userdata');
             f2lin = get(findobj('tag','Hu2b_5D'),'Userdata');
             [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
             args = linspace(zb_diff(1),zb_diff(2),50);
             f_mf = @(x) 1/4*x.^2;
             F2 = findobj('Tag','figure2'); 
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 8)
                
                flin_p1 = get(findobj('tag','Hu1a_5D'),'Userdata');
                flin_p2 = get(findobj('tag','Hu2a_5D'),'Userdata');
                flin_p3 = get(findobj('tag','Hu3a_5D'),'Userdata');
                zlin_p1 = get(findobj('tag','Hu6a_5D'),'Userdata');
                zlin_p2 = get(findobj('tag','Hu7a_5D'),'Userdata');
                
                flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                
                for i = 1:length(flin_p)
                    f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                end
                
                %%% evaluation of the all possible combinations of input arguments %%%
                Uarg = cell(1,2);
                Uarg{1} = f_hod{1};
                Uarg{2} = f_hod{2};
                
                Ucombs = mpt_allcombs(Uarg);
                f1z = Ucombs(:,1);
                f2z = Ucombs(:,2);
                
                %%% obtaining the good_values %%%
                y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                z = y1 - y2;
                
                f1min=min(z);
                f1max=max(z);
                
                f2min=min(f_hod{3});
                f2max=max(f_hod{3});
                
                %%% obtaining the boundaries for apporximation of the quadratic functions %%%
                u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                
                u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                zb_sum = [u1min u1max];
                zb_diff = [u2min u2max];
                set(findobj('tag','Hpom1b_5D'),'Userdata',zb_diff);
                
                %%% approximation of the quadratic functions %%%
                syms x
                               
                %%% approximation of the quadratic functions %%%
                args = linspace(zb_sum(1),zb_sum(2),50)
                
                F2 = findobj('Tag','figure2');
                if(isempty(F2))
                    Monitor = get(0,'Screensize');
                    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                    set(F2,'visible','on');
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                else
                    set(F2,'visible','on');
                    figure(F2);
                    plot(args,f7(args),'b-','linewidth', 2);
                    legend(char(sym(f7)), 'Location', 'Best');
                end        
          elseif(value_of_popup == 9)
               args_bounds = get(findobj('tag','Hpom1b_5D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on');
           
           elseif(value_of_popup == 10)
               flin_p3 = get(findobj('tag','Hu3a_5D'),'Userdata');
               flin_p4 = get(findobj('tag','Hu4a_5D'),'Userdata');
               zlin_p1 = get(findobj('tag','Hu7a_5D'),'Userdata');
               zlin_p2 = get(findobj('tag','Hu8a_5D'),'Userdata');
               fun_temp1 = get(findobj('tag','Hu_gval_5D'),'Userdata')
               
               flin_p = {flin_p3{1} flin_p4{1}};
               
               for i = 1:length(flin_p)
                   f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
               end
               
               %%% here the good _value of z
               
               
               %%% evaluation of all possible combination of input arguments %%%
               Uarg = cell(1,2);
               Uarg{1} = fun_temp1'
               Uarg{2} = f_hod{1}
               
               Ucombs = mpt_allcombs(Uarg);
               fzz = Ucombs(:,1);
               f3z = Ucombs(:,2);
               
               %%% approximation of the quadratic functions %%%
               y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
               y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
               z = y1-y2;
               
               %%% finding the minimal and maximal function values %%%
               f2min=min(z);
               f2max=max(z);
               
               f1min=min(f_hod{2});
               f1max=max(f_hod{2});
               
               %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
               u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
               u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
               u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
               u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
               
               zb_sum = [u1min u1max];
               zb_diff = [u2min u2max];
               
               set(findobj('tag','Hpom1b_5D'),'Userdata',zb_diff);
                           
               %%% approximation of the quadratic functions %%%
               args = linspace(zb_sum(1),zb_sum(2),50);
               
               f_mf = @(x) 1/4*x.^2;
                              
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               end
           elseif(value_of_popup == 11)
               args_bounds = get(findobj('tag','Hpom1b_5D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
              end
              elseif(value_of_popup == 12)
                 flin_p4 = get(findobj('tag','Hu4a_5D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_5D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu10a_5D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu11a_5D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_5Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_5Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                                
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-''linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
             elseif(value_of_popup == 13)
                  z_bounds = get(findobj('tag','Hpom1b_5Da'),'Userdata');
                                
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end  
               end
           end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on');    
        % ----------------------------------------------------- %   
        if(temp_result == 6)
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
           if(value_of_popup == 1)
               args = linspace(xbmin1(1),xbmax1(1),50);
               F2 = findobj('Tag','figure2');
               f_mf = f1;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 2)
               args = linspace(xbmin1(2),xbmax1(2),50);
               F2 = findobj('Tag','figure2');
               f_mf = f2;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 3)
               args = linspace(xbmin1(3),xbmax1(3),50);
               F2 = findobj('Tag','figure2');
               f_mf = f3;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
        elseif(value_of_popup == 4)
               args = linspace(xbmin1(4),xbmax1(4),50);
               F2 = findobj('Tag','figure2');
               f_mf = f4;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
               set(findobj('Tag','origi_fun'),'Visible','off');
         elseif(value_of_popup == 5)
               args = linspace(xbmin1(5),xbmax1(5),50);
               F2 = findobj('Tag','figure2');
               f_mf = f5;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
        elseif(value_of_popup == 6)
               args = linspace(xbmin1(6),xbmax1(6),50);
               F2 = findobj('Tag','figure2');
               f_mf = f6;
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
         elseif(value_of_popup == 7)
             f1lin = get(findobj('tag','Hu1b_6D'),'Userdata');
             f2lin = get(findobj('tag','Hu2b_6D'),'Userdata');
             [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
             args = linspace(zb_sum(1),zb_sum(2),50);
             f_mf = @(x) 1/4*x.^2;
             F2 = findobj('Tag','figure2');
             if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
         elseif(value_of_popup == 8)
             f1lin = get(findobj('tag','Hu1b_6D'),'Userdata');
             f2lin = get(findobj('tag','Hu2b_6D'),'Userdata');
             [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
             args = linspace(zb_diff(1),zb_diff(2),50);
             f_mf = @(x) 1/4*x.^2;
             F2 = findobj('Tag','figure2'); 
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)),'Location', 'Best');
               end
          elseif(value_of_popup == 9)
                
                flin_p1 = get(findobj('tag','Hu1a_6D'),'Userdata');
                flin_p2 = get(findobj('tag','Hu2a_6D'),'Userdata');
                flin_p3 = get(findobj('tag','Hu3a_6D'),'Userdata');
                zlin_p1 = get(findobj('tag','Hu7a_6D'),'Userdata');
                zlin_p2 = get(findobj('tag','Hu8a_6D'),'Userdata');
                
                flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                
                for i = 1:length(flin_p)
                    f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                end
                
                %%% evaluation of the all possible combinations of input arguments %%%
                Uarg = cell(1,2);
                Uarg{1} = f_hod{1};
                Uarg{2} = f_hod{2};
                
                Ucombs = mpt_allcombs(Uarg);
                f1z = Ucombs(:,1);
                f2z = Ucombs(:,2);
                
                %%% obtaining the good_values %%%
                y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                z = y1 - y2;
                
                f1min=min(z);
                f1max=max(z);
                
                f2min=min(f_hod{3});
                f2max=max(f_hod{3});
                
                %%% obtaining the boundaries for apporximation of the quadratic functions %%%
                u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                
                u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                zb_sum = [u1min u1max]
                zb_diff = [u2min u2max]
                set(findobj('tag','Hpom1b_6D'),'Userdata',zb_diff);
                
                %%% approximation of the quadratic functions %%%
                syms x
                               
                %%% approximation of the quadratic functions %%%
                args = linspace(zb_sum(1),zb_sum(2),50)
                
                F2 = findobj('Tag','figure2');
                if(isempty(F2))
                    Monitor = get(0,'Screensize');
                    F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                        'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                        'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                    set(F2,'visible','on');
                    plot(args,f_mf(args),'b-','linewidth', 2);
                    legend(char(sym(f_mf)), 'Location', 'Best');
                else
                    set(F2,'visible','on');
                    figure(F2);
                    plot(args,f7(args),'b-','linewidth', 2);
                    legend(char(sym(f7)), 'Location', 'Best');
                end        
          elseif(value_of_popup == 10)
               args_bounds = get(findobj('tag','Hpom1b_6D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               end
         elseif(value_of_popup == 11)
               flin_p3 = get(findobj('tag','Hu3a_6D'),'Userdata');
               flin_p4 = get(findobj('tag','Hu4a_6D'),'Userdata');
               zlin_p1 = get(findobj('tag','Hu9a_6D'),'Userdata');
               zlin_p2 = get(findobj('tag','Hu10a_6D'),'Userdata');
               fun_temp1 = get(findobj('tag','Hu_gval_6D'),'Userdata')
               
               flin_p = {flin_p3{1} flin_p4{1}};
               
               for i = 1:length(flin_p)
                   f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
               end
               
               %%% here the good _value of z
               
               
               %%% evaluation of all possible combination of input arguments %%%
               Uarg = cell(1,2);
               Uarg{1} = fun_temp1'
               Uarg{2} = f_hod{1}
               
               Ucombs = mpt_allcombs(Uarg);
               fzz = Ucombs(:,1);
               f3z = Ucombs(:,2);
               
               %%% approximation of the quadratic functions %%%
               y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
               y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
               z = y1-y2;
               
               %%% finding the minimal and maximal function values %%%
               f2min=min(z);
               f2max=max(z);
               
               f1min=min(f_hod{2});
               f1max=max(f_hod{2});
               
               %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
               u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
               u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
               u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
               u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
               
               zb_sum = [u1min u1max];
               zb_diff = [u2min u2max];
               
               set(findobj('tag','Hpom1b_6D'),'Userdata',zb_diff);
                           
               %%% approximation of the quadratic functions %%%
               args = linspace(zb_sum(1),zb_sum(2),50);
               
               f_mf = @(x) 1/4*x.^2;
                              
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f_mf(args),'b-','linewidth', 2);
                   legend(char(sym(f_mf)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f9(args),'b-','linewidth', 2);
                   legend(char(sym(f9)), 'Location', 'Best');
               end
           elseif(value_of_popup == 12)
               args_bounds = get(findobj('tag','Hpom1b_6D'),'Userdata');
               args = linspace(args_bounds(1),args_bounds(2),50);
               F2 = findobj('Tag','figure2');
               if(isempty(F2))
                   Monitor = get(0,'Screensize');
                   F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                       'position',[0.955*Monitor(4) 0.3*Monitor(4) 0.6*Monitor(4) 0.45*Monitor(4)],...
                       'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                   set(F2,'visible','on');
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
               else
                   set(F2,'visible','on');
                   figure(F2);
                   plot(args,f8(args),'b-','linewidth', 2);
                   legend(char(sym(f8)), 'Location', 'Best');
              end
              elseif(value_of_popup == 13)
                 flin_p4 = get(findobj('tag','Hu4a_6D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_6D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu11a_6D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu12a_6D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_6Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_6Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                                
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-''linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
             elseif(value_of_popup == 14)
                  z_bounds = get(findobj('tag','Hpom1b_6Da'),'Userdata');
                                
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-','linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end
                  
             elseif(value_of_popup == 15)
                 flin_p4 = get(findobj('tag','Hu5a_6D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_6D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu13a_6D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu14a_6D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_6Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_6Db'),'Userdata',zb_diff);
                 
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
             elseif(value_of_popup == 16)
                  z_bounds = get(findobj('tag','Hpom1b_6Db'),'Userdata');
                            
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                              
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end    
           end
           set(findobj('Tag','origi_fun'),'Visible','off');
           set(findobj('Tag','apps'),'Visible','on');
           set(findobj('tag','h_temp'),'Visible','on');
           set(findobj('tag','regs'),'Visible','on'); 
        end
        % ----------------------------------------------------- %   
        if(temp_result == 7)
                         
            value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                                              
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                case 5  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [xbmin1(5) xbmax1(5)], ns);
                   set(findobj('tag','Hu5a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu5b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                case 6 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [xbmin1(6) xbmax1(6)], ns);
                   set(findobj('tag','Hu6a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu6b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                case 7 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f7, var1, [xbmin1(7) xbmax1(7)], ns);
                   set(findobj('tag','Hu7a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu7b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(7),xbmax1(7),50);
                   f_mf = matlabFunction(sym(f{1}{7}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                 case 8
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_7D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_7D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [zb_sum(1) zb_sum(2)], ns);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
          
                case 9
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_7D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_7D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                   
                case 10
                  flin_p1 = get(findobj('tag','Hu1a_7D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_7D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_7D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu8a_7D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu9a_7D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_7D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_7D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu10a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu10b_7D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
                                         
              case 11
                  z_bounds = get(findobj('tag','Hpom1b_7D'),'Userdata');
       
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end
                  
              case 12
                 flin_p3 = get(findobj('tag','Hu3a_7D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu10a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu11a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_7Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu12a_7D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu12b_7D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
                 
              case 13
                  z_bounds = get(findobj('tag','Hpom1b_7D'),'Userdata');
                                               
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end
                  
              case 14  
                 flin_p4 = get(findobj('tag','Hu4a_7D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu12a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu13a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_7Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
             
               case 15
                  z_bounds = get(findobj('tag','Hpom1b_7Da'),'Userdata');
                            
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end
              
              case 16 
                 flin_p4 = get(findobj('tag','Hu5a_7D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu14a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu15a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_7Dc'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7Db'),'Userdata',zb_diff);
                              
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
                 
               case 17
                  z_bounds = get(findobj('tag','Hpom1b_7Db'),'Userdata');

                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end

               case 18 
                 flin_p4 = get(findobj('tag','Hu6a_7D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu7a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu16a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu17a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+5),xbmax1(i+5),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7Dc'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7Dc'),'Userdata',zb_diff);
                 
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 end
                 
               case 19
                  z_bounds = get(findobj('tag','Hpom1b_7Dc'),'Userdata');
                               
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                  
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  end
            end
        end
        % ----------------------------------------------------- %   
        if(temp_result == 8)
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
           switch value_of_popup
               case 1
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
               case 2
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
                                              
               case 3
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
               case 4
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 5
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 6
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 7
                   args = linspace(xbmin1(7),xbmax1(7),50);
                   f_mf = matlabFunction(sym(f{1}{7}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 8
                   args = linspace(xbmin1(8),xbmax1(8),50);
                   f_mf = matlabFunction(sym(f{1}{8}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 9
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_8D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_8D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end 
               case 10
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_8D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_8D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 11
                  flin_p1 = get(findobj('tag','Hu1a_8D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_8D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_8D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu9a_8D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu10a_8D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_8D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_8D'),'Userdata',zb_diff);
                  
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 12
                  z_bounds = get(findobj('tag','Hpom1b_8D'),'Userdata');
                            
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                 
               case 13
                 flin_p3 = get(findobj('tag','Hu3a_8D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu11a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu12a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8D'),'Userdata',zb_diff);
                                  
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
               case 14
                  z_bounds = get(findobj('tag','Hpom1b_8D'),'Userdata');
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                  
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 15
                 flin_p4 = get(findobj('tag','Hu4a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu13a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu14a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;

                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
                 
               case 16
                  z_bounds = get(findobj('tag','Hpom1b_8Da'),'Userdata');
                             
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 17
                 flin_p4 = get(findobj('tag','Hu5a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu15a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu16a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Dc'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8Db'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                   
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
                 
               case 18
                  z_bounds = get(findobj('tag','Hpom1b_8Db'),'Userdata');
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 19
                 flin_p4 = get(findobj('tag','Hu6a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu7a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu17a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu18a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+5),xbmax1(i+5),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Dc'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Dd'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8Dd'),'Userdata',zb_diff);
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                                  
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
               case 20
                  z_bounds = get(findobj('tag','Hpom1b_8Dd'),'Userdata')
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 21
                 flin_p4 = get(findobj('tag','Hu7a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu8a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu19a_8D'),'Userdata')
                 zlin_p2 = get(findobj('tag','Hu20a_8D'),'Userdata')
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+6),xbmax1(i+6),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Dd'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8De'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8De'),'Userdata',zb_diff);

                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                  
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
                
               case 22
                  z_bounds = get(findobj('tag','Hpom1b_8De'),'Userdata');
                 
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
               
                  set(findobj('Tag','origi_fun'),'Visible','off');
                  set(findobj('Tag','apps'),'Visible','on');
                  set(findobj('tag','h_temp'),'Visible','on');
                  set(findobj('tag','regs'),'Visible','on');
              end
        end
        if(temp_result == 9)
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup = value_of_popup{1};
           end
           switch value_of_popup
               case 1
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
               case 2
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
                                              
               case 3
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   end
               case 4
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 5
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 6
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 7
                   args = linspace(xbmin1(7),xbmax1(7),50);
                   f_mf = matlabFunction(sym(f{1}{7}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 8
                   args = linspace(xbmin1(8),xbmax1(8),50);
                   f_mf = matlabFunction(sym(f{1}{8}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 9
                   args = linspace(xbmin1(9),xbmax1(9),50);
                   f_mf = matlabFunction(sym(f{1}{9}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end    
               case 10
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_9D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_9D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end 
               case 11
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_9D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_9D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                   end
               case 12
                  flin_p1 = get(findobj('tag','Hu1a_9D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_9D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_9D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu10a_9D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu11a_9D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_9D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_9D'),'Userdata',zb_diff);
                  
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 13
                  z_bounds = get(findobj('tag','Hpom1b_9D'),'Userdata');
                            
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                 
               case 14
                 flin_p3 = get(findobj('tag','Hu3a_9D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu12a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu13a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9D'),'Userdata',zb_diff);
                                  
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
               case 15
                  z_bounds = get(findobj('tag','Hpom1b_9D'),'Userdata');
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                  
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 16
                 flin_p4 = get(findobj('tag','Hu4a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu14a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu15a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;

                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
                 
               case 17
                  z_bounds = get(findobj('tag','Hpom1b_9Da'),'Userdata');
                             
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                      
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 18
                 flin_p4 = get(findobj('tag','Hu5a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu16a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu17a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Dc'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Db'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                   
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
                 
               case 19
                  z_bounds = get(findobj('tag','Hpom1b_9Db'),'Userdata');
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 20
                 flin_p4 = get(findobj('tag','Hu6a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu7a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu18a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu19a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+5),xbmax1(i+5),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Dc'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Dd'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Dd'),'Userdata',zb_diff);
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                                  
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
               case 21
                  z_bounds = get(findobj('tag','Hpom1b_9Dd'),'Userdata')
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  f_mf = @(x) 1/4*x.^2;
                                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
                  
               case 22
                 flin_p4 = get(findobj('tag','Hu7a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu8a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu20a_9D'),'Userdata')
                 zlin_p2 = get(findobj('tag','Hu21a_9D'),'Userdata')
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+6),xbmax1(i+6),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Dd'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9De'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9De'),'Userdata',zb_diff);

                 args = linspace(zb_sum(1),zb_sum(2),50);
                 f_mf = @(x) 1/4*x.^2;
                  
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func), 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-', 'linewidth', 2);
                     legend(char(func),'Location', 'Best');
                 end
                
               case 23
                  z_bounds = get(findobj('tag','Hpom1b_9De'),'Userdata');
                 
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func), 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-', 'linewidth', 2);
                      legend(char(func),'Location', 'Best');
                  end
               
                  set(findobj('Tag','origi_fun'),'Visible','off');
                  set(findobj('Tag','apps'),'Visible','on');
                  set(findobj('tag','h_temp'),'Visible','on');
                  set(findobj('tag','regs'),'Visible','on');
               case 24
                 flin_p4 = get(findobj('tag','Hu8a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu9a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu22a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu23a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+7),xbmax1(i+7),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9De'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Df'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Df'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu24a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu24b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                
               case 25
                  z_bounds = get(findobj('tag','Hpom1b_9Df'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu25a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu25b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
     
              end
           end
        end
              % ------------------------------------------------------ %
        case('plot')
        %%% data for approximation summary %%%    
        var1 = get(findobj('Tag','but1'),'Value');
        if(var1)
        func = get(findobj('tag','fun'),'String');
        func = sym(func);
        vars = findsym(func);
        xbmin = get(findobj('tag','Lbound'),'String');
        xbmin = str2num(xbmin);
        xbmax = get(findobj('tag','Ubound'),'String');
        xbmax = str2num(xbmax);
        Xbounds = [xbmin xbmax];
        ns = get(findobj('Tag','apps'),'Value');
        [f1_aprx,f1_aprx_data] = autoprox_1d(func, var1, [xbmin xbmax], ns);
        set(findobj('tag','fun'),'Userdata',f1_aprx_data);
        set(findobj('tag','hu_11_1D'),'Userdata',vars)
        set(findobj('tag','hu_12_1D'),'Userdata',[xbmin xbmax]);
        args = linspace(xbmin,xbmax,50);
        f_mf = matlabFunction(func);
        
        F1 = findobj('Tag','figure1');
        figure(F1);
        
        th1 = findobj('tag','hp1');
        th1a = findobj('tag','hp1a');
        th2 = findobj('tag','hp2');
        th2a = findobj('tag','hp2a');
        th3 = findobj('tag','hp3');
        th3a = findobj('tag','hp3a');
        th4 = findobj('tag','hp4');
        th4a = findobj('tag','hp4a');
        th5 = findobj('tag','hp5');
        th6 = findobj('tag','hp6');
        th7 = findobj('tag','hp7');
        th8 = findobj('tag','hp8');
        set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8],'Visible','on');
        set(th1a,'String',char(func));
        set(th2a,'String',num2str(xbmin));
        set(th3a,'String',num2str(xbmax));
        set(th4a,'String',num2str(ns));
                                   
        fun_value1 = f_mf(args);
        fun_value2 = f1_aprx(args);
        average_error = sum((fun_value1-fun_value2).^2);
        worst_error = max(abs((fun_value1-fun_value2)));
        
%         if(pocet >= 1)
%            comp_avg = [average_error avg_error];
%            comp_wrst = [worst_error wst_error];
%            ns_old = ns;
%         end
        
%         avg_error = average_error;
%         wst_error = worst_error;
                
        set(th6,'String',num2str(average_error));
        set(th8,'String',num2str(worst_error));
        
        F2 = findobj('Tag','figure2');
        if(isempty(F2))
            Monitor = get(0,'Screensize');
            F2 = figure('Units','Pixels','Name','Depiction of the given function',...
            'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
            'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
            set(F2,'visible','on');
            plot(args,f_mf(args),'b-',args,f1_aprx(args),'r--', 'linewidth', 2);
            legend(char(func), 'Approximation', 'Location', 'Best');
        else
            set(F2,'visible','on');
            figure(F2);
            plot(args,f_mf(args),'b-',args,f1_aprx(args),'r--', 'linewidth', 2);
            legend(char(func), 'Approximation', 'Location', 'Best');
        end
%         pocet = pocet + 1;        
%         if(pocet >= 2)
%            F1 = findobj('tag','figure1');
%            figure(F1)
%            result_avg = (1-(comp_avg(1)/comp_avg(2)))*100;              
%            result_wrst = (1-(comp_wrst(1)/comp_wrst(2)))*100;
%            
%            hD_avg = uicontrol('Units','normalized','Position',[0.65 0.28 0.17 0.05],'Style','text','String','DETERIORATION',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','red','fontsize',12,'fontweight','bold','tag','hd_avg','Visible','off');
%            hI_avg = uicontrol('Units','normalized','Position',[0.65 0.28 0.17 0.05],'Style','text','String','IMPROVEMENT',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor',[0.1 0.4 0.1],'fontsize',12,'fontweight','bold','tag','hi_avg','Visible','off'); 
%            hD_wrst = uicontrol('Units','normalized','Position',[0.65 0.225 0.17 0.05],'Style','text','String','DETERIORATION',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','red','fontsize',12,'fontweight','bold','tag','hd_wst','Visible','off');    
%            hI_wrst = uicontrol('Units','normalized','Position',[0.65 0.225 0.17 0.05],'Style','text','String','IMPROVEMENT',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor',[0.1 0.4 0.1],'fontsize',12,'fontweight','bold','tag','hi_wst','Visible','off');
% %            res_avg = uicontrol('Units','normalized','Position',[0.75 0.28 0.1 0.05],'Style','text','String',num2str(round(abs(result_avg))),...
% %                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','fontsize',12,'fontweight','bold','Visible','off');
% %            res_wrst = uicontrol('Units','normalized','Position',[0.75 0.225 0.1 0.05],'Style','text','String',num2str(round(abs(result_avg))),...
% %                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','fontsize',12,'fontweight','bold','Visible','off');
%            if(comp_avg(2) > result_avg)
%                set(hD_avg,'Visible','on');
% %                set(res_avg,'Visible','on');
%            else
%                set(hI_avg,'Visible','on');
% %                set(res_avg,'Visible','on');
%            end
%            
%            if(comp_wrst(2) > result_wrst)
%                set(hD_wrst,'Visible','on');
% %                set(res_wrst,'Visible','on');
%            else
%                set(hI_wrst,'Visible','on');
% %                set(res_wrst,'Visible','on');
%            end
%         end
        
        end
        
        var2 = get(findobj('Tag','but2'),'Value');
        temp = var2;
        if(var2)   
           func = get(findobj('tag','fun'),'String');
           func1 = sym(func);
           vars = findsym(func1);
           set(findobj('tag','hu_11'),'Userdata',vars);
           vars = sym(vars);
           [L,V] = split(func,vars);
           [subL,subV] = separate_functions(L,V);
           f = obtain_subfunctions(subL,subV);
           xbmin = get(findobj('tag','Lbound'),'String');
           xbmin1 = str2num(xbmin);
           set(findobj('tag','hu_12'),'Userdata',xbmin1);
           xbmax = get(findobj('tag','Ubound'),'String');
           xbmax1 = str2num(xbmax);
           set(findobj('tag','hu_13'),'Userdata',xbmax1);
           ns = get(findobj('tag','apps'),'Value');
           
           f1 = matlabFunction(sym(f{1}{1}));
           f2 = matlabFunction(sym(f{1}{2}));
           syms u1 u2
           f3 = 0.25*u1^2;
           f3 = matlabFunction(f3);
           f4 = 0.25*u2^2;
           f4 = matlabFunction(f4);
           
           value_of_popup = get(findobj('Tag','2D'),'Value');
           if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
           else
               value_of_popup =value_of_popup{1};
           end
           
            F1 = findobj('Tag','figure1');
            figure(F1);
            
            th1 = findobj('tag','hp1');
            th1a = findobj('tag','hp1a');
            th2 = findobj('tag','hp2');
            th2a = findobj('tag','hp2a');
            th3 = findobj('tag','hp3');
            th3a = findobj('tag','hp3a');
            th4 = findobj('tag','hp4');
            th4a = findobj('tag','hp4a');
            th5 = findobj('tag','hp5');
            th6 = findobj('tag','hp6');
            th7 = findobj('tag','hp7');
            th8 = findobj('tag','hp8');
            set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8],'Visible','on');
                               
           
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','fun1'),'Userdata',f1_aprx_data);
                   set(findobj('tag','but1'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(xbmin1(1)));
                   set(th3a,'String',num2str(xbmax1(1)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   if(pocet >= 1)
                       comp_avg = [average_error avg_error];
                       comp_wrst = [worst_error wst_error];
                       ns_old = ns;
                   end
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                              
                 case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','fun1'),'Userdata',f1_aprx_data);
                   set(findobj('tag','but2'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(xbmin1(2)));
                   set(th3a,'String',num2str(xbmax1(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   if(pocet >= 1)
                       comp_avg = [average_error avg_error];
                       comp_wrst = [worst_error wst_error];
                       ns_old = ns;
                   end
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 3  
                   set(findobj('Tag','apps'),'Visible','on');   
                   set(findobj('Tag','origi_fun'),'Visible','off');
                   f1lin = get(findobj('tag','but1'),'Userdata');
                   f2lin = get(findobj('tag','but2'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   syms x
                   [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','Lbound'),'Userdata',z1lin_p);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,z1lin(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,z1lin(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(zb_sum(1)));
                   set(th3a,'String',num2str(zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   if(pocet >= 1)
                       comp_avg = [average_error avg_error];
                       comp_wrst = [worst_error wst_error];
                       ns_old = ns;
                   end
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 4
                   set(findobj('Tag','apps'),'Visible','on');
                   set(findobj('Tag','origi_fun'),'Visible','off');
                   f1lin = get(findobj('tag','but1'),'Userdata');
                   f2lin = get(findobj('tag','but2'),'Userdata'); 
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   syms x
                   [z2lin, z2lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_diff, ns);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','Ubound'),'Userdata',z2lin_p);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,z2lin(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,z2lin(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(zb_diff(1)));
                   set(th3a,'String',num2str(zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = z2lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   if(pocet >= 1)
                       comp_avg = [average_error avg_error];
                       comp_wrst = [worst_error wst_error];
                       ns_old = ns;
                   end
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
           end
                
%            if(pocet >= 2)
%                F1 = findobj('tag','figure1');
%                figure(F1)
%                result_avg = (1-(comp_avg(1)/comp_avg(2)))*100;
%                result_wrst = (1-(comp_wrst(1)/comp_wrst(2)))*100;
%                
%                hD_avg = uicontrol('Units','normalized','Position',[0.65 0.28 0.17 0.05],'Style','text','String','DETERIORATION',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','red','fontsize',12,'fontweight','bold','tag','hd_avg','Visible','off');
%                hI_avg = uicontrol('Units','normalized','Position',[0.65 0.28 0.17 0.05],'Style','text','String','IMPROVEMENT',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor',[0.1 0.4 0.1],'fontsize',12,'fontweight','bold','tag','hi_avg','Visible','off');
%                hD_wrst = uicontrol('Units','normalized','Position',[0.65 0.225 0.17 0.05],'Style','text','String','DETERIORATION',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','red','fontsize',12,'fontweight','bold','tag','hd_wst','Visible','off');
%                hI_wrst = uicontrol('Units','normalized','Position',[0.65 0.225 0.17 0.05],'Style','text','String','IMPROVEMENT',...
%                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor',[0.1 0.4 0.1],'fontsize',12,'fontweight','bold','tag','hi_wst','Visible','off');
%                %            res_avg = uicontrol('Units','normalized','Position',[0.75 0.28 0.1 0.05],'Style','text','String',num2str(round(abs(result_avg))),...
%                %                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','fontsize',12,'fontweight','bold','Visible','off');
%                %            res_wrst = uicontrol('Units','normalized','Position',[0.75 0.225 0.1 0.05],'Style','text','String',num2str(round(abs(result_avg))),...
%                %                    'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black','fontsize',12,'fontweight','bold','Visible','off');
%                if(comp_avg(2) > result_avg)
%                    set(hD_avg,'Visible','on');
%                    %                set(res_avg,'Visible','on');
%                else
%                    set(hI_avg,'Visible','on');
%                    %                set(res_avg,'Visible','on');
%                end
%                
%                if(comp_wrst(2) > result_wrst)
%                    set(hD_wrst,'Visible','on');
%                    %                set(res_wrst,'Visible','on');
%                else
%                    set(hI_wrst,'Visible','on');
%                    %                set(res_wrst,'Visible','on');
%                end
%            end
        end
        var3 = get(findobj('Tag','but3'),'Value');
        if(var3) 
           func = get(findobj('tag','fun'),'String');
           func1 = sym(func);
           vars = findsym(func1);
           [L,V] = split(func,vars);
           [subL,subV] = separate_functions(L,V);
           f = obtain_subfunctions(subL,subV);
           xbmin = get(findobj('tag','Lbound'),'String');
           xbmin1 = str2num(xbmin)
           xbmax = get(findobj('tag','Ubound'),'String');
           xbmax1 = str2num(xbmax)
           ns = get(findobj('tag','apps'),'Value');
           temp_result = findstr(vars,',');
           temp_result = length(temp_result);
           temp_result = temp_result + 1;
           syms u1 u2 u3 u4 u5 u6 u7 u8 u9 u10 u11 u12 u13 u14 u15
           if(temp_result == 3)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = @(u1) 0.25*u1.^2;
               f5 = @(u2) 0.25*u2.^2;
               f6 = @(u3) 0.25*u3.^2;
               f7 = @(u4) 0.25*u4.^2;
           elseif(temp_result == 4)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = @(u1) 0.25*u1.^2;
               f6 = @(u2) 0.25*u2.^2;
               f7 = @(u3) 0.25*u3.^2;
               f8 = @(u4) 0.25*u4.^2;
               f9 = @(u5) 0.25*u5.^2;
               f10 =@(u6) 0.25*u6.^2;
               f11 =@(u7) 0.25*u7.^2;
               f12 =@(u8) 0.25*u8.^2;
           elseif(temp_result == 5)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = @(u1) 0.25*u1.^2;
               f7 = @(u2) 0.25*u2.^2;
               f8 = @(u3) 0.25*u3.^2;
               f9 = @(u4) 0.25*u4.^2;
               f10 =@(u5) 0.25*u5.^2;
               f11 =@(u6) 0.25*u6.^2;
               f12 =@(u7) 0.25*u7.^2;
               f13 =@(u8) 0.25*u8.^2;
               f14 =@(u9) 0.25*u9.^2;
               f15 =@(u10) 0.25*u10.^2;
           elseif(temp_result == 6)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = @(u1) 0.25*u1.^2;
               f8 = @(u2) 0.25*u2.^2;
               f9 = @(u3) 0.25*u3.^2;
               f10 = @(u4) 0.25*u4.^2;
               f11 =@(u5) 0.25*u5.^2;
               f12 =@(u6) 0.25*u6.^2;
               f13 =@(u7) 0.25*u7.^2;
               f14 =@(u8) 0.25*u8.^2;
               f15 =@(u9) 0.25*u9.^2;
               f16 =@(u10) 0.25*u10.^2;
               f17 =@(u11) 0.25*u11.^2;
               f18 =@(u12) 0.25*u12.^2;
            elseif(temp_result == 7)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = @(u1) 0.25*u1.^2;
               f9 = @(u2) 0.25*u2.^2;
               f10 = @(u3) 0.25*u3.^2;
               f11 = @(u4) 0.25*u4.^2;
               f12 =@(u5) 0.25*u5.^2;
               f13 =@(u6) 0.25*u6.^2;
               f14 =@(u7) 0.25*u7.^2;
               f15 =@(u8) 0.25*u8.^2;
               f16 =@(u9) 0.25*u9.^2;
               f17 =@(u10) 0.25*u10.^2;
               f18 =@(u11) 0.25*u11.^2;
               f19 =@(u12) 0.25*u12.^2;
               f20 =@(u13) 0.25*u13.^2;
               f21 =@(u14) 0.25*u14.^2;
           elseif(temp_result == 8)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = matlabFunction(sym(f{1}{8}));
               f9 = @(u1) 0.25*u1.^2;
               f10 = @(u2) 0.25*u2.^2;
               f11 = @(u3) 0.25*u3.^2;
               f12 = @(u4) 0.25*u4.^2;
               f13 =@(u5) 0.25*u5.^2;
               f14 =@(u6) 0.25*u6.^2;
               f15 =@(u7) 0.25*u7.^2;
               f16 =@(u8) 0.25*u8.^2;
               f17 =@(u9) 0.25*u9.^2;
               f18 =@(u10) 0.25*u10.^2;
               f19 =@(u11) 0.25*u11.^2;
               f20 =@(u12) 0.25*u12.^2;
               f21 =@(u13) 0.25*u13.^2;
               f22 =@(u14) 0.25*u14.^2;
               f23 =@(u15) 0.25*u15.^2;
               f24 =@(u16) 0.25*u16.^2;
           elseif(temp_result == 9)
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = matlabFunction(sym(f{1}{8}));
               f9 = matlabFunction(sym(f{1}{9}));
               f10 = @(u1) 0.25*u1.^2;
               f11 = @(u2) 0.25*u2.^2;
               f12 = @(u3) 0.25*u3.^2;
               f13 = @(u4) 0.25*u4.^2;
               f14 =@(u5) 0.25*u5.^2;
               f15 =@(u6) 0.25*u6.^2;
               f16 =@(u7) 0.25*u7.^2;
               f17 =@(u8) 0.25*u8.^2;
               f18 =@(u9) 0.25*u9.^2;
               f19 =@(u10) 0.25*u10.^2;
               f20 =@(u11) 0.25*u11.^2;
               f21 =@(u12) 0.25*u12.^2;
               f22 =@(u13) 0.25*u13.^2;
               f23 =@(u14) 0.25*u14.^2;
               f24 =@(u15) 0.25*u15.^2;
               f25 =@(u16) 0.25*u16.^2;
               f26 =@(u15) 0.25*u17.^2;
               f27 =@(u16) 0.25*u18.^2;
           else
               f1 = matlabFunction(sym(f{1}{1}));
               f2 = matlabFunction(sym(f{1}{2}));
               f3 = matlabFunction(sym(f{1}{3}));
               f4 = matlabFunction(sym(f{1}{4}));
               f5 = matlabFunction(sym(f{1}{5}));
               f6 = matlabFunction(sym(f{1}{6}));
               f7 = matlabFunction(sym(f{1}{7}));
               f8 = matlabFunction(sym(f{1}{8}));
               f9 = matlabFunction(sym(f{1}{9}));
               f10 = matlabFunction(sym(f{1}{10}));
               f11 = @(u1) 0.25*u1.^2;
               f12 = @(u2) 0.25*u2.^2;
               f13 = @(u3) 0.25*u3.^2;
               f14 = @(u4) 0.25*u4.^2;
               f15 =@(u5) 0.25*u5.^2;
               f16 =@(u6) 0.25*u6.^2;
               f17 =@(u7) 0.25*u7.^2;
               f18 =@(u8) 0.25*u8.^2;
               f19 =@(u9) 0.25*u9.^2;
               f20 =@(u10) 0.25*u10.^2;
               f21 =@(u11) 0.25*u11.^2;
               f22 =@(u12) 0.25*u12.^2;
               f23 =@(u13) 0.25*u13.^2;
               f24 =@(u14) 0.25*u14.^2;
               f25 =@(u15) 0.25*u15.^2;
               f26 =@(u16) 0.25*u16.^2;
               f27 =@(u15) 0.25*u17.^2;
               f28 =@(u16) 0.25*u18.^2;
               f29 =@(u15) 0.25*u19.^2;
               f30 =@(u16) 0.25*u120.^2;
           end
                                 
           F1 = findobj('Tag','figure1');
           figure(F1);
            
           th1 = findobj('tag','hp1');
           th1a = findobj('tag','hp1a');
           th2 = findobj('tag','hp2');
           th2a = findobj('tag','hp2a');
           th3 = findobj('tag','hp3');
           th3a = findobj('tag','hp3a');
           th4 = findobj('tag','hp4');
           th4a = findobj('tag','hp4a');
           th5 = findobj('tag','hp5');
           th6 = findobj('tag','hp6');
           th7 = findobj('tag','hp7');
           th8 = findobj('tag','hp8');
           set([th1 th1a th2 th2a th3 th3a th4 th4a th5 th6 th7 th8],'Visible','on');
             
           
            if(temp_result == 3)
                         
            value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','Hu1a_3D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_3D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(xbmin1(1)));
                   set(th3a,'String',num2str(xbmax1(1)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_3D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_3D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                     
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(xbmin1(2)));
                   set(th3a,'String',num2str(xbmax1(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_3D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_3D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',num2str(xbmin1(3)));
                   set(th3a,'String',num2str(xbmax1(3)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 4
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_3D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_3D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu4a_3D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu4b_3D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f4(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f4(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   syms u
                   set(th1a,'String',char(0.25*u^2));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f4(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 5
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_3D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_3D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu5a_3D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu5b_3D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                     
                   set(th1a,'String',char(sym(f_mf)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 6
                  var1 = get(findobj('Tag','but1'),'Value');
                  flin_p1 = get(findobj('tag','Hu1a_3D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_3D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_3D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu4a_3D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu5a_3D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max]
                  zb_diff = [u2min u2max]
                  set(findobj('tag','Hpom1b_3D'),'Userdata',zb_diff);
                  
                  %%% approximation of the kvadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                                                     
                  %%% approximations of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                                      
                   set(th1a,'String',char(sym(f6)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   fun_value1 = f6(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                   set(findobj('tag','Hu6a_3D'),'Userdata',z1lin_p);
                   set(findobj('tag','Hu6b_3D'),'Userdata',z1lin);
                   
             case 7
                  var1 = get(findobj('Tag','but1'),'Value');
                  z_bounds = get(findobj('tag','Hpom1b_3D'),'Userdata');
                 
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                 
                  set(th2a,'String',num2str(z_bounds(1)));
                  set(th3a,'String',num2str(z_bounds(2)));
                  
                  syms x
                  [z2lin, z2lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu7a_3D'),'Userdata',z2lin_p);                  
                  set(findobj('tag','Hu7b_3D'),'Userdata',z2lin);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z2lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f6)));
                   set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                   set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                   set(th4a,'String',num2str(ns));
                   
                   args = linspace(z_bounds(1),z_bounds(2),50);
                   fun_value1 = f7(args);
                   fun_value2 = z2lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                end
                      
            end
            % ---------------------------------------------- %
            if(temp_result == 4)
                         
            value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','Hu1a_4D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_4D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f1)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(1)));
                   set(th3a,'String',sprintf('%.2f',xbmax1(1)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f1(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                        
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_4D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_4D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f2)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(2)));
                   set(th3a,'String',sprintf('%.2f',xbmax1(2)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f2(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_4D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_4D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f3)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(3)));
                   set(th3a,'String',sprintf('%.2f',xbmax1(3)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f3(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_4D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_4D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f4)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(4)));
                   set(th3a,'String',sprintf('%.2f',xbmax1(4)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f4(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 5
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_4D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_4D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu5a_4D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu5b_4D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f5)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 6
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_4D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_4D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu6a_4D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu6b_4D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f6)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f6(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
               case 7
                  flin_p1 = get(findobj('tag','Hu1a_4D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_4D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_4D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu5a_4D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu6a_4D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval'),'Userdata',z);
                  
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_4D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu7a_4D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu7b_4D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f7)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                  
                   fun_value1 = f7(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
              case 8
                  z_bounds = get(findobj('tag','Hpom1b_4D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu8a_4D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu8b_4D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f8)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f8(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 9
                 flin_p3 = get(findobj('tag','Hu3a_4D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_4D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu7a_4D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu8a_4D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_4D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu9a_4D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu9b_4D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f9)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f9(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
              case 10
                  z_bounds = get(findobj('tag','Hpom1b_4D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu10a_4D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu10b_4D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f10)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f10(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              end
            end
            % ----------------------------------------------------- %
            if(temp_result == 5)
                         
            value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','Hu1a_5D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_5D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f1)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(1)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(1)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f1(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_5D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_5D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f2)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(2)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f2(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 3 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_5D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_5D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f3)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(3)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(3)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f3(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                                 
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_5D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_5D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f4)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(4)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(4)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f4(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                   
                case 5  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [xbmin1(5) xbmax1(5)], ns);
                   set(findobj('tag','Hu5a_5D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu5b_5D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f5)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(5)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(5)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f5(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 6
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_5D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_5D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu6a_5D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu6b_5D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f6)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f_mf(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 7
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_5D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_5D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu7a_5D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu7b_5D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f7)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f7(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 8
                  flin_p1 = get(findobj('tag','Hu1a_5D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_5D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_5D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu6a_5D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu7a_5D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_5D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_5D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu8a_5D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu8b_5D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f8)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f8(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
              case 9
                  z_bounds = get(findobj('tag','Hpom1b_5D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu9a_5D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu9b_5D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f9)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f9(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 10
                 flin_p3 = get(findobj('tag','Hu3a_5D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_5D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu8a_5D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu9a_5D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_5D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_5Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_5D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu10a_5D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu10b_5D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f10)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f10(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
              case 11
                  z_bounds = get(findobj('tag','Hpom1b_5D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu11a_5D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu11b_5D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f11)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f11(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 12  
                 flin_p4 = get(findobj('tag','Hu4a_5D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_5D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu10a_5D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu11a_5D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_5Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_5Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu12a_5D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu12b_5D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f12)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f12(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 13
                  z_bounds = get(findobj('tag','Hpom1b_5Da'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu13a_5D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu13b_5D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end  
                  
                  set(th1a,'String',char(sym(f13)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f13(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
               end
               
            end
            if(temp_result == 6)
                         
            value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup = value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns)
                   set(findobj('tag','Hu1a_6D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_6D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f1)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(1)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(1)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f1(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_6D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_6D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                     
                   set(th1a,'String',char(sym(f2)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(2)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f2(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                        
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_6D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_6D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f3)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(3)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(3)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f3(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));
                   
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_6D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_6D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f4)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(4)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(4)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f4(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));                 
                   
                case 5  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [xbmin1(5) xbmax1(5)], ns);
                   set(findobj('tag','Hu5a_6D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu5b_6D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f5)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(5)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(5)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f5(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error));   
                   
                case 6 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [xbmin1(6) xbmax1(6)], ns);
                   set(findobj('tag','Hu6a_6D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu6b_6D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                   
                   set(th1a,'String',char(sym(f6)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(6)));
                   set(th3a,'String',sprintf('%.2f',xbmin1(6)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f5(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 7
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_6D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_6D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu7a_6D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu7b_6D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f7)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f7(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 8
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_6D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_6D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu8a_6D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu8b_6D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f8)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f8(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 9
                  flin_p1 = get(findobj('tag','Hu1a_6D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_6D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_6D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu7a_6D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu8a_6D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_6D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_6D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu9a_6D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu9b_6D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f9)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f9(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                                         
              case 10
                  z_bounds = get(findobj('tag','Hpom1b_6D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu10a_6D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu10b_6D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f10)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f10(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 11
                 flin_p3 = get(findobj('tag','Hu3a_6D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_6D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu9a_6D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu10a_6D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_6D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_6Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_6D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu11a_6D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu11b_6D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f10)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f10(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
              case 12
                  z_bounds = get(findobj('tag','Hpom1b_6D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu12a_6D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu12b_6D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f12)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f12(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 13  
                 flin_p4 = get(findobj('tag','Hu4a_6D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_6D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu11a_6D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu12a_6D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_6Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_6Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_6Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu13a_6D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu13b_6D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f12)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f13(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 14
                  z_bounds = get(findobj('tag','Hpom1b_6Da'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu14a_6D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu14b_6D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end  
                  
                  set(th1a,'String',char(sym(f14)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f14(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
                case 15 
                 flin_p4 = get(findobj('tag','Hu5a_6D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_6D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu13a_6D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu14a_6D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_6Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_6Db'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu15a_6D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu15b_6D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f15)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f15(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 16
                  z_bounds = get(findobj('tag','Hpom1b_6Db'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu16a_6D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu16b_6D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f16)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f15(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
               end  
            end
            if(temp_result == 7)
                         
            value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','Hu1a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                                              
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 5  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [xbmin1(5) xbmax1(5)], ns);
                   set(findobj('tag','Hu5a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu5b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 6 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [xbmin1(6) xbmax1(6)], ns);
                   set(findobj('tag','Hu6a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu6b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 7 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f7, var1, [xbmin1(7) xbmax1(7)], ns);
                   set(findobj('tag','Hu7a_7D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu7b_7D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(7),xbmax1(7),50);
                   f_mf = matlabFunction(sym(f{1}{7}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                 case 8
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_7D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_7D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu8a_7D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu8b_7D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f8)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f7(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 9
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_7D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_7D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu9a_7D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu9b_7D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f9)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f9(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 10
                  flin_p1 = get(findobj('tag','Hu1a_7D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_7D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_7D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu8a_7D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu9a_7D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_7D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_7D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu10a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu10b_7D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f10)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f9(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                                         
              case 11
                  z_bounds = get(findobj('tag','Hpom1b_7D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu11a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu11b_7D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f11)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f10(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 12
                 flin_p3 = get(findobj('tag','Hu3a_7D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu10a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu11a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_7Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];4
                 
                 set(findobj('tag','Hpom1b_7D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu12a_7D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu12b_7D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f12)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f12(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
              case 13
                  z_bounds = get(findobj('tag','Hpom1b_7D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu13a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu13b_7D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f13)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f13(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 14  
                 flin_p4 = get(findobj('tag','Hu4a_7D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu12a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu13a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_7Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu14a_7D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu14b_7D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f14)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f13(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 15
                  z_bounds = get(findobj('tag','Hpom1b_7Da'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu15a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu15b_7D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end  
                  
                  set(th1a,'String',char(sym(f15)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f14(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 16 
                 flin_p4 = get(findobj('tag','Hu5a_7D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu14a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu15a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_7Dc'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7Db'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu16a_7D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu16b_7D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f16)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 17
                  z_bounds = get(findobj('tag','Hpom1b_7Db'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu17a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu17b_7D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f17)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f16(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));  
               case 18 
                 flin_p4 = get(findobj('tag','Hu6a_7D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu7a_7D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu16a_7D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu17a_7D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+5),xbmax1(i+5),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_7Dc'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_7Dc'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu18a_7D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu18b_7D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f18)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 19
                  z_bounds = get(findobj('tag','Hpom1b_7Dc'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu19a_7D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu19b_7D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f17)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f15(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));     
               end
            end
            if(temp_result == 8)
               value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','Hu1a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                                              
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 5  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [xbmin1(5) xbmax1(5)], ns);
                   set(findobj('tag','Hu5a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu5b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 6 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [xbmin1(6) xbmax1(6)], ns);
                   set(findobj('tag','Hu6a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu6b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 7 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f7, var1, [xbmin1(7) xbmax1(7)], ns);
                   set(findobj('tag','Hu7a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu7b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(7),xbmax1(7),50);
                   f_mf = matlabFunction(sym(f{1}{7}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 8
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f8, var1, [xbmin1(8) xbmax1(8)], ns);
                   set(findobj('tag','Hu8a_8D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu8b_8D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(8),xbmax1(8),50);
                   f_mf = matlabFunction(sym(f{1}{8}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f8)));
                   set(th2a,'String',sprintf('%.2f',xbmin1(8)));
                   set(th3a,'String',sprintf('%.2f',xbmax1(8)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f7(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 9
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_8D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_8D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu9a_8D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu9b_8D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f9)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f7(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 10
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_8D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_8D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu10a_8D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu10b_8D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f10)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f10(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 11
                  flin_p1 = get(findobj('tag','Hu1a_8D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_8D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_8D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu9a_8D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu10a_8D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_8D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_8D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu11a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu11b_8D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f11)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f11(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                                         
              case 12
                  z_bounds = get(findobj('tag','Hpom1b_8D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu12a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu12b_8D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f12)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f10(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 13
                 flin_p3 = get(findobj('tag','Hu3a_8D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu11a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu12a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu13a_8D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu13b_8D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f13)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f13(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
              case 14
                  z_bounds = get(findobj('tag','Hpom1b_8D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu14a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu14b_8D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f14)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f14(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 15
                 flin_p4 = get(findobj('tag','Hu4a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu13a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu14a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu15a_8D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu15b_8D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f15)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f15(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 16
                  z_bounds = get(findobj('tag','Hpom1b_8Da'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu16a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu16b_8D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end  
                  
                  set(th1a,'String',char(sym(f16)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f16(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 17
                 flin_p4 = get(findobj('tag','Hu5a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu15a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu16a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Dc'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8Db'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu17a_8D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu17b_8D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f17)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f17(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 18
                  z_bounds = get(findobj('tag','Hpom1b_8Db'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu18a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu18b_8D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f18)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f18(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));  
              case 19 
                 flin_p4 = get(findobj('tag','Hu6a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu7a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu17a_8D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu18a_8D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+5),xbmax1(i+5),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Dc'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8Dd'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8Dd'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu19a_8D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu19b_8D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f19)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 20
                  z_bounds = get(findobj('tag','Hpom1b_8Dd'),'Userdata')
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu20a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu20b_8D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f20)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f19(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));  
              case 21
                 flin_p4 = get(findobj('tag','Hu7a_8D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu8a_8D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu19a_8D'),'Userdata')
                 zlin_p2 = get(findobj('tag','Hu20a_8D'),'Userdata')
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+6),xbmax1(i+6),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_8Dd'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_8De'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_8De'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu21a_8D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu21b_8D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f20)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 22
                  z_bounds = get(findobj('tag','Hpom1b_8De'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu22a_8D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu22b_8D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f21)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f21(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));        
               end
            end
            if(temp_result == 9)
               value_of_popup = get(findobj('Tag','2D'),'Value');
            if(length(value_of_popup) == 1)
               value_of_popup = value_of_popup;
            else
               value_of_popup =value_of_popup{1};
            end
            
            switch value_of_popup
                case 1
                   var1 = get(findobj('Tag','but3'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f1, var1, [xbmin1(1) xbmax1(1)], ns);
                   set(findobj('tag','Hu1a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu1b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(1),xbmax1(1),50);
                   f_mf = matlabFunction(sym(f{1}{1}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','fun'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 2
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f2, var1, [xbmin1(2) xbmax1(2)], ns);
                   set(findobj('tag','Hu2a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu2b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(2),xbmax1(2),50);
                   f_mf = matlabFunction(sym(f{1}{2}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                                              
                case 3  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f3, var1, [xbmin1(3) xbmax1(3)], ns);
                   set(findobj('tag','Hu3a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu3b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(3),xbmax1(3),50);
                   f_mf = matlabFunction(sym(f{1}{3}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 4  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f4, var1, [xbmin1(4) xbmax1(4)], ns);
                   set(findobj('tag','Hu4a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu4b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(4),xbmax1(4),50);
                   f_mf = matlabFunction(sym(f{1}{4}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 5  
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [xbmin1(5) xbmax1(5)], ns);
                   set(findobj('tag','Hu5a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu5b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(5),xbmax1(5),50);
                   f_mf = matlabFunction(sym(f{1}{5}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 6 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [xbmin1(6) xbmax1(6)], ns);
                   set(findobj('tag','Hu6a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu6b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(6),xbmax1(6),50);
                   f_mf = matlabFunction(sym(f{1}{6}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 7 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f7, var1, [xbmin1(7) xbmax1(7)], ns);
                   set(findobj('tag','Hu7a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu7b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(7),xbmax1(7),50);
                   f_mf = matlabFunction(sym(f{1}{7}));
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                 case 8 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f8, var1, [xbmin1(8) xbmax1(8)], ns);
                   set(findobj('tag','Hu8a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu8b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(8),xbmax1(8),50);
                   f_mf = matlabFunction(sym(f{1}{8}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 9 
                   var1 = get(findobj('Tag','but1'),'Value');
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f9, var1, [xbmin1(9) xbmax1(9)], ns);
                   set(findobj('tag','Hu9a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu9b_9D'),'Userdata',f1_apprx);
                   args = linspace(xbmin1(9),xbmax1(9),50);
                   f_mf = matlabFunction(sym(f{1}{9}));
                   F2 = findobj('Tag','figure2');
                   set(findobj('tag','apps'),'Userdata',f1_aprx_data);
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end
                case 10
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_9D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_9D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_sum(1),zb_sum(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f6 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f6, var1, [zb_sum(1) zb_sum(2)], ns);
                   set(findobj('tag','Hu10a_9D'),'Userdata',f1_aprx_data);
                   set(findobj('tag','Hu10b_9D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end  
                   
                   set(th1a,'String',char(sym(f10)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f7(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 11
                   var1 = get(findobj('Tag','but1'),'Value');
                   f1lin = get(findobj('tag','Hu1b_9D'),'Userdata');
                   f2lin = get(findobj('tag','Hu2b_9D'),'Userdata');
                   [zb_sum, zb_diff] = autoprox_getminmax(f1lin, [xbmin1(1) xbmax1(1)], f2lin, [xbmin1(2) xbmax1(2)]);
                   args = linspace(zb_diff(1),zb_diff(2),50);
                   f_mf = @(x) 1/4*x.^2;
                   f5 = sym(f_mf);
                   [f1_apprx,f1_aprx_data] = autoprox_1d(f5, var1, [zb_diff(1) zb_diff(2)], ns);
                   set(findobj('tag','Hu11a_9D'),'Userdata',f1_aprx_data)
                   set(findobj('tag','Hu11b_9D'),'Userdata',f1_apprx);
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,f1_apprx(args),'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f11)));
                   set(th2a,'String',sprintf('%.2f',zb_diff(1)));
                   set(th3a,'String',sprintf('%.2f',zb_diff(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f11(args);
                   fun_value2 = f1_apprx(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                   
                case 12
                  flin_p1 = get(findobj('tag','Hu1a_9D'),'Userdata');
                  flin_p2 = get(findobj('tag','Hu2a_9D'),'Userdata');
                  flin_p3 = get(findobj('tag','Hu3a_9D'),'Userdata');
                  zlin_p1 = get(findobj('tag','Hu10a_9D'),'Userdata');
                  zlin_p2 = get(findobj('tag','Hu11a_9D'),'Userdata');
                    
                  flin_p = {flin_p1{1} flin_p2{1} flin_p3{1}};
                    
                  for i = 1:length(flin_p)
                      f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i),xbmax1(i),3));
                  end
                    
                  %%% evaluation of the all possible combinations of input arguments %%%
                  Uarg = cell(1,2);
                  Uarg{1} = f_hod{1};
                  Uarg{2} = f_hod{2};
                    
                  Ucombs = mpt_allcombs(Uarg);
                  f1z = Ucombs(:,1);
                  f2z = Ucombs(:,2);
                    
                  %%% obtaining the good_values %%%
                  y1 = eval_multilin(zlin_p1{1},(f1z+f2z));
                  y2 = eval_multilin(zlin_p2{1},(f1z-f2z));
                  z = y1 - y2;
                  
                  set(findobj('tag','Hu_gval_9D'),'Userdata',z);
                                    
                  f2min=min(z);
                  f2max=max(z);
 
                  f1min=min(f_hod{3});
                  f1max=max(f_hod{3});
                    
                  %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                  u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                  
                  u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                  
                  zb_sum = [u1min u1max];
                  zb_diff = [u2min u2max];
                  set(findobj('tag','Hpom1b_9D'),'Userdata',zb_diff);
                  
                  %%% approximation of the quadratic functions %%%
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                  set(findobj('tag','Hu12a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu12b_9D'),'Userdata',z1lin);
                                    
                  %%% approximation of the quadratic functions %%%
                  args = linspace(zb_sum(1),zb_sum(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                   F2 = findobj('Tag','figure2');
                   if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                      'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                      'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                   end 
                   
                   set(th1a,'String',char(sym(f12)));
                   set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                   set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                   set(th4a,'String',num2str(ns));
                   
                   fun_value1 = f12(args);
                   fun_value2 = z1lin(args);
                   average_error = sum((fun_value1-fun_value2).^2);
                   worst_error = max(abs((fun_value1-fun_value2)));
                   
                   avg_error = average_error;
                   wst_error = worst_error;
                   
                   set(th6,'String',num2str(average_error));
                   set(th8,'String',num2str(worst_error)); 
                                         
              case 13
                  z_bounds = get(findobj('tag','Hpom1b_9D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu13a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu13b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f13)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f13(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 14
                 flin_p3 = get(findobj('tag','Hu3a_9D'),'Userdata');
                 flin_p4 = get(findobj('tag','Hu4a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu12a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu13a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p3{1} flin_p4{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+2),xbmax1(i+2),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9D'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Da'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9D'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu14a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu14b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f14)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f14(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
              case 15
                  z_bounds = get(findobj('tag','Hpom1b_9D'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu15a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu15b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f15)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f15(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 16
                 flin_p4 = get(findobj('tag','Hu4a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu5a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu14a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu15a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+3),xbmax1(i+3),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Da'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Db'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Da'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu16a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu16b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f16)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 17
                  z_bounds = get(findobj('tag','Hpom1b_9Da'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu17a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu17b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end  
                  
                  set(th1a,'String',char(sym(f17)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f16(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));
                  
              case 18
                 flin_p4 = get(findobj('tag','Hu5a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu6a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu16a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu17a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+4),xbmax1(i+4),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Db'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                 
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Dc'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Db'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu18a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu18b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f18)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f18(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 19
                  z_bounds = get(findobj('tag','Hpom1b_9Db'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu19a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu19b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f19)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f19(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));  
              case 20
                 flin_p4 = get(findobj('tag','Hu6a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu7a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu18a_9D'),'Userdata');
                 zlin_p2 = get(findobj('tag','Hu19a_9D'),'Userdata');
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+5),xbmax1(i+5),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Dc'),'Userdata')
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Dd'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Dd'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu20a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu20b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f20)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 21
                  z_bounds = get(findobj('tag','Hpom1b_9Dd'),'Userdata')
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu21a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu21b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f21)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f19(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));  
              case 22
                 flin_p4 = get(findobj('tag','Hu7a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu8a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu20a_9D'),'Userdata')
                 zlin_p2 = get(findobj('tag','Hu21a_9D'),'Userdata')
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+6),xbmax1(i+6),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9Dd'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9De'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9De'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu22a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu22b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f20)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 23
                  z_bounds = get(findobj('tag','Hpom1b_9De'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu23a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu23b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f23)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f21(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));        
               case 24
                 flin_p4 = get(findobj('tag','Hu8a_9D'),'Userdata');
                 flin_p5 = get(findobj('tag','Hu9a_9D'),'Userdata');
                 zlin_p1 = get(findobj('tag','Hu22a_9D'),'Userdata')
                 zlin_p2 = get(findobj('tag','Hu23a_9D'),'Userdata')
                                                  
                 flin_p = {flin_p4{1} flin_p5{1}};
                 
                 for i = 1:length(flin_p)
                     f_hod{i} = eval_multilin(flin_p{i},linspace(xbmin1(i+7),xbmax1(i+7),3));
                 end
                 
                 fun_temp = get(findobj('tag','Hu_gval_9De'),'Userdata');
                                                  
                 %%% evaluation of all possible combination of input arguments %%%
                 Uarg = cell(1,2);
                 Uarg{1} = fun_temp';
                 Uarg{2} = f_hod{1};
                 
                 Ucombs = mpt_allcombs(Uarg);
                 fzz = Ucombs(:,1);
                 f3z = Ucombs(:,2);
                               
                 %%% approximation of the quadratic functions %%%
                 y1 = eval_multilin(zlin_p1{1},(fzz+f3z));
                 y2 = eval_multilin(zlin_p2{1},(fzz-f3z));
                 z = y1-y2;
                 
                 set(findobj('tag','Hu_gval_9Df'),'Userdata',z);
                 
                 %%% finding the minimal and maximal function values %%%
                 f2min=min(z);
                 f2max=max(z);
                 
                 f1min=min(f_hod{2});
                 f1max=max(f_hod{2});
                 
                 %%% obtaining the boundaries for apporximation of the kvadratic functions %%%
                 u1max = max([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 u1min = min([(f1max+f2max), (f1max+f2min), (f1min+f2max), (f1min+f2min)]);
                 
                 u2max = max([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 u2min = min([(f1max-f2max), (f1max-f2min), (f1min-f2max), (f1min-f2min)]);
                 
                 zb_sum = [u1min u1max];
                 zb_diff = [u2min u2max];
                 
                 set(findobj('tag','Hpom1b_9Df'),'Userdata',zb_diff);
                 
                 %%% approximation of the quadratic functions %%%
                 syms x
                 [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, zb_sum, ns);
                 set(findobj('tag','Hu24a_9D'),'Userdata',z1lin_p);
                 set(findobj('tag','Hu24b_9D'),'Userdata',z1lin);
                 
                 %%% approximation of the quadratic functions %%%
                 args = linspace(zb_sum(1),zb_sum(2),50);
                 
                 f_mf = @(x) 1/4*x.^2;
                 
                 main_fhod = eval_multilin(z1lin_p{1},args);
                 
                 F2 = findobj('Tag','figure2');
                 if(isempty(F2))
                     Monitor = get(0,'Screensize');
                     F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                         'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                         'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                     set(F2,'visible','on');
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 else
                     set(F2,'visible','on');
                     figure(F2);
                     plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                     legend(char(func), 'Approximation', 'Location', 'Best');
                 end
                 
                 set(th1a,'String',char(sym(f24)));
                 set(th2a,'String',sprintf('%.2f',zb_sum(1)));
                 set(th3a,'String',sprintf('%.2f',zb_sum(2)));
                 set(th4a,'String',num2str(ns));
                 
                 fun_value1 = f16(args);
                 fun_value2 = z1lin(args);
                 average_error = sum((fun_value1-fun_value2).^2);
                 worst_error = max(abs((fun_value1-fun_value2)));
                 
                 avg_error = average_error;
                 wst_error = worst_error;
                 
                 set(th6,'String',num2str(average_error));
                 set(th8,'String',num2str(worst_error));
                 
               case 25
                  z_bounds = get(findobj('tag','Hpom1b_9Df'),'Userdata');
                                    
                  syms x
                  [z1lin, z1lin_p] = autoprox_1d(@(x) 1/4*x.^2, x, z_bounds, ns);
                  set(findobj('tag','Hu25a_9D'),'Userdata',z1lin_p);
                  set(findobj('tag','Hu25b_9D'),'Userdata',z1lin);
                  
                  %%% approximation of the quadratic functions %%%
                  args = linspace(z_bounds(1),z_bounds(2),50);
                  
                  f_mf = @(x) 1/4*x.^2;
                  main_fhod = eval_multilin(z1lin_p{1},args);    
                                    
                  F2 = findobj('Tag','figure2');
                  if(isempty(F2))
                      Monitor = get(0,'Screensize');
                      F2 = figure('Units','Pixels','Name','Depiction of the given function',...
                          'position',[0.5*Monitor(4) 0.4*Monitor(4) 0.6*Monitor(4) 0.5*Monitor(4)],...
                          'Tag','figure2','color',[0.701961 0.701961 0.701961],'Visible','off');
                      set(F2,'visible','on');
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  else
                      set(F2,'visible','on');
                      figure(F2);
                      plot(args,f_mf(args),'b-',args,main_fhod,'r--', 'linewidth', 2);
                      legend(char(func), 'Approximation', 'Location', 'Best');
                  end
                  
                  set(th1a,'String',char(sym(f25)));
                  set(th2a,'String',sprintf('%.2f',z_bounds(1)));
                  set(th3a,'String',sprintf('%.2f',z_bounds(2)));
                  set(th4a,'String',num2str(ns));
                  
                  fun_value1 = f21(args);
                  fun_value2 = z1lin(args);
                  average_error = sum((fun_value1-fun_value2).^2);
                  worst_error = max(abs((fun_value1-fun_value2)));
                  
                  avg_error = average_error;
                  wst_error = worst_error;
                  
                  set(th6,'String',num2str(average_error));
                  set(th8,'String',num2str(worst_error));        
            end
          end    
        end
        case('spl')
           
           syms u1 u2 u3 u4 u5 u6 u7 u8 u9 u10 u11 u12 u13 u14 u15 u16 u17 u18
           func = get(findobj('tag','fun'),'String')
           func1 = sym(func);
           vars = findsym(func1); 
           temp_result = findstr(vars,',');
           temp_result = length(temp_result) + 1;
           if(temp_result == 2)
               func = strcat(func,'*u1^2*u2^2');
           elseif(temp_result == 3)
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2');
           elseif(temp_result == 4)    
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2');
           elseif(temp_result == 5)
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2*u7^2*u8^2');
           elseif(temp_result == 6)
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2*u7^2*u8^2*u9^2*u10^2');
           elseif(temp_result == 7)
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2*u7^2*u8^2*u9^2*u10^2*u11^2*u12^2');
           elseif(temp_result == 8)
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2*u7^2*u8^2*u9^2*u10^2*u11^2*u12^2*u13^2*u14^2');
           elseif(temp_result == 9)
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2*u7^2*u8^2*u9^2*u10^2*u11^2*u12^2*u13^2*u14^2*u15^2*u16^2');
           else
               func = strcat(func,'*u1^2*u2^2*u3^2*u4^2*u5^2*u6^2*u7^2*u8^2*u9^2*u10^2*u11^2*u12^2*u13^2*u14^2*u15^2*u16^2*u17^2*u18^2');
           end
           [L,V] = split(func,vars);
           [subL,subV] = separate_functions(L,V);
           xbmin = get(findobj('tag','Lbound'),'String');
           xbmin1 = str2num(xbmin);
           xbmax = get(findobj('tag','Ubound'),'String');
           xbmax1 = str2num(xbmax);
           ns = get(findobj('tag','apps'),'String');
           ns1 = str2num(ns);
           ns1 = ns1';
                          
           ht11 = findobj('tag','fun');   
                                   
           set(ht11,'Visible','off');
           F1 = findobj('Tag','figure1');
           figure(F1);
           h41 = uicontrol('Units','normalized','position',[0.64 0.77 0.15 0.06],'Style','popup',...
           'Foregroundcolor','black','Backgroundcolor',get(gcf,'Color'),'tag','2D','String',subL{:});
           set(findobj('Tag','funpos'),'position',[0.62 0.81 0.15 0.06]);
              
         case('export')
            var1 = get(findobj('Tag','but1'),'Value');
            var2 = get(findobj('Tag','but2'),'Value');
            var3 = get(findobj('Tag','but3'),'Value');
            if(var1) 
                main_data_1D = cell(1,3);
                data = get(findobj('Tag','fun'),'Userdata');
                file_name = get(findobj('Tag','fname'),'String');
                symVars_1D = get(findobj('tag','hu_11_1D'),'Userdata');
                LU_bounds = get(findobj('tag','hu_12_1D'),'Userdata');
                main_data_1D{1} = data{1};
                main_data_1D{2} = symVars_1D;
                main_data_1D{3} = LU_bounds;
                hysdel_1d(main_data_1D,file_name);
                ret_value = exist(file_name);
                F3 = findobj('tag','figure3');
                if(isempty(F3))
                    Monitor = get(0,'Screensize');
                    F3 = figure('Units','Pixels','Name','Info','position',...
                        [0.5*Monitor(4) 0.4*Monitor(4) 0.3*Monitor(4) 0.2*Monitor(4)],'Tag','figure3',...
                        'Visible','off','menubar','none','numbertitle','off');
                    set(F3,'visible','on');
                else
                    set(F3,'visible','on');
                end
                if(ret_value == 2)
                    figure(F3)
                    h33 = uicontrol('units','normalized','position',[0.2 0.4 0.6 0.3],'Style','text',...
                        'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black',...
                        'String','The export was succesfully done','Fontsize',13);
                end
            end
                      
            if(var2)
                main_data = cell(1,4);
                data = cell(1,4);
                data1 = get(findobj('Tag','fun'),'Userdata');
                data2 = get(findobj('Tag','apps'),'Userdata');
                data3 = get(findobj('Tag','Lbound'),'Userdata');
                data4 = get(findobj('Tag','Ubound'),'Userdata');
                symVar = get(findobj('Tag','hu_11'),'Userdata');
                Xbmin = get(findobj('Tag','hu_12'),'Userdata');
                Xbmax = get(findobj('Tag','hu_13'),'Userdata');
                file_name = get(findobj('Tag','fname'),'String');
                data{1} = data1{1};
                data{2} = data2{1};
                data{3} = data3{1};
                data{4} = data4{1};
                main_data{1} = data;
                main_data{2} = symVar;
                main_data{3} = Xbmin;
                main_data{4} = Xbmax;
                hysdel_2d(main_data,file_name);
                ret_value = exist(file_name);
                F3 = findobj('tag','figure3');
                if(isempty(F3))
                    Monitor = get(0,'Screensize');
                    F3 = figure('Units','Pixels','Name','Info','position',...
                        [0.5*Monitor(4) 0.4*Monitor(4) 0.3*Monitor(4) 0.2*Monitor(4)],'Tag','figure3',...
                        'Visible','off','menubar','none','numbertitle','off');
                    set(F3,'visible','on');
                else
                    set(F3,'visible','on');
                end
                if(ret_value == 2)
                    figure(F3)
                    h33 = uicontrol('units','normalized','position',[0.2 0.4 0.6 0.3],'Style','text',...
                        'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black',...
                        'String','The export was succesfully done','Fontsize',13);
                end
            end
            if(var3)
               
               main_data_3D = cell(1,9); 
               switcher = get(findobj('tag','to_export'),'Userdata');
                             
               if(switcher == 3)
                   flin_p1 = get(findobj('tag','Hu1a_3D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_3D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_3D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu4a_3D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu5a_3D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu6a_3D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu7a_3D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_3D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_3D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_3D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu4b_3D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu5b_3D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu6b_3D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu7b_3D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1}};
                   main_flin = {flin_1 flin_2 flin_3};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4};
               elseif(switcher == 4)
                   flin_p1 = get(findobj('tag','Hu1a_4D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_4D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_4D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_4D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu5a_4D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu6a_4D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu7a_4D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu8a_4D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu9a_4D'),'Userdata');
                   zlin_p6 = get(findobj('tag','Hu10a_4D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_4D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_4D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_4D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_4D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu5b_4D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu6b_4D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu7b_4D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu8b_4D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu9b_4D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu10b_4D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6};
                   
               elseif(switcher == 5)
                   flin_p1 = get(findobj('tag','Hu1a_5D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_5D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_5D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_5D'),'Userdata');
                   flin_p5 = get(findobj('tag','Hu5a_5D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu6a_5D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu7a_5D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu8a_5D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu9a_5D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu10a_5D'),'Userdata')
                   zlin_p6 = get(findobj('tag','Hu11a_5D'),'Userdata')
                   zlin_p7 = get(findobj('tag','Hu12a_5D'),'Userdata')
                   zlin_p8 = get(findobj('tag','Hu13a_5D'),'Userdata')
                   flin_1 =  get(findobj('tag','Hu1b_5D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_5D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_5D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_5D'),'Userdata');
                   flin_5 =  get(findobj('tag','Hu5b_5D'),'Userdata')
                   zlin_1 = get(findobj('tag','Hu6b_5D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu7b_5D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu8b_5D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu9b_5D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu10b_5D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu11b_5D'),'Userdata');
                   zlin_7 = get(findobj('tag','Hu12b_5D'),'Userdata');
                   zlin_8 = get(findobj('tag','Hu13b_5D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1} flin_p5{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1} zlin_p7{1} zlin_p8{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4 flin_5};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6 zlin_7 zlin_8};
                      
               elseif(switcher == 6)
                   flin_p1 = get(findobj('tag','Hu1a_6D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_6D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_6D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_6D'),'Userdata');
                   flin_p5 = get(findobj('tag','Hu5a_6D'),'Userdata');
                   flin_p6 = get(findobj('tag','Hu6a_6D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu7a_6D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu8a_6D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu9a_6D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu10a_6D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu11a_6D'),'Userdata');
                   zlin_p6 = get(findobj('tag','Hu12a_6D'),'Userdata');
                   zlin_p7 = get(findobj('tag','Hu13a_6D'),'Userdata');
                   zlin_p8 = get(findobj('tag','Hu14a_6D'),'Userdata');
                   zlin_p9 = get(findobj('tag','Hu15a_6D'),'Userdata');
                   zlin_p10 = get(findobj('tag','Hu16a_6D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_6D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_6D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_6D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_6D'),'Userdata');
                   flin_5 =  get(findobj('tag','Hu5b_6D'),'Userdata');
                   flin_6 =  get(findobj('tag','Hu6b_6D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu7b_6D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu8b_6D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu9b_6D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu10b_6D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu11b_6D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu12b_6D'),'Userdata');
                   zlin_7 = get(findobj('tag','Hu13b_6D'),'Userdata');
                   zlin_8 = get(findobj('tag','Hu14b_6D'),'Userdata');
                   zlin_9 = get(findobj('tag','Hu15b_6D'),'Userdata');
                   zlin_10 = get(findobj('tag','Hu16b_6D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1} flin_p5{1} flin_p6{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1} zlin_p7{1} zlin_p8{1} zlin_p9{1} zlin_p10{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4 flin_5 flin_6};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6 zlin_7 zlin_8 zlin_9 zlin_10};    
               
               elseif(switcher == 7)
                   flin_p1 = get(findobj('tag','Hu1a_7D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_7D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_7D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_7D'),'Userdata');
                   flin_p5 = get(findobj('tag','Hu5a_7D'),'Userdata');
                   flin_p6 = get(findobj('tag','Hu6a_7D'),'Userdata');
                   flin_p7 = get(findobj('tag','Hu7a_7D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu8a_7D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu9a_7D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu10a_7D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu11a_7D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu12a_7D'),'Userdata');
                   zlin_p6 = get(findobj('tag','Hu13a_7D'),'Userdata');
                   zlin_p7 = get(findobj('tag','Hu14a_7D'),'Userdata');
                   zlin_p8 = get(findobj('tag','Hu15a_7D'),'Userdata');
                   zlin_p9 = get(findobj('tag','Hu16a_7D'),'Userdata');
                   zlin_p10 = get(findobj('tag','Hu17a_7D'),'Userdata');
                   zlin_p11 = get(findobj('tag','Hu18a_7D'),'Userdata');
                   zlin_p12 = get(findobj('tag','Hu19a_7D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_7D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_7D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_7D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_7D'),'Userdata');
                   flin_5 =  get(findobj('tag','Hu5b_7D'),'Userdata');
                   flin_6 =  get(findobj('tag','Hu6b_7D'),'Userdata');
                   flin_7 =  get(findobj('tag','Hu7b_7D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu8b_7D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu9b_7D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu10b_7D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu11b_7D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu12b_7D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu13b_7D'),'Userdata');
                   zlin_7 = get(findobj('tag','Hu14b_7D'),'Userdata');
                   zlin_8 = get(findobj('tag','Hu15b_7D'),'Userdata');
                   zlin_9 = get(findobj('tag','Hu16b_7D'),'Userdata');
                   zlin_10 = get(findobj('tag','Hu17b_7D'),'Userdata');
                   zlin_11 = get(findobj('tag','Hu18b_7D'),'Userdata');
                   zlin_12 = get(findobj('tag','Hu19b_7D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1} flin_p5{1} flin_p6{1} flin_p7{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1} zlin_p7{1},...
                                 zlin_p8{1} zlin_p9{1} zlin_p10{1} zlin_p11{1} zlin_p12{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4 flin_5 flin_6 flin_7};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6 zlin_7 zlin_8 zlin_9 zlin_10 zlin_11 zlin_12};    
                   
               elseif(switcher == 8)
                   flin_p1 = get(findobj('tag','Hu1a_8D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_8D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_8D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_8D'),'Userdata');
                   flin_p5 = get(findobj('tag','Hu5a_8D'),'Userdata');
                   flin_p6 = get(findobj('tag','Hu6a_8D'),'Userdata');
                   flin_p7 = get(findobj('tag','Hu7a_8D'),'Userdata');
                   flin_p8 = get(findobj('tag','Hu8a_8D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu9a_8D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu10a_8D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu11a_8D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu12a_8D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu13a_8D'),'Userdata');
                   zlin_p6 = get(findobj('tag','Hu14a_8D'),'Userdata');
                   zlin_p7 = get(findobj('tag','Hu15a_8D'),'Userdata');
                   zlin_p8 = get(findobj('tag','Hu16a_8D'),'Userdata');
                   zlin_p9 = get(findobj('tag','Hu17a_8D'),'Userdata');
                   zlin_p10 = get(findobj('tag','Hu18a_8D'),'Userdata');
                   zlin_p11 = get(findobj('tag','Hu19a_8D'),'Userdata');
                   zlin_p12 = get(findobj('tag','Hu20a_8D'),'Userdata');
                   zlin_p13 = get(findobj('tag','Hu21a_8D'),'Userdata');
                   zlin_p14 = get(findobj('tag','Hu22a_8D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_8D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_8D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_8D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_8D'),'Userdata');
                   flin_5 =  get(findobj('tag','Hu5b_8D'),'Userdata');
                   flin_6 =  get(findobj('tag','Hu6b_8D'),'Userdata');
                   flin_7 =  get(findobj('tag','Hu7b_8D'),'Userdata');
                   flin_8 =  get(findobj('tag','Hu8b_8D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu9b_8D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu10b_8D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu11b_8D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu12b_8D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu13b_8D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu14b_8D'),'Userdata');
                   zlin_7 = get(findobj('tag','Hu15b_8D'),'Userdata');
                   zlin_8 = get(findobj('tag','Hu16b_8D'),'Userdata');
                   zlin_9 = get(findobj('tag','Hu17b_8D'),'Userdata');
                   zlin_10 = get(findobj('tag','Hu18b_8D'),'Userdata');
                   zlin_11 = get(findobj('tag','Hu19b_8D'),'Userdata');
                   zlin_12 = get(findobj('tag','Hu20b_8D'),'Userdata');
                   zlin_13 = get(findobj('tag','Hu21b_8D'),'Userdata');
                   zlin_14 = get(findobj('tag','Hu22b_8D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1} flin_p5{1} flin_p6{1} flin_p7{1} flin_p8{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1} zlin_p7{1},...
                                 zlin_p8{1} zlin_p9{1} zlin_p10{1} zlin_p11{1} zlin_p12{1} zlin_p13{1} zlin_p14{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4 flin_5 flin_6 flin_7 flin_8};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6 zlin_7 zlin_8 zlin_9 zlin_10 zlin_11 zlin_12 zlin_13 zlin_14};          
                   
               elseif(switcher == 9)
                   flin_p1 = get(findobj('tag','Hu1a_9D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_9D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_9D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_9D'),'Userdata');
                   flin_p5 = get(findobj('tag','Hu5a_9D'),'Userdata');
                   flin_p6 = get(findobj('tag','Hu6a_9D'),'Userdata');
                   flin_p7 = get(findobj('tag','Hu7a_9D'),'Userdata');
                   flin_p8 = get(findobj('tag','Hu8a_9D'),'Userdata');
                   flin_p9 = get(findobj('tag','Hu9a_9D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu10a_9D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu11a_9D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu12a_9D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu13a_9D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu14a_9D'),'Userdata');
                   zlin_p6 = get(findobj('tag','Hu15a_9D'),'Userdata');
                   zlin_p7 = get(findobj('tag','Hu16a_9D'),'Userdata');
                   zlin_p8 = get(findobj('tag','Hu17a_9D'),'Userdata');
                   zlin_p9 = get(findobj('tag','Hu18a_9D'),'Userdata');
                   zlin_p10 = get(findobj('tag','Hu19a_9D'),'Userdata');
                   zlin_p11 = get(findobj('tag','Hu20a_9D'),'Userdata');
                   zlin_p12 = get(findobj('tag','Hu21a_9D'),'Userdata');
                   zlin_p13 = get(findobj('tag','Hu22a_9D'),'Userdata');
                   zlin_p14 = get(findobj('tag','Hu23a_9D'),'Userdata');
                   zlin_p15 = get(findobj('tag','Hu24a_9D'),'Userdata');
                   zlin_p16 = get(findobj('tag','Hu25a_9D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_9D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_9D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_9D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_9D'),'Userdata');
                   flin_5 =  get(findobj('tag','Hu5b_9D'),'Userdata');
                   flin_6 =  get(findobj('tag','Hu6b_9D'),'Userdata');
                   flin_7 =  get(findobj('tag','Hu7b_9D'),'Userdata');
                   flin_8 =  get(findobj('tag','Hu8b_9D'),'Userdata');
                   flin_9 =  get(findobj('tag','Hu9b_9D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu10b_9D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu11b_9D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu12b_9D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu13b_9D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu14b_9D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu15b_9D'),'Userdata');
                   zlin_7 = get(findobj('tag','Hu16b_9D'),'Userdata');
                   zlin_8 = get(findobj('tag','Hu17b_9D'),'Userdata');
                   zlin_9 = get(findobj('tag','Hu18b_9D'),'Userdata');
                   zlin_10 = get(findobj('tag','Hu19b_9D'),'Userdata');
                   zlin_11 = get(findobj('tag','Hu20b_9D'),'Userdata');
                   zlin_12 = get(findobj('tag','Hu21b_9D'),'Userdata');
                   zlin_13 = get(findobj('tag','Hu22b_9D'),'Userdata');
                   zlin_14 = get(findobj('tag','Hu23b_9D'),'Userdata');
                   zlin_15 = get(findobj('tag','Hu24b_9D'),'Userdata');
                   zlin_16 = get(findobj('tag','Hu22b_9D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1} flin_p5{1} flin_p6{1} flin_p7{1} flin_p8{1} flin_p9{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1} zlin_p7{1},...
                                 zlin_p8{1} zlin_p9{1} zlin_p10{1} zlin_p11{1} zlin_p12{1} zlin_p13{1} zlin_p14{1} zlin_p15{1} zlin_p16{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4 flin_5 flin_6 flin_7 flin_8 flin_9};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6 zlin_7,...
                                zlin_8 zlin_9 zlin_10 zlin_11 zlin_12 zlin_13 zlin_14 zlin_15 zlin_16};
                
               elseif(switcher == 10)
                   flin_p1 = get(findobj('tag','Hu1a_9D'),'Userdata');
                   flin_p2 = get(findobj('tag','Hu2a_9D'),'Userdata');
                   flin_p3 = get(findobj('tag','Hu3a_9D'),'Userdata');
                   flin_p4 = get(findobj('tag','Hu4a_9D'),'Userdata');
                   flin_p5 = get(findobj('tag','Hu5a_9D'),'Userdata');
                   flin_p6 = get(findobj('tag','Hu6a_9D'),'Userdata');
                   flin_p7 = get(findobj('tag','Hu7a_9D'),'Userdata');
                   flin_p8 = get(findobj('tag','Hu8a_9D'),'Userdata');
                   flin_p9 = get(findobj('tag','Hu9a_9D'),'Userdata');
                   flin_p10 = get(findobj('tag','Hu10a_9D'),'Userdata');
                   zlin_p1 = get(findobj('tag','Hu11a_9D'),'Userdata');
                   zlin_p2 = get(findobj('tag','Hu12a_9D'),'Userdata');
                   zlin_p3 = get(findobj('tag','Hu13a_9D'),'Userdata');
                   zlin_p4 = get(findobj('tag','Hu14a_9D'),'Userdata');
                   zlin_p5 = get(findobj('tag','Hu15a_9D'),'Userdata');
                   zlin_p6 = get(findobj('tag','Hu16a_9D'),'Userdata');
                   zlin_p7 = get(findobj('tag','Hu17a_9D'),'Userdata');
                   zlin_p8 = get(findobj('tag','Hu18a_9D'),'Userdata');
                   zlin_p9 = get(findobj('tag','Hu19a_9D'),'Userdata');
                   zlin_p10 = get(findobj('tag','Hu20a_9D'),'Userdata');
                   zlin_p11 = get(findobj('tag','Hu21a_9D'),'Userdata');
                   zlin_p12 = get(findobj('tag','Hu22a_9D'),'Userdata');
                   zlin_p13 = get(findobj('tag','Hu23a_9D'),'Userdata');
                   zlin_p14 = get(findobj('tag','Hu24a_9D'),'Userdata');
                   zlin_p15 = get(findobj('tag','Hu25a_9D'),'Userdata');
                   zlin_p16 = get(findobj('tag','Hu26a_9D'),'Userdata');
                   zlin_p17 = get(findobj('tag','Hu27a_9D'),'Userdata');
                   zlin_p18 = get(findobj('tag','Hu28a_9D'),'Userdata');
                   flin_1 =  get(findobj('tag','Hu1b_9D'),'Userdata');
                   flin_2 =  get(findobj('tag','Hu2b_9D'),'Userdata');
                   flin_3 =  get(findobj('tag','Hu3b_9D'),'Userdata');
                   flin_4 =  get(findobj('tag','Hu4b_9D'),'Userdata');
                   flin_5 =  get(findobj('tag','Hu5b_9D'),'Userdata');
                   flin_6 =  get(findobj('tag','Hu6b_9D'),'Userdata');
                   flin_7 =  get(findobj('tag','Hu7b_9D'),'Userdata');
                   flin_8 =  get(findobj('tag','Hu8b_9D'),'Userdata');
                   flin_9 =  get(findobj('tag','Hu9b_9D'),'Userdata');
                   flin_9 =  get(findobj('tag','Hu9b_9D'),'Userdata');
                   zlin_1 = get(findobj('tag','Hu10b_9D'),'Userdata');
                   zlin_2 = get(findobj('tag','Hu11b_9D'),'Userdata');
                   zlin_3 = get(findobj('tag','Hu12b_9D'),'Userdata');
                   zlin_4 = get(findobj('tag','Hu13b_9D'),'Userdata');
                   zlin_5 = get(findobj('tag','Hu14b_9D'),'Userdata');
                   zlin_6 = get(findobj('tag','Hu15b_9D'),'Userdata');
                   zlin_7 = get(findobj('tag','Hu16b_9D'),'Userdata');
                   zlin_8 = get(findobj('tag','Hu17b_9D'),'Userdata');
                   zlin_9 = get(findobj('tag','Hu18b_9D'),'Userdata');
                   zlin_10 = get(findobj('tag','Hu19b_9D'),'Userdata');
                   zlin_11 = get(findobj('tag','Hu20b_9D'),'Userdata');
                   zlin_12 = get(findobj('tag','Hu21b_9D'),'Userdata');
                   zlin_13 = get(findobj('tag','Hu22b_9D'),'Userdata');
                   zlin_14 = get(findobj('tag','Hu23b_9D'),'Userdata');
                   zlin_15 = get(findobj('tag','Hu24b_9D'),'Userdata');
                   zlin_16 = get(findobj('tag','Hu22b_9D'),'Userdata');
                   
                   main_flinp = {flin_p1{1} flin_p2{1} flin_p3{1} flin_p4{1} flin_p5{1} flin_p6{1} flin_p7{1} flin_p8{1} flin_p9{1}};
                   main_zlinp = {zlin_p1{1} zlin_p2{1} zlin_p3{1} zlin_p4{1} zlin_p5{1} zlin_p6{1} zlin_p7{1},...
                                 zlin_p8{1} zlin_p9{1} zlin_p10{1} zlin_p11{1} zlin_p12{1} zlin_p13{1} zlin_p14{1} zlin_p15{1} zlin_p16{1}};
                   main_flin = {flin_1 flin_2 flin_3 flin_4 flin_5 flin_6 flin_7 flin_8 flin_9};
                   main_zlin = {zlin_1 zlin_2 zlin_3 zlin_4 zlin_5 zlin_6 zlin_7,...
                                zlin_8 zlin_9 zlin_10 zlin_11 zlin_12 zlin_13 zlin_14 zlin_15 zlin_16};
                            
               end
                             
               Nlin_x = [];
               Nlin_u = [];
               
               for i = 1:length(main_flinp)
                   Nlin_x = [Nlin_x length(main_flinp{i})];
               end
               
               for i = 1:length(main_zlinp)
                   Nlin_u = [Nlin_u length(main_zlinp{i})];
               end
               
               symVars_nD = get(findobj('tag','Hu_sym'),'Userdata');
                              
               Xbmin = get(findobj('tag','Hu_b1'),'Userdata');
               Xbmax = get(findobj('tag','Hu_b2'),'Userdata');
               
               main_data_3D{1} = main_flin;
               main_data_3D{2} = main_flinp;
               main_data_3D{3} = main_zlin;
               main_data_3D{4} = main_zlinp;
               main_data_3D{5} = Nlin_x;
               main_data_3D{6} = Nlin_u;
               main_data_3D{7} = symVars_nD;
               main_data_3D{8} = Xbmin;
               main_data_3D{9} = Xbmax;
                       
               file_name = get(findobj('Tag','fname'),'String');
               
               hysdel_nd(main_data_3D,file_name);
               ret_value = exist(file_name);
               F3 = findobj('tag','figure3');
               if(isempty(F3))
                   Monitor = get(0,'Screensize');
                   F3 = figure('Units','Pixels','Name','Info','position',...
                       [0.5*Monitor(4) 0.4*Monitor(4) 0.3*Monitor(4) 0.2*Monitor(4)],'Tag','figure3',...
                       'Visible','off','menubar','none','numbertitle','off');
                   set(F3,'visible','on');
               else
                   set(F3,'visible','on');
               end
               if(ret_value == 2)
                   figure(F3)
                   h33 = uicontrol('units','normalized','position',[0.2 0.4 0.6 0.3],'Style','text',...
                       'Backgroundcolor',get(gcf,'Color'),'Foregroundcolor','black',...
                       'String','The export was succesfully done','Fontsize',13);
               end
                              
            end
        case('end')
            close all
    end
    
end
    
